The libPSML library for handling PSML pseudopotential files.

For more details, see

  The psml format and library for norm-conserving pseudopotential
  data curation and interoperability,  
  by Alberto García, Matthieu J. Verstraete, Yann Pouillon, and Javier Junquera  
  Comput. Phys. Comm., 227 (2018) 51–71 (https://doi.org/10.1016/j.cpc.2018.02.011)

also available as a preprint in https://arxiv.org/abs/1707.08938, and also:

     http://esl.cecam.org/PSML

If you have the FORD documentation generator, you can process the
sources in doc/ and have a local copy of the documentation in doc/html.
Otherwise browse the documentation in
[https://siesta-project.github.io/psml-docs/)](https://siesta-project.github.io/psml-docs/)

_NOTE_: Version 2 of the library introduces a minor backward incompatibility: Client codes no longer need to
provide a `psml_die` routine to handle errors. They can define their own custom handlers are install them
in the library through the `ps_set_error_handler` routine. By default, the library provides a simple error
handler.

INSTALLATION
============

## Pre-requisites

* The [libPSML library](http://gitlab.com/siesta-project/libraries/libpsml) itself.

* The [xmlf90 library](http://gitlab.com/siesta-project/libraries/xmlf90)
  Follow the instructions in the package to compile it.

## Installation of libPSML with CMake

```
    cmake -S. -B_build -DCMAKE_INSTALL_PREFIX=/path/to/install/directory
    cmake --build _build
    (push _build; ctest ; popd)  # To run a simple test
    cmake --install _build
```

The source for the xmlf90 dependency will be fetched from
the gitlab repo, configured, and built.
If a compiled xmlf90 is available and installed in a
path pointed to by $XMLF90_ROOT, do instead:

```
    cmake -S. -B_build -DCMAKE_INSTALL_PREFIX=/path/to/install/directory -DCMAKE_PREFIX_PATH=$XMLF90_ROOT
    cmake --build _build
    (push _build; ctest ; popd)  # To run a simple test
    cmake --install _build
```

## Installation of libPSML with autotools

```
    ./configure --prefix=/path/to/installation --with-xmlf90=/path/to/xmlf90
    make
    make check
    make install
```

In case the installed xmlf90 does not follow the simple rule of keeping the .mod files in `include` and
the library files in `lib`, you might need to use the more general expression:

```
../configure --prefix=/path/to/installation \
             --with-xmlf90="$(pkg-config --cflags xmlf90),$(pkg-config --libs xmlf90)"
```

assuming that the PKG_CONFIG_PATH is appropriate for the discovery of xmlf90.

Test programs
-------------

Go into the subdirectory `examples`. In it you can find, among others:

* normalize:  A program to parse a PSML file and dump the resulting `ps`
object.

* show_psml: A program to parse a PSML file and extract
  various kinds of information, with optional evaluation of radial
  functions on a linear grid for later plotting.

Compiling user programs with CMake
----------------------------------

Just use the standard CMake idiom in your CMakeLists.txt file:

```
    add_executable(your_program your_sources)
    find_package(xmlf90 REQUIRED)
    find_package(libpsml REQUIRED)
    target_link_libraries(your_program libpsml::libpsml)
```

The above assumes that the installation directories for xmlf90 and libpsml can
be found by CMake. This can be achieved by adding them to the CMAKE_PREFIX_PATH
CMake or enviroment variable:

```
    cmake -S. -B_your_build -DCMAKE_PREFIX_PATH="$PSML_ROOT;$XMLF90_ROOT" .......
    CMAKE_PREFIX_PATH=$PSML_ROOT:$XMLF90_ROOT cmake -S. -B_your_build .......
```

Compiling user programs with standard makefiles
-----------------------------------------------

Both methods above will create a pkg-config file with information
for client programs. It is suggested that the user create a
separate directory to hold the program files and prepare a Makefile
following this example (FC, FFLAGS, and LDFLAGS need to be set appropriately
for the Fortran compiler used):

```
    #---------------------------------------------------------------
    #
    default: example
    #
    #---------------------------
    XMLF90_ROOT=/path/to/installation
    PSML_ROOT=/path/to/installation
    PKG_CONFIG_PATH=$(PSML_ROOT)/lib/pkgconfig:$(PKG_CONFIG_PATH)
    PKG_CONFIG_PATH=$(XMLF90_ROOT)/lib/pkgconfig:$(PKG_CONFIG_PATH)
    #
    XMLF90_LIBS=$(pkg-config --libs xmlf90)
    XMLF90_INCFLAGS=$(pkg-config --cflags xmlf90)
    PSML_LIBS=$(pkg-config --libs libpsml)
    PSML_INCFLAGS=$(pkg-config --cflags libpsml)
    #
    INCFLAGS+= $(XMLF90_INCFLAGS)
    INCFLAGS+= $(PSML_INCFLAGS)
    LIBS+= $(PSML_LIBS) $(XMLF90_LIBS) 
    #---------------------------
    #
    OBJS= m_handlers.o example.o
     
    example:  $(OBJS)
            $(FC) $(LDFLAGS) -o $@ $(OBJS)  $(LIBS)
    #
    clean: 
            rm -f *.o example *.mod
    #
    # Building rules
    #
    .F.o:
            $(FC) -c $(FFLAGS) $(INCFLAGS)  $(FPPFLAGS) $<
    .f.o:
            $(FC) -c $(FFLAGS) $(INCFLAGS)   $<
    .F90.o:
            $(FC) -c $(FFLAGS) $(INCFLAGS)  $(FPPFLAGS) $<
    .f90.o:
            $(FC) -c $(FFLAGS) $(INCFLAGS)   $<
    #
    #---------------------------------------------------------------
```

Here it is assumed that the user has two source files,
'example.f90' and 'm_handlers.f90'. Simply typing
'make' will compile 'example', pulling in all the needed
modules and library objects.

To begin the schema work I used the schema generator in

   http://xml.mherman.org/index.php/trang/generate

using a few sample psml files from the "examples" directory.

(The 'trang' converter can also be used for this)

Then, I used this link for the "annotations" free-form spec:

  http://www.microhowto.info/howto/match_arbitrary_content_using_relax_ng.html

The RELAX-NG compact-form tutorial contains information on all the features
used.

Example programs and psml files

Example programs:

* normalize:  Parses a PSML file and dumps the resulting `ps` object.

* show_psml: A program to parse a PSML file and extract
  various kinds of information, with optional evaluation of radial
  functions on a linear grid for later plotting.

* getz: A very simple example of extraction of a single piece of data


The psml files in this directory (which are not meant for production
work) have been created in a number of ways:

(ATOM is the pseudopotential generator formerly
 distributed with Siesta.
 See http://siesta-project.org/siesta/Pseudopotentials/)

(ONCVPSP is Don Hamann's pseudopotential generator.
 Versions of ONCVPSP able to produce PSML files are available in
[Gitlab](https://gitlab.com/garalb/oncvpsp-psml/-/releases).)

(PSOP is a Vlocal and KB projector generator that
 uses Siesta's classic approach. It is available in the master
 version of Siesta.)

Ba.sc-ionic.psml :  ATOM (dirac, sr+so semilocal pots)
Fe.spin.psml     :  ATOM (spin-pol, spin ave+diff sl pots)


Ba.sc-ionic-siesta-vnl.psml :
Si.tm2.nrl.vnl.psml:
Fe.spin-siesta-vnl.psml:
                                 ATOM + Siesta's PSOP
                               (addition of projectors and Vlocal)

14_Si.psml       :  ONCVPSP (scalar-relativistic)
                            (with wavefunctions, '-w' option)
14_Si_UPF_r.psml :  ONCVPSP (dirac, with lj-style projs)
                            (with wavefunctions, '-w' option)
52_Te_r.psml     :  ONCVPSP (dirac, with sr+so projs)
80_Hg.psml       :  ONCVPSP (scalar-relativistic)
83_Bi_r.psml     :  ONCVPSP (dirac, with sr+so AND lj projs)
                            (with command-line option '-r both')
			    
80_Hg-siesta-vnl.psml: ONCVPSP + Siesta's PSOP
    (replacement of Vlocal and KB projectors by
     the Siesta flavored ones, built from the
     semilocal potentials in the ONCVPSP file)

You can use the show_psml program to get information:

./show_psml [options] File.psml
./show_psml -h   # for help

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

module m_psml_assoc_list
! First version, with fixed (initial) length,
! and fixed-length fields.
! Alberto Garcia, Sept 2014
!
!-----------------------------------------------------------
type, public :: assoc_list_t
  private
  integer                               :: nslots = 0
  integer                               :: nitems = 0
  character(len=200), allocatable       :: key(:)
  character(len=1000), allocatable      :: value(:)
end type assoc_list_t

public :: assoc_list_init
public :: assoc_list_reset
public :: assoc_list_insert
public :: assoc_list_nitems
public :: assoc_list_get_key
public :: assoc_list_get_value
public :: assoc_list_print

! Now, define and export an EMPTY_ASSOC_LIST
! This feature might be deprecated in future versions. Client programs can
! use 'assoc_list_reset' to generate an empty association list.


! NOTE: A module variable of a type with default initialization must
! have the SAVE attribute by the Fortran 2003 or earlier standards
! The 'protected' attribute forbids changing the value of the variable
! from outside the module.

! NOTE: A 'parameter' could be used instead of a variable, with explicit initialization
! of the form:
! type(assoc_list_t), parameter :: PAR = assoc_list_type_t(0,0,null(),null())
! ... but compiler support for this might be spotty.

type(assoc_list_t), protected, save   :: EMPTY_ASSOC_LIST 


interface assoc_list_get_value
  module procedure assoc_list_get_value_by_index
  module procedure assoc_list_get_value_of_key
end interface

CONTAINS

subroutine assoc_list_init(a,n,stat)
type(assoc_list_t), intent(inout) :: a
integer, intent(in)               :: n
integer, intent(out)              :: stat

  if (allocated(a%key)) then
     deallocate(a%key)
  endif
  if (allocated(a%value)) then
     deallocate(a%value)
  endif
  a%nslots = n
  a%nitems = 0
  allocate(a%key(n),a%value(n),stat=stat)

end subroutine assoc_list_init

subroutine assoc_list_reset(a)
type(assoc_list_t), intent(inout) :: a

  if (allocated(a%key)) then
     deallocate(a%key)
  endif
  if (allocated(a%value)) then
     deallocate(a%value)
  endif
  a%nslots = 0
  a%nitems = 0

end subroutine assoc_list_reset

subroutine assoc_list_insert(a,key,value,stat)
type(assoc_list_t), intent(inout) :: a
character(len=*), intent(in)      :: key, value
integer, intent(out)              :: stat

integer :: i
character(len=1000), allocatable  :: b(:)

if (.not. allocated(a%key)) then
   call assoc_list_init(a,4,stat)
   if (stat /= 0) return
endif

! Replace if key exists already
do i = 1, a%nitems
   if (a%key(i) == key) then
      a%value(i) = value
      stat = 0
      return
   endif
enddo
!
! Add at the end
a%nitems = a%nitems + 1
if (a%nitems > a%nslots)  then
   ! Enlarge a%data by 4 slots
   !
   allocate(b(a%nslots))
   !
   b = a%key
   deallocate(a%key)
   allocate(a%key(a%nslots + 4))
   a%key(1:a%nslots) = b
   !
   b = a%value
   deallocate(a%value)
   allocate(a%value(a%nslots + 4))
   a%value(1:a%nslots) = b
   deallocate(b)
   !
   a%nslots = size(a%key)
endif
i = a%nitems
a%key(i) = key
a%value(i) = value
stat = 0

end subroutine assoc_list_insert

function assoc_list_nitems(a) result(n)
type(assoc_list_t), intent(in)    :: a
integer                           :: n

n = a%nitems
end function assoc_list_nitems

subroutine assoc_list_get_key(a,i,key,stat)
type(assoc_list_t), intent(in)    :: a
integer, intent(in)               :: i
character(len=*), intent(out)     :: key
integer, intent(out)              :: stat

if (i > a%nitems) then
   stat = -1
   return
endif
key = a%key(i)
stat = 0
end subroutine assoc_list_get_key

subroutine assoc_list_get_value_of_key(a,key,value,stat)
type(assoc_list_t), intent(in) :: a
character(len=*), intent(in)      :: key
character(len=*), intent(out)     :: value
integer, intent(out)              :: stat

integer :: i

do i = 1, a%nitems
   if (a%key(i) == key) then
      value = a%value(i) 
      stat = 0
      return
   endif
enddo
stat = -1
end subroutine assoc_list_get_value_of_key

subroutine assoc_list_get_value_by_index(a,i,value,stat)
type(assoc_list_t), intent(in) :: a
integer, intent(in)            :: i
character(len=*), intent(out)     :: value
integer, intent(out)              :: stat

if (i <= a%nitems) then
   value = a%value(i) 
   stat = 0
else
   stat = -1
   value =""
endif

end subroutine assoc_list_get_value_by_index

subroutine assoc_list_print(a)
type(assoc_list_t), intent(in) :: a

integer :: i

if (a%nitems > 0) then
   print "(a)", "---------------------"
   do i = 1, a%nitems
      print "(3x,a,a,a)", trim(a%key(i)), " : ", trim(a%value(i))
   enddo
   print "(a)", "---------------------"
endif
end subroutine assoc_list_print

end module m_psml_assoc_list

module m_getopts
! Assume now a f2003 compliant compiler...
!use f2kcli
public :: getopts

CONTAINS

subroutine getopts(optionstring,name,optarg,optind,exitcode)
!$$$  Subprogram Documentation Block
!
! Subprogram:  Getopts    Process command line arguments for valid options
!   Prgmmr: Iredell       Org: W/NP23        Date: 2000-08-22
!
! Abstract: This subprogram processes command-line arguments for valid options.
!           It is the Fortran equivalent of the built-in shell command getopts.
!           Options on the command line come before the positional arguments.
!           Options are preceded by a - (minus sign) or a + (plus sign).
!           Options are single case-sensitive alphanumeric characters.
!           Options either do or do not have an expected argument.
!           Options without an argument may be immediately succeeded by
!           further options without the accompanying - or + prefix.
!           Options with an argument may be separated from their argument
!           by zero or more blanks.  The argument cannot end with a blank.
!           Options end when not preceded by a - or a + or after -- or ++.
!           This subprogram processes one option per invocation.
!           This subprogram is not thread-safe.
!
! Program History Log:
!   2007-05-05  Alberto Garcia: Use f2k-compliant f2kcli module
!   2000-08-22  Iredell
!
! Usage:    call getopts(optionstring,name,optarg,optind,exitcode)
!
!   Input Argument List:
!     optionstring
!       character string containing a list of all valid options;
!       options succeeded by a : require an argument
!
!   Input and Output Argument List:
!     optind
!       integer index of the next argument to be processed;
!       set to 0 before initial call or to restart processing
!
!   Output Argument List:
!     name
!       character string containing the name of the next option
!       or ? if no option or an unknown option is found
!       or : if an option had a missing required argument;
!       a + is prepended to the value in name if the option begins with a +
!     optarg
!       character string containing the option argument if required
!       or null if not required or not found;
!       optarg contains the option found if name is ? or :.
!     exitcode
!       integer return code (0 if an option was found, 1 if end of options)
!     
! Subprograms Called:
!   command_argument_count
!     Retrieve number of command-line arguments
!   get_command_argument
!     Retrieve a command-line argument
!   index 
!     Retrieve the starting position of a substring within a string
!     
! Remarks:
!   Here is an example of how to use this subprogram.
!     -----------------------------------------------------------
!     implicit none
!     character(len=20) copt,carg,cb,cpos
!     integer ia,ib,iopt,iret,narg,npos,ipos
!
!     ia=0     ! Programmer's flag for option a
!     ib=0     !  "                           b
!
!     iopt=0
!     do
!       call getopts('ab:',copt,carg,iopt,iret)
!       if(iret.ne.0) exit
!       select case(copt)
!       case('a','+a')
!         ia=1
!       case('b','+b')
!         ib=1
!         cb=carg
!       case('?',':')
!         print *,'invalid option ',carg(1:1)
!         stop 1
!       end select
!     enddo
!     if(ia.eq.1) print *,'option a selected'
!     if(ib.eq.1) print *,'option b selected; argument=',cb
!
!     Now process positional parameters
!     narg=command_argument_count()
!     npos=narg-iopt+1
!     do ipos=1,npos
!       call get_command_argument(number=ipos+iopt-1,value=cpos)
!       print *,'positional argument ',ipos,' is ',cpos
!     enddo
!     end
!     -----------------------------------------------------------
!
! Attributes:
!   Language: Fortran 90
!
!$$$
  implicit none

!  Passed data
  character(len=*),intent(in)      :: optionstring
  character(len=*),intent(out)     :: name
  character(len=*),intent(out)     :: optarg
  integer,         intent(inout)   :: optind
  integer,         intent(out)     :: exitcode

!  Saved data
  character(len=256), save  :: carg
  character(len=1) ,  save  :: cone
  integer,save              :: narg,larg,lcur

!  Local data
  character(len=1) ::  copt
  integer          ::  lname,lopt

! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
!  Initially set saved data.
  if(optind.le.0) then
    optind=0
    narg=command_argument_count()
    carg=''
    cone=''
    larg=0
    lcur=1
  endif
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
!  Retrieve next command-line argument if necessary;
!  exit if at end of options
  if(lcur.gt.larg) then
    optind=optind+1
    if(optind.gt.narg) then
      name='?'
      optarg=''
      exitcode=1
      RETURN
    endif
    call get_command_argument(number=optind,value=carg)
    cone=carg(1:1)
    larg=len_trim(carg)
    lcur=2
    if(larg.eq.1.or.(cone.ne.'-'.and.cone.ne.'+')) then
      name='?'
      optarg=''
      exitcode=1
      RETURN
    elseif(larg.eq.2.and.carg(2:2).eq.cone) then
      optind=optind+1
      name='?'
      optarg=''
      exitcode=1
      RETURN
    endif
  endif
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
!  Find next option in the list; exit if option is unknown
  exitcode=0
  copt=carg(lcur:lcur)
  lcur=lcur+1
  lopt=index(optionstring,copt)
  if(lopt.eq.0) then
    name='?'
    optarg=copt
    RETURN
  endif
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
!  Option found; retrieve its argument if requested
    if(cone.eq.'-') then
      name=""
      lname=1
    else
      name="+"
      lname=2
    endif
  name(lname:lname)=copt
  optarg=''
  if(lopt.lt.len(optionstring)) then
     if (optionstring(lopt+1:lopt+1).eq.':') then
        if(lcur.gt.larg) then
           optind=optind+1
           if(optind.gt.narg) then
              name=':'
              optarg=copt
              RETURN
           endif
           call get_command_argument(number=optind,value=carg)
           larg=len_trim(carg)
           lcur=1
        endif
        optarg=carg(lcur:larg)
        lcur=larg+1
     endif
  endif
end subroutine
end module m_getopts

program normalize

  !
  ! Parses a PSML file and dumps the contents of the resulting
  ! ps_t object in a PSML 1.1 file.
  !
  ! If it detects a 1.0 PSML file, it inserts
  ! a new provenance element, but keeps the original uuid.
  !
  ! It will also add 'record-number' attributes to provenance elements.
  !
use m_psml
use m_getopts

integer, parameter :: dp = selected_real_kind(10,100)

type(ps_t)   :: ps

      character(len=200) :: filename, output_filename
      logical            :: debug
      character(len=200) :: opt_arg, mflnm, ref_line
      character(len=10)  :: opt_name 
      integer :: nargs, iostat, n_opts, nlabels
      
      integer :: i, j, l, n, num, nfun, set, seq
      character(len=20) :: date, version
!
!     Process options
!
      n_opts = 0
      debug = .false.
      output_filename = "PSML_DUMP"
      do
         call getopts('do:',opt_name,opt_arg,n_opts,iostat)
         if (iostat /= 0) exit
         select case(opt_name)
           case ('d')
              debug = .true.
           case ('o')
              read(opt_arg,*) output_filename
           case ('?',':')
             write(0,*) "Invalid option: ", opt_arg(1:1)
             write(0,*) "Usage: test_dump [-o output_file] PSML_FILE"
             STOP
          end select
       enddo

       nargs = command_argument_count()
       nlabels = nargs - n_opts + 1
       if (nlabels /= 1)  then
             write(0,*) "Invalid option: ", opt_arg(1:1)
             write(0,*) "Usage: test_dump [-o output_file] PSML_FILE"
             STOP
       endif

       call get_command_argument(n_opts,value=filename,status=iostat)
       if (iostat /= 0) then
          STOP "Cannot get filename"
       endif
!
if (debug) print "(a)", "Processing: " // trim(filename)
call date_and_time(date)
call psml_reader(filename,ps,debug=debug,stat=iostat)
if (iostat == -1) then
   write(0,*) "Cannot open PSML file " // trim(filename)
   STOP
endif

call ps_RootAttributes_Get(ps,version=version)

call ps_RootAttributes_Set(ps,version="1.1",&
     namespace="http://esl.cecam.org/PSML/ns/1.1")

if (trim(version) == "1.0") then
   if (nitems_annotation(ps%annotation)>0) then
      call ps_Provenance_Add(ps,creator="1.0-to-1.1-conversion",&
           date=trim(date),  annotation=ps%annotation)
   else
      call ps_Provenance_Add(ps,creator="1.0-to-1.1-conversion",&
           date=trim(date), annotation=EMPTY_ANNOTATION)
   endif
endif

call ps_DumpToPSMLFile(ps,trim(output_filename))
write(0,"(a)") "Written PSML 1.1 file: " // trim(output_filename)
end program normalize

!> Functions to edit the PSML ps_t structure
!!
!> @author Alberto Garcia
!
#if defined HAVE_CONFIG_H
#include "config.h"
#endif

module m_psml_ps_edit

use m_psml_core   ! For basic structures
use m_psml_external_interfaces, only: die => psml_die

use m_psml_assoc_list, ps_annotation_t => assoc_list_t

implicit none

public :: ps_RootAttributes_Set
public :: ps_SetUUID
public :: ps_SetPSMLVersion
public :: ps_AddProvenanceRecord
public :: ps_Delete_LocalPotential
public :: ps_Delete_NonLocalProjectors

! Aliases
interface ps_Provenance_Add
   module procedure ps_AddProvenanceRecord
end interface ps_Provenance_Add
public :: ps_Provenance_Add

interface ps_NonLocalProjectors_Delete
   module procedure ps_Delete_NonLocalProjectors
end interface ps_NonLocalProjectors_Delete
public :: ps_NonLocalProjectors_Delete

interface ps_LocalPotential_Delete
   module procedure ps_Delete_LocalPotential
end interface ps_LocalPotential_Delete
public :: ps_LocalPotential_Delete

!public :: ps_AddSLBlock
private

CONTAINS !===============================================
  subroutine ps_RootAttributes_Set(ps,version,uuid,namespace) 
    type(ps_t), intent(inout) :: ps
    character(len=*), intent(in), optional :: version
    character(len=*), intent(in), optional :: uuid
    character(len=*), intent(in), optional :: namespace

    if (present(version)) then
       ps%version = version
    endif

    if (present(uuid)) then
       ps%uuid = uuid
    endif
    
    if (present(namespace)) then
       ps%namespace = namespace
    endif
    
  end  subroutine ps_RootAttributes_Set
  
  subroutine ps_SetPSMLVersion(ps,version) 
    type(ps_t), intent(inout) :: ps
    character(len=*), intent(in) :: version
    ps%version = version
  end subroutine ps_SetPSMLVersion
  
  subroutine ps_SetUUID(ps,id) 
    type(ps_t), intent(inout) :: ps
    character(len=36), intent(in) :: id
    ps%uuid = id
  end subroutine ps_SetUUID
  
  subroutine ps_AddProvenanceRecord(ps,creator,date,annotation)

    type(ps_t), intent(inout) :: ps
    character(len=*), intent(in) :: creator
    character(len=*), intent(in) :: date
    type(ps_annotation_t), intent(in), target :: annotation

type(provenance_t), pointer :: p
type(provenance_t), pointer :: q
integer :: depth

allocate(p)
!
! Find the depth of the provenance stack
!
depth = 0
q => ps%provenance
do while (associated(q))
   depth = depth + 1
   q => q%next
enddo

q => ps%provenance
if (associated(q)) then
   p%next => q
   q%prev => p
endif
ps%provenance => p

p%record_number = depth + 1
p%creator = trim(creator)
p%date = trim(date)
p%annotation= annotation

end subroutine ps_AddProvenanceRecord
!
subroutine ps_Delete_NonlocalProjectors(ps)
type(ps_t), intent(inout) :: ps

call destroy_nonlocal(ps%nonlocal)
end subroutine ps_Delete_NonlocalProjectors

subroutine ps_Delete_LocalPotential(ps)
type(ps_t), intent(inout) :: ps

call destroy_local(ps%local)
end subroutine ps_Delete_LocalPotential

end module m_psml_ps_edit
   

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

module m_psml_reader

  public :: psml_reader

  CONTAINS

  subroutine psml_reader(fname,ps,debug,stat)

  use m_psml_core,            only: ps_t, ps_destroy
  use m_psml_tables,          only: ps_GenerateTables

  use m_psml_parsing_helpers, only: begin_element, end_element, pcdata_chunk
  use m_psml_parsing_helpers, only: cdata_section_chunk
  use m_psml_parsing_helpers, only: pseudo, debug_parsing

  use m_psml_external_interfaces,    only: die => psml_die
  use m_psml_interp,               only: set_default_interpolator

  use xmlf90_sax,        only: xml_t, open_xmlfile, xml_parse, close_xmlfile
#ifdef XMLF90_PARSE_HAS_STAT
  use xmlf90_sax,        only: xml_error_report
  use, intrinsic :: iso_fortran_env, only: error_unit
#endif

  implicit none 

  character(len=*), intent(in)        :: fname
  type(ps_t), intent(inout), target   :: ps 
  logical, intent(in), optional       :: debug
  integer, intent(out), optional      :: stat

  type(xml_t)                     :: fxml
  integer :: iostat

  ! Clean the object's internal data
  ! Note that the inout intent allow us
  ! to do this, and avoid having ps being
  ! reset by the compiler

  call ps_destroy(ps)

  ! Associate module pointer, so that the parsed data
  ! is written to ps
  pseudo => ps
  if (present(debug)) then
     debug_parsing = debug
  else
     debug_parsing = .false.
  endif

 ! Allocate internal structures here...
 
 call open_xmlfile(fname,fxml,iostat)
 if (iostat /=0) then
    if (present(stat)) then
       stat = -1
       RETURN
    else
       call die("Cannot open PSML file: " // trim(fname))
    endif
 endif
 call xml_parse(fxml, begin_element,end_element,pcdata_chunk, &
      cdata_section_handler=cdata_section_chunk,verbose=.false. &
#ifdef XMLF90_PARSE_HAS_STAT
      ,stat=iostat)
 if (iostat /=0) then
    if (present(stat)) then
       stat = -2
       call xml_error_report(fxml,error_unit)
       RETURN
    else
       call die("Parsing error (details in stderr) in PSML file: " // trim(fname))
    endif
 endif

#else
      )
#endif
 call close_xmlfile(fxml)

 ! Clean up association of module pointer
 pseudo => null()

 call ps_GenerateTables(ps)

 !
 ! Set default interpolator
 !
 call set_default_interpolator()

 if (present(stat)) then
    ! Set code to success if we made it here
    ! without returning
    stat = 0
 endif

end subroutine psml_reader

end module m_psml_reader

program getz

!
! Example of PSML data extraction
! 
! + Tests of possible use of custom error handler, depending on the PSML library version
!
use m_psml
use m_getopts

#ifdef PSML_HAS_PP
external :: custom_psml_die
#endif

! Example of use of the provided kind specification
real(kind=ps_real_kind) :: atnum

character(len=1), dimension(0:4) :: sym = (/ "s", "p", "d", "f", "g" /)

type(ps_t)   :: ps

      character(len=200) :: filename
      logical            :: debug
      character(len=200) :: opt_arg, mflnm, ref_line
      character(len=10)  :: opt_name 
      integer :: nargs, iostat, n_opts, nlabels
      
      integer :: i, j, l, n, num, nfun, set, seq
      integer :: version_number

      version_number = ps_GetLibPSMLVersion()
      print "(a,i5)", "libpsml Version: ", version_number
!
!     Process options
!
      n_opts = 0
      debug = .false.

      do
         call getopts('d',opt_name,opt_arg,n_opts,iostat)
         if (iostat /= 0) exit
         select case(opt_name)
           case ('d')
              debug = .true.
           case ('?',':')
             write(0,*) "Invalid option: ", opt_arg(1:1)
             write(0,*) "Usage: getz [-d]  FILE"
             write(0,*) " -d   : debug"
             STOP
          end select
       enddo

       nargs = command_argument_count()
       nlabels = nargs - n_opts + 1
       if (nlabels /= 1)  then
          write(0,*) "Usage: getz FILE"
          write(0,*) " -d for debug output"
          STOP
       endif

       call get_command_argument(n_opts,value=filename,status=iostat)
       if (iostat /= 0) then
          STOP "Cannot get filename"
       endif
       !
#ifdef PSML_HAS_PP       
       call ps_set_error_handler(custom_psml_die)
#endif

       if (debug) print "(a)", "Processing: " // trim(filename)

#ifdef PSML_READER_HAS_STAT
! Released versions with procedure pointers also have the 'stat' optional argument
call psml_reader(filename,ps,debug=debug,stat=iostat)
if (iostat /=0) then
   print *, "PSML reader error. Iostat: ", iostat
   stop 
endif
#else
call psml_reader(filename,ps,debug=debug)
#endif


call ps_PseudoAtomSpec_Get(ps,atomic_number=atnum)
print *,  int(atnum)

end program getz

!> Functions to handle PSML pseudopotential format structures
!!
!! (Dumpers)
!> @author Alberto Garcia
!
#if defined HAVE_CONFIG_H
#include "config.h"
#endif

module m_psml_dump

use m_psml_core   ! For basic structures

use m_psml_assoc_list, only: ps_annotation_t => assoc_list_t
!use m_psml_assoc_list, only: EMPTY_ANNOTATION => EMPTY_ASSOC_LIST

use m_psml_class_grid, Grid_t => Grid
use m_psml_external_interfaces, only: die => psml_die

implicit none

integer, parameter    :: dp = selected_real_kind(14)
logical               :: global_debug = .false.
character(len=1), dimension(0:4) :: sym = (/ "s", "p", "d", "f", "g" /)

public :: ps_DumpToPSMLFile

private

CONTAINS !===============================================

subroutine ps_DumpToPSMLFile(ps,fname,indent)

  use xmlf90_wxml

  type(ps_t), intent(in) :: ps
  character(len=*), intent(in) :: fname
  logical, intent(in), optional :: indent

  type(xmlf_t)  :: xf

  call xml_OpenFile(trim(fname),xf, indent)

  call xml_AddXMLDeclaration(xf,"UTF-8")

  call xml_NewElement(xf,"psml")
  call my_add_attribute(xf,"version",trim(ps%version))
  call my_add_attribute(xf,"energy_unit",trim(ps%energy_unit))
  call my_add_attribute(xf,"length_unit",trim(ps%length_unit))
  call my_add_attribute(xf,"uuid",ps%uuid)
      call my_add_attribute(xf,"xmlns",ps%namespace)

! No top-level annotations in V1.1      
!      call dump_annotation(xf,ps%annotation)

  call dump_provenance(xf,ps%provenance)

      call dump_pseudo_atom_spec(xf,ps)

  if (initialized(ps%global_grid)) then
     call dump_grid(xf,ps%global_grid)
  endif

  call dump_valence_charge(xf,ps%valence_charge,ps%global_grid)
  if (trim(ps%header%core_corrections) == "yes") then
     call dump_core_charge(xf,ps%core_charge,ps%global_grid)
  endif

  if (trim(ps%header%meta_gga) == "yes") then
     call dump_valence_kinetic_energy_density(xf,ps%valence_kinetic_energy_density,ps%global_grid)
     if (trim(ps%header%core_corrections) == "yes") then
        call dump_core_kinetic_energy_density(xf,ps%core_kinetic_energy_density,ps%global_grid)
     endif
  endif

  call dump_semilocal_potentials(xf,ps)
  call dump_local_potential(xf,ps)
  call dump_nonlocal_projectors(xf,ps)
  call dump_pseudo_wavefunctions(xf,ps)

      
  call xml_EndElement(xf,"psml")
  call xml_Close(xf)

end subroutine ps_DumpToPSMLFile

subroutine dump_provenance(xf,p)

  use xmlf90_wxml
  
  type(xmlf_t), intent(inout) :: xf
  type(provenance_t), pointer :: p

  integer :: depth
  type(provenance_t), pointer :: q

  depth = 0
  q => p
  do while (associated(q))
     depth = depth + 1
     q => q%next
  enddo
  
  do while (associated(p))
     call xml_NewElement(xf,"provenance")
     call my_add_attribute(xf,"record-number",str(p%record_number))
     call my_add_attribute(xf,"creator",trim(p%creator))
     call my_add_attribute(xf,"date",trim(p%date))
     call dump_annotation(xf,p%annotation)
     if (len(p%input_file%buffer) > 0) then
        call xml_NewElement(xf,"input-file")
        call my_add_attribute(xf,"name",trim(p%input_file%name))
        call xml_AddCDataSection(xf,p%input_file%buffer, &
                                 line_feed=.true.)
        call xml_EndElement(xf,"input-file")
     endif
     call xml_EndElement(xf,"provenance")
     p => p%next
  end do

end subroutine dump_provenance


subroutine dump_xc_info(xf,p)

  use xmlf90_wxml

  type(xmlf_t), intent(inout) :: xf
  type(xc_t), intent(in) :: p

  integer :: i
  
  call xml_NewElement(xf,"exchange-correlation")
  call dump_annotation(xf,p%annotation)
  call xml_NewElement(xf,"libxc-info")
  call my_add_attribute(xf,"number-of-functionals",str(p%n_functs_libxc))
  do i = 1, p%n_functs_libxc
     call xml_NewElement(xf,"functional")
     call my_add_attribute(xf,"name",trim(p%libxc_name(i)))
     if (trim(p%libxc_type(i)) /= "UNKNOWN") then
        call my_add_attribute(xf,"type",trim(p%libxc_type(i)))
     endif
     call my_add_attribute(xf,"id",str(p%libxc_id(i)))
     if (p%libxc_weight(i) /= 1.0_dp) then
        call my_add_attribute(xf,"weight",str(p%libxc_weight(i)))
     endif
     call xml_EndElement(xf,"functional")
  enddo
  call xml_EndElement(xf,"libxc-info")
  call xml_EndElement(xf,"exchange-correlation")
     
end subroutine dump_xc_info

subroutine dump_config_val(xf,p)

  use xmlf90_wxml

  type(xmlf_t), intent(inout) :: xf
  type(config_val_t), intent(in) :: p

  integer :: i

  call xml_NewElement(xf,"valence-configuration")
  call my_add_attribute(xf,"total-valence-charge",str(p%total_charge))
  call dump_annotation(xf,p%annotation)
  do i = 1, p%nshells
     call xml_NewElement(xf,"shell")
     call my_add_attribute(xf,"n",str(p%n(i)))
     call my_add_attribute(xf,"l",p%l(i))
     call my_add_attribute(xf,"occupation",str(p%occ(i)))
     if ((p%occ_up(i) + p%occ_down(i)) /= 0.0_dp) then
        call my_add_attribute(xf,"occupation-down",str(p%occ_down(i)))
        call my_add_attribute(xf,"occupation-up",str(p%occ_up(i)))
     endif
     call xml_EndElement(xf,"shell")
  enddo
  call xml_EndElement(xf,"valence-configuration")
     
end subroutine dump_config_val


subroutine dump_pseudo_atom_spec(xf,ps)

  use xmlf90_wxml

  type(xmlf_t), intent(inout) :: xf
  type(ps_t), intent(in), target :: ps

  type(header_t), pointer :: h

  h => ps%header
  call xml_NewElement(xf,"pseudo-atom-spec")
  call my_add_attribute(xf,"atomic-label",trim(h%atomic_label))
  call my_add_attribute(xf,"atomic-number",str(h%z))
  call my_add_attribute(xf,"z-pseudo",str(h%zpseudo))
  call my_add_attribute(xf,"flavor",trim(h%flavor))
  call my_add_attribute(xf,"relativity",trim(h%relativity))
  if (h%polarized) then
     call my_add_attribute(xf,"spin-dft","yes")
  else
     call my_add_attribute(xf,"spin-dft","no")
  endif
  call my_add_attribute(xf,"core-corrections",trim(h%core_corrections))
  call my_add_attribute(xf,"meta-gga",trim(h%meta_gga))

  call dump_annotation(xf,h%annotation)

  call dump_xc_info(xf,ps%xc_info)
  call dump_config_val(xf,ps%config_val)

  call xml_EndElement(xf,"pseudo-atom-spec")

end subroutine dump_pseudo_atom_spec

subroutine dump_radfunc(xf,rf,parent_grid)

  use xmlf90_wxml

  type(xmlf_t), intent(inout) :: xf
  type(radfunc_t), intent(in) :: rf
  type(Grid_t)                  :: parent_grid ! Only one level for now

  if (.not. initialized(rf%grid)) return

  call xml_NewElement(xf,"radfunc")
  if (same(rf%grid,parent_grid)) then
     ! do nothing
  else
     call dump_grid(xf,rf%grid)
  endif
  call xml_NewElement(xf,"data")
  ! Cover the case in which the data uses only an
  ! initial section of the grid
  if (size(rf%data) < sizeGrid(rf%grid)) then
     call my_add_attribute(xf,"npts",str(size(rf%data)))
  endif
  call xml_AddArray(xf,rf%data(:))
  call xml_EndElement(xf,"data")
  call xml_EndElement(xf,"radfunc")
end subroutine dump_radfunc

subroutine dump_valence_charge(xf,val,parent_grid)

  use xmlf90_wxml

  type(xmlf_t), intent(inout) :: xf
  type(valence_charge_t), intent(in) :: val
  type(Grid_t)           :: parent_grid

  call xml_NewElement(xf,"valence-charge")
  call my_add_attribute(xf,"total-charge",str(val%total_charge))
  call dump_annotation(xf,val%annotation)
  call dump_radfunc(xf,val%rho_val,parent_grid)
  call xml_EndElement(xf,"valence-charge")
end subroutine dump_valence_charge

subroutine dump_core_charge(xf,core,parent_grid)

  use xmlf90_wxml

  type(xmlf_t), intent(inout) :: xf
  type(core_charge_t), intent(in) :: core
  type(Grid_t)                 :: parent_grid

  call xml_NewElement(xf,"pseudocore-charge")
  if (core%rcore >= 0.0_dp) then
     call my_add_attribute(xf,"matching-radius",str(core%rcore))
  endif
  if (core%n_cont_derivs >= 0 ) then
     call my_add_attribute(xf,"number-of-continuous-derivatives",str(core%n_cont_derivs))
  endif
  call dump_annotation(xf,core%annotation)
  call dump_radfunc(xf,core%rho_core,parent_grid)
  call xml_EndElement(xf,"pseudocore-charge")
end subroutine dump_core_charge
!

subroutine dump_valence_kinetic_energy_density(xf,val,parent_grid)

  use xmlf90_wxml

  type(xmlf_t), intent(inout) :: xf
  type(valence_kinetic_energy_density_t), intent(in) :: val
  type(Grid_t)           :: parent_grid

  call xml_NewElement(xf,"valence-kinetic-energy-density")
  call my_add_attribute(xf,"is-unscreening-tau",trim(val%is_unscreening_tau))
  call dump_annotation(xf,val%annotation)
  call dump_radfunc(xf,val%kin_edens_val,parent_grid)
  call xml_EndElement(xf,"valence-kinetic-energy-density")
end subroutine dump_valence_kinetic_energy_density

subroutine dump_core_kinetic_energy_density(xf,core,parent_grid)

  use xmlf90_wxml

  type(xmlf_t), intent(inout) :: xf
  type(core_kinetic_energy_density_t), intent(in) :: core
  type(Grid_t)                 :: parent_grid

  call xml_NewElement(xf,"pseudocore-kinetic-energy-density")
  if (core%rcore >= 0.0_dp) then
     call my_add_attribute(xf,"matching-radius",str(core%rcore))
  endif
  if (core%n_cont_derivs >= 0 ) then
     call my_add_attribute(xf,"number-of-continuous-derivatives",str(core%n_cont_derivs))
  endif
  call dump_annotation(xf,core%annotation)
  call dump_radfunc(xf,core%kin_edens_core,parent_grid)
  call xml_EndElement(xf,"pseudocore-charge")
end subroutine dump_core_kinetic_energy_density
!

subroutine dump_semilocal_potentials(xf,ps)

  use xmlf90_wxml

  type(xmlf_t), intent(inout) :: xf
  type(ps_t), intent(in), target :: ps

  type(semilocal_t), pointer :: slp
  type(slps_t), pointer :: slvp
  type(Grid_t)            :: parent_grid
  integer :: i, j, set

  slp => ps%semilocal
  do while (associated(slp))
     set = slp%set
     call xml_NewElement(xf,"semilocal-potentials")
     if (set /= SET_NULL) then
        ! Group set was specified
        call my_add_attribute(xf,"set",str_of_set(set))
     else
        call die("Set not specified in SemiLocalPotentials block")
     endif
     call dump_annotation(xf,slp%annotation)
     if (initialized(slp%grid)) then
        parent_grid = slp%grid
        call dump_grid(xf,slp%grid)
     else
        parent_grid = ps%global_grid
     endif
     slvp => slp%pot
     do while (associated(slvp))
        call xml_NewElement(xf,"slps")
        call my_add_attribute(xf,"n",str(slvp%n))
        call my_add_attribute(xf,"l",slvp%l)
        call my_add_attribute(xf,"rc",str(slvp%rc))
        ! If eref has a physical value, output it
        if (slvp%eref < 0.1*huge(1.0_dp)) then
           call my_add_attribute(xf,"eref",str(slvp%eref))
        endif
        call my_add_attribute(xf,"flavor",slvp%flavor)
        if (set == SET_LJ) then
           call my_add_attribute(xf,"j",str(slvp%j,format="(f3.1)"))
        endif
        call dump_radfunc(xf,slvp%V,parent_grid)
        call xml_EndElement(xf,"slps")
        slvp => slvp%next
     enddo
     call xml_EndElement(xf,"semilocal-potentials")
     slp => slp%next
  enddo
  call delete(parent_grid)
end subroutine dump_semilocal_potentials

subroutine dump_local_potential(xf,ps)

  use xmlf90_wxml

  type(xmlf_t), intent(inout) :: xf
  type(ps_t), intent(in), target :: ps

  type(local_t), pointer :: lop
  type(Grid_t)           :: parent_grid

  logical :: has_vlocal, has_local_charge

  lop => ps%local
  
  has_vlocal = associated(lop%Vlocal%data)
  has_local_charge = associated(lop%Chlocal%data)

  if (has_vlocal) then
     call xml_NewElement(xf,"local-potential")
     call my_add_attribute(xf,"type",lop%vlocal_type)
     call dump_annotation(xf,lop%annotation)
     ! No processing of grids here
     if (initialized(lop%grid)) then
        parent_grid = lop%grid
        call dump_grid(xf,lop%grid)
     else
        parent_grid = ps%global_grid
     endif
     call dump_radfunc(xf,lop%Vlocal,parent_grid)
     if (has_local_charge) then
        call xml_NewElement(xf,"local-charge")
        call dump_radfunc(xf,lop%chlocal,parent_grid)
        call xml_EndElement(xf,"local-charge")
     endif
     call xml_EndElement(xf,"local-potential")
     call delete(parent_grid)
  endif
end subroutine dump_local_potential

!----------------------------------------------------------
subroutine dump_nonlocal_projectors(xf,ps)

  use xmlf90_wxml

  type(xmlf_t), intent(inout) :: xf
  type(ps_t), intent(in), target :: ps

  type(nonlocal_t), pointer :: nlp
  type(nlpj_t), pointer :: nlpp
  type(Grid_t)            :: parent_grid
  integer :: set

  nlp => ps%nonlocal
  do while (associated(nlp))
     set = nlp%set
     call xml_NewElement(xf,"nonlocal-projectors")
     if (set /= SET_NULL) then
        ! Group set was specified
        call my_add_attribute(xf,"set",str_of_set(set))
     else
        call die("Set not specified in NonLocalProjectors block")
     endif
     call dump_annotation(xf,nlp%annotation)
     if (initialized(nlp%grid)) then
        parent_grid = nlp%grid
        call dump_grid(xf,nlp%grid)
     else
        parent_grid = ps%global_grid
     endif
     nlpp => nlp%proj
     do while (associated(nlpp))
        call xml_NewElement(xf,"proj")
        call my_add_attribute(xf,"l",nlpp%l)
        if (set == SET_LJ) then
           call my_add_attribute(xf,"j",str(nlpp%j,format="(f3.1)"))
        endif
        call my_add_attribute(xf,"seq",str(nlpp%seq))
        call my_add_attribute(xf,"ekb",str(nlpp%ekb))
        ! If eref has a physical value, output it
        if (nlpp%eref < 0.1*huge(1.0_dp)) then
           call my_add_attribute(xf,"eref",str(nlpp%eref))
        endif
        call my_add_attribute(xf,"type",nlpp%type)
        call dump_radfunc(xf,nlpp%proj,parent_grid)
        call xml_EndElement(xf,"proj")
        nlpp => nlpp%next
     enddo
     call xml_EndElement(xf,"nonlocal-projectors")
     nlp => nlp%next
  enddo
  call delete(parent_grid)
end subroutine dump_nonlocal_projectors
!----------------------------------------------------------
subroutine dump_pseudo_wavefunctions(xf,ps)

  use xmlf90_wxml

  type(xmlf_t), intent(inout) :: xf
  type(ps_t), intent(in), target :: ps

  type(wfns_t), pointer :: wfp
  type(wf_t), pointer   :: wfpp
  type(Grid_t)             :: parent_grid

  integer :: set
  
  wfp => ps%wavefunctions
  do while (associated(wfp))
     set = wfp%set
     call xml_NewElement(xf,"pseudo-wave-functions")
     if (set /= SET_NULL) then
        ! Group set was specified
        call my_add_attribute(xf,"set",str_of_set(set))
     else
        call die("Set not specified in Wavefunctions block")
     endif
!     if (wfp%type /= "") then
!        call my_add_attribute(xf,"type",wfp%type)
!     endif
     call dump_annotation(xf,wfp%annotation)
     if (initialized(wfp%grid)) then
        parent_grid = wfp%grid
        call dump_grid(xf,wfp%grid)
     else
        parent_grid = ps%global_grid
     endif
     wfpp => wfp%wf
     do while (associated(wfpp))
        call xml_NewElement(xf,"pswf")
        call my_add_attribute(xf,"n",str(wfpp%n))
        call my_add_attribute(xf,"l",wfpp%l)
        if (set == SET_LJ) then
           call my_add_attribute(xf,"j",str(wfpp%j,format="(f3.1)"))
        endif
        ! If energy_level has a physical value, output it
        if (wfpp%energy_level < 0.1*huge(1.0_dp)) then
           call my_add_attribute(xf,"energy_level",str(wfpp%energy_level))
        endif

        call dump_radfunc(xf,wfpp%Phi,parent_grid)
        call xml_EndElement(xf,"pswf")
        wfpp => wfpp%next
     enddo
     call xml_EndElement(xf,"pseudo-wave-functions")
     wfp => wfp%next
  enddo
  call delete(parent_grid)

end subroutine dump_pseudo_wavefunctions

subroutine dump_grid(xf,agrid)

  use xmlf90_wxml

  type(xmlf_t), intent(inout) :: xf
  type(Grid_t), intent(in) :: agrid

  if (.not. initialized(agrid)) return
  
  call xml_NewElement(xf,"grid")
  call my_add_attribute(xf,"npts",str(sizeGrid(agrid)))
  call dump_annotation(xf,annotationGrid(agrid))
  call xml_NewElement(xf,"grid-data")
  call xml_AddArray(xf,valGrid(agrid))
  call xml_EndElement(xf,"grid-data")
  call xml_EndElement(xf,"grid")
end subroutine dump_grid

subroutine dump_annotation(xf,annotation)

  use xmlf90_wxml

  use m_psml_assoc_list, only: ps_annotation_t => assoc_list_t
  use m_psml_assoc_list, only: nitems_annotation => assoc_list_nitems
  use m_psml_assoc_list, only: get_annotation_key => assoc_list_get_key
  use m_psml_assoc_list, only: get_annotation_value => assoc_list_get_value

  type(xmlf_t), intent(inout) :: xf
  type(ps_annotation_t), intent(in)  :: annotation

integer :: n_items, i, stat
character(len=256) :: key, val

n_items = nitems_annotation(annotation)
if (n_items > 0) then

   call xml_NewElement(xf,"annotation")
   do i = 1, n_items
      call get_annotation_key(annotation,i,key,stat)
      call get_annotation_value(annotation,i,val,stat)
      call my_add_attribute(xf,trim(key),trim(val))
   enddo
   call xml_EndElement(xf,"annotation")
endif
end subroutine dump_annotation

subroutine my_add_attribute(xf,name,value)

  use xmlf90_wxml

  type(xmlf_t), intent(inout)   :: xf
  character(len=*), intent(in)  :: name
  character(len=*), intent(in)  :: value

  call xml_AddAttribute(xf,name,trim(value))
end subroutine my_add_attribute

end module m_psml_dump

!+ libPSML API implementation
#if defined HAVE_CONFIG_H
#include "config.h"
#endif

module m_psml_api
!+ graph: false
!+ Procedures to handle the PSML pseudopotential format.

use m_psml_core, ps_radfunc_t => radfunc_t

use m_psml_assoc_list, only: ps_annotation_t => assoc_list_t
use m_psml_assoc_list, only: EMPTY_ANNOTATION => EMPTY_ASSOC_LIST

use m_psml_external_interfaces, only: die => psml_die
use m_psml_class_Grid

implicit none

integer, parameter    :: dp = selected_real_kind(14)
logical               :: global_debug = .false.
logical               :: global_use_effective_range = .true.
character(len=1), dimension(0:4) :: sym = (/ "s", "p", "d", "f", "g" /)

! Library operation routines
public :: ps_GetLibPSMLVersion
public :: ps_SetEvaluatorOptions
!
! Accessor list
!
public :: ps_RootAttributes_Get
public :: ps_Provenance_Depth
public :: ps_Provenance_Get

public :: ps_PseudoAtomSpec_Get
public :: ps_ExchangeCorrelation_Get
public :: ps_LibxcFunctional_Get

public :: ps_ValenceConfiguration_Get
public :: ps_ValenceShell_Get
!
public :: ps_ValenceCharge_Value
public :: ps_ValenceCharge_Get
!
public :: ps_CoreCharge_Value
public :: ps_CoreCharge_Get
!
! MGGA
!
public :: ps_ValenceKineticDensity_Value
public :: ps_ValenceKineticDensity_Get
!
public :: ps_CoreKineticDensity_Value
public :: ps_CoreKineticDensity_Get
!
! Semilocal potentials
!
public :: ps_HasSemilocalPotentials
public :: ps_SemilocalPotentials_Filter
public :: ps_Potential_Get
public :: ps_Potential_Value

! Pseudo Operator
!
public :: ps_HasPsOperator
!
! Vlocal 
!
public :: ps_HasLocalPotential
public :: ps_LocalPotential_Get
public :: ps_LocalPotential_Value
!
! Projectors
!
public :: ps_HasProjectors
public :: ps_NonlocalProjectors_Filter
public :: ps_Projector_Get
public :: ps_Projector_Value
!
! Pseudo-wave-functions
!
public :: ps_PseudoWavefunctions_Filter
public :: ps_PseudoWf_Get
public :: ps_PseudoWf_Value

! Grid Annotations
public :: ps_GridAnnotation 
!
! Exported low-level routines
!
public :: ps_GetValue
public :: ps_GetRawData
!
! Aliases
!
interface ps_Potential_Filter
   module procedure ps_SemiLocalPotentials_Filter
end interface ps_Potential_Filter
public :: ps_Potential_Filter

interface ps_Projector_Filter
   module procedure ps_NonLocalProjectors_Filter
end interface ps_Projector_Filter
public :: ps_Projector_Filter

interface ps_PseudoWf_Filter
   module procedure ps_PseudoWaveFunctions_Filter
end interface ps_PseudoWf_Filter
public :: ps_PseudoWf_Filter

private

CONTAINS 

!
! ==============================================================
!
!>  Returns the library version in integer format
function ps_GetLibPSMLVersion() result(v)
integer :: v
  v = PSML_LIBRARY_VERSION
end function ps_GetLibPSMLVersion

!> Sets various parameters for the operation of
!> the evaluator
subroutine ps_SetEvaluatorOptions(quality_level,debug,&
     use_effective_range,&
     custom_interpolator)

use m_psml_interp, only: nq, interpolator

! Parameter for interpolator's quality
! It might mean different things for different
! interpolators
integer, intent(in), optional :: quality_level

logical, intent(in), optional :: debug
logical, intent(in), optional :: use_effective_range

interface
   subroutine interp(nquality,x,y,npts,r,val,debug)

     integer, parameter :: dp = selected_real_kind(10,100)

     integer, intent(in)  :: nquality  ! Quality parameter
     real(dp), intent(in) :: x(*), y(*)
     integer, intent(in)  :: npts    ! Size of x, y arrays
     real(dp), intent(in) :: r
     real(dp), intent(out):: val
     logical, intent(in) :: debug
   end subroutine interp
end interface

procedure(interp), optional :: custom_interpolator

if (present(quality_level)) then
   nq = quality_level
endif
if (present(debug)) then
   global_debug = debug
endif
if (present(use_effective_range)) then
   global_use_effective_range = use_effective_range
endif
if (present(custom_interpolator)) then
   interpolator => custom_interpolator
endif

end subroutine ps_SetEvaluatorOptions
!
! ==============================================================
!
subroutine ps_RootAttributes_Get(ps,uuid,version,namespace,annotation)
  type(ps_t), intent(in) :: ps
  
  character(len=*), intent(out), optional :: uuid
  character(len=*), intent(out), optional :: version
  character(len=*), intent(out), optional :: namespace
  type(ps_annotation_t), intent(out), optional :: annotation

  if (present(uuid)) then
     uuid = trim(ps%uuid)
  endif
  if (present(version)) then
     version = trim(ps%version)
  endif
  if (present(annotation)) then
     annotation = ps%annotation
  endif
  if (present(namespace)) then
     namespace = ps%namespace
  endif

end subroutine ps_RootAttributes_Get
!
! ==============================================================
!
function ps_Provenance_Depth(ps) result(n)
  type(ps_t), intent(in) :: ps
  integer :: n
  
  type(provenance_t), pointer  :: p

  n = 0
  p => ps%provenance
  do while (associated(p))
     n = n + 1
     p => p%next
  enddo
end function ps_Provenance_Depth
  
subroutine ps_Provenance_Get(ps,level,creator,date,&
     annotation,number_of_input_files)
  type(ps_t), intent(in) :: ps
  integer   , intent(in) :: level

  character(len=*), intent(out), optional :: creator
  character(len=*), intent(out), optional :: date
  type(ps_annotation_t), intent(out), optional :: annotation
  integer, intent(out), optional :: number_of_input_files

  type(provenance_t), pointer  :: p
  logical :: found_level

  ! Here "level" means "record_number", with
  ! the oldest having a value of 1.
  
  found_level = .false.
  p => ps%provenance
  do while (associated(p))
     if (p%record_number == level) then
        found_level = .true.
        exit
     endif
     p => p%next
  enddo
  
  if (.not. found_level) call die("Cannot reach provenance level")

  if (present(creator)) then
     creator = p%creator
  endif
  if (present(date)) then
     date = p%date
  endif
  if (present(number_of_input_files)) then
     number_of_input_files = p%n_input_files
  endif
  if (present(annotation)) then
     annotation = p%annotation
  endif
end subroutine ps_Provenance_Get

! To be implemented
!subroutine ps_Provenance_InputFile(ps,level,file_index,&
!                             filename,file_content)
!
! ===================================================================
!
subroutine ps_PseudoAtomSpec_Get(ps,atomic_symbol, atomic_label, &
     atomic_number, z_pseudo, pseudo_flavor,&
     relativity, spin_dft, core_corrections, meta_gga, annotation)
  
  type(ps_t), intent(in) :: ps
  
  character(len=*), intent(out), optional :: atomic_symbol
  character(len=*), intent(out), optional :: atomic_label
  real(dp), intent(out), optional         :: atomic_number
  real(dp), intent(out), optional         :: z_pseudo
  character(len=*), intent(out), optional :: pseudo_flavor
  character(len=*), intent(out), optional :: relativity
  logical, intent(out), optional          :: spin_dft
  logical, intent(out), optional          :: core_corrections
  logical, intent(out), optional          :: meta_gga
  type(ps_annotation_t), intent(out), optional :: annotation

  if (present(atomic_symbol)) then
     atomic_symbol = ps%header%atomic_label(1:2)
  endif
  
  if (present(atomic_label)) then
     atomic_label = trim(ps%header%atomic_label)
  endif

  if (present(atomic_number)) then
     atomic_number = ps%header%z
  endif
  
  if (present(z_pseudo)) then
     z_pseudo = ps%header%zpseudo
  endif
  
  if (present(pseudo_flavor)) then
     pseudo_flavor = trim(ps%header%flavor)
  endif

  if (present(relativity)) then
     relativity = trim(ps%header%relativity)
  endif

  if (present(spin_dft)) then
     spin_dft = ps%header%polarized
  endif

  if (present(core_corrections)) then
     core_corrections = (ps%header%core_corrections == "yes")
  endif

  if (present(meta_gga)) then
     meta_gga = (ps%header%meta_gga == "yes")
  endif

  if (present(annotation)) then
     annotation = ps%header%annotation
  endif

end subroutine ps_PseudoAtomSpec_Get
!
! ===================================================================
!
subroutine ps_ValenceConfiguration_Get(ps,nshells,charge,annotation)
  type(ps_t), intent(in) :: ps
  integer, intent(out), optional  :: nshells
  real(dp), intent(out), optional :: charge
  type(ps_annotation_t), intent(out), optional :: annotation

  if (present(nshells)) then
     nshells = ps%config_val%nshells
  endif
  if (present(charge)) then
     charge = ps%config_val%total_charge
  endif
  if (present(annotation)) then
     annotation = ps%config_val%annotation
  endif
end subroutine ps_ValenceConfiguration_Get

subroutine ps_ValenceShell_Get(ps,i,n,l,occupation,occ_up,occ_down)
  type(ps_t), intent(in) :: ps
  integer, intent(in)    :: i
  
  integer, intent(out), optional  :: n
  integer, intent(out), optional  :: l
  real(dp), intent(out), optional :: occupation 
  real(dp), intent(out), optional :: occ_up
  real(dp), intent(out), optional :: occ_down

  call check_index(i,ps%config_val%nshells,"valence shell")
  if (present(n)) then
     n =  ps%config_val%n(i)
  endif
  if (present(l)) then
     l = l_of_sym(ps%config_val%l(i),"valence shell")
  endif
  if (present(occupation)) then
     occupation = ps%config_val%occ(i)
  endif
  if (present(occ_up)) then
     if (ps%header%polarized) then
        occ_up = ps%config_val%occ_up(i)
     else
        call die("Cannot get per spin occupation")
     endif
  endif
  if (present(occ_down)) then
     if (ps%header%polarized) then
        occ_down = ps%config_val%occ_down(i)
     else
        call die("Cannot get per spin occupation")
     endif
  endif
end subroutine ps_ValenceShell_Get
!
! ===================================================================
!
subroutine ps_ValenceCharge_Get(ps,total_charge,&
     is_unscreening_charge, rescaled_to_z_pseudo,&
     annotation,func)

type(ps_t), intent(in) :: ps

real(dp), intent(out), optional              :: total_charge
character(len=*), intent(out), optional      :: is_unscreening_charge
character(len=*), intent(out), optional      :: rescaled_to_z_pseudo
type(ps_annotation_t), intent(out), optional :: annotation
type(ps_radfunc_t), intent(out), optional    :: func

if (present(total_charge)) then
   total_charge = ps%valence_charge%total_charge
endif

if (present(is_unscreening_charge)) then
   is_unscreening_charge = ps%valence_charge%is_unscreening_charge
endif

if (present(rescaled_to_z_pseudo)) then
   rescaled_to_z_pseudo = ps%valence_charge%rescaled_to_z_pseudo
endif

if (present(annotation)) then
   annotation = ps%valence_charge%annotation
endif

if (present(func)) then
   func = ps%valence_charge%rho_val
endif

end subroutine ps_ValenceCharge_Get
!
!-------------------------------------------------------
!>  Computes the value of the valence charge at r
!> @param ps is a handle to the psml information
!> @param r is the radius
!> It returns the valence charge density integrated over
!> solid angle, so that Q_val = int{ val*r*r }
!> 
function ps_ValenceCharge_Value(ps,r) result(val)
type(ps_t), intent(in) :: ps
real(dp), intent(in)       :: r
real(dp)                   :: val

val = ps_GetValue(ps%valence_charge%rho_val,r)

end function ps_ValenceCharge_Value
!
! ===================================================================
!
subroutine ps_CoreCharge_Get(ps,rc,nderivs,annotation,func)

type(ps_t), intent(in) :: ps

real(dp), intent(out), optional              :: rc
integer , intent(out), optional              :: nderivs
type(ps_annotation_t), intent(out), optional :: annotation
type(ps_radfunc_t), intent(out), optional    :: func

if (present(rc)) then
   rc = ps%core_charge%rcore
endif
if (present(nderivs)) then
   nderivs = ps%core_charge%n_cont_derivs
endif
if (present(annotation)) then
   annotation = ps%core_charge%annotation
endif
if (present(func)) then
   func = ps%core_charge%rho_core
endif

end subroutine ps_CoreCharge_Get

!>  Computes the value of the pseudo-core charge at r
!> @param ps is a handle to the psml information
!> @param r is the radius
!> It returns the pseudo-core charge density integrated over
!> solid angle, so that Q_core = int{ val*r*r }
!> 
function ps_CoreCharge_Value(ps,r) result(val)
type(ps_t), intent(in) :: ps
real(dp), intent(in)       :: r
real(dp)                   :: val

val = ps_GetValue(ps%core_charge%rho_core,r)

end function ps_CoreCharge_Value

!MGGA
! ===================================================================
!
subroutine ps_ValenceKineticDensity_Get(ps,annotation,func)

type(ps_t), intent(in) :: ps

type(ps_annotation_t), intent(out), optional :: annotation
type(ps_radfunc_t), intent(out), optional    :: func

if (present(annotation)) then
   annotation = ps%valence_kinetic_energy_density%annotation
endif

if (present(func)) then
   func = ps%valence_kinetic_energy_density%kin_edens_val
endif

end subroutine ps_ValenceKineticDensity_Get
!
!-------------------------------------------------------
!> Computes the value of the valence kinetic energy density at r
!> @param ps is a handle to the psml information
!> @param r is the radius
!> ??? It returns the valence kinetic energy density integrated over
!> ??? solid angle, so that KE_val = int{ val*r*r }
!> 
function ps_ValenceKineticDensity_Value(ps,r) result(val)
type(ps_t), intent(in) :: ps
real(dp), intent(in)       :: r
real(dp)                   :: val

val = ps_GetValue(ps%valence_kinetic_energy_density%kin_edens_val,r)

end function ps_ValenceKineticDensity_Value
!
! ===================================================================
!
subroutine ps_CoreKineticDensity_Get(ps,rc,nderivs,annotation,func)

type(ps_t), intent(in) :: ps

real(dp), intent(out), optional              :: rc
integer, intent(out), optional               :: nderivs
type(ps_annotation_t), intent(out), optional :: annotation
type(ps_radfunc_t), intent(out), optional    :: func

if (present(rc)) then
   rc = ps%core_kinetic_energy_density%rcore
endif
if (present(nderivs)) then
   nderivs = ps%core_kinetic_energy_density%n_cont_derivs
endif
if (present(annotation)) then
   annotation = ps%core_kinetic_energy_density%annotation
endif
if (present(func)) then
   func = ps%core_kinetic_energy_density%kin_edens_core
endif

end subroutine ps_CoreKineticDensity_Get

!>  Computes the value of the pseudo-core kinetic energy density at r
!> @param ps is a handle to the psml information
!> @param r is the radius
!> ??? It returns the pseudo-core kinetic energy density integrated over
!> ??? solid angle, so that Q_core = int{ val*r*r }
!> 
function ps_CoreKineticDensity_Value(ps,r) result(val)
type(ps_t), intent(in) :: ps
real(dp), intent(in)       :: r
real(dp)                   :: val

val = ps_GetValue(ps%core_kinetic_energy_density%kin_edens_core,r)

end function ps_CoreKineticDensity_Value
!
! ===================================================================
!
subroutine ps_ExchangeCorrelation_Get(ps,annotation,n_libxc_functionals)
type(ps_t), intent(in) :: ps

type(ps_annotation_t), intent(out), optional :: annotation
integer, intent(out), optional               :: n_libxc_functionals

if (present(annotation)) then
   annotation = ps%xc_info%annotation
endif
if (present(n_libxc_functionals)) then
   n_libxc_functionals =  ps%xc_info%n_functs_libxc
endif
end subroutine ps_ExchangeCorrelation_Get

subroutine ps_LibxcFunctional_Get(ps,i,name,code,type,weight)
  type(ps_t), intent(in) :: ps

  integer, intent(in)      :: i
  character(len=*), intent(out), optional :: name
  integer, intent(out), optional          :: code
  character(len=*), intent(out), optional :: type
  real(dp), intent(out), optional         :: weight

  call check_index(i,ps%xc_info%n_functs_libxc,"libxc functional")

  if (present(name)) then
     name = ps%xc_info%libxc_name(i)
  endif
  if (present(code)) then
     code = ps%xc_info%libxc_id(i)
  endif
  if (present(type)) then
     type = ps%xc_info%libxc_type(i)
  endif
  if (present(weight)) then
     weight = ps%xc_info%libxc_weight(i)
  endif
end subroutine ps_LibxcFunctional_Get
!
!=================================================
!> Returns the annotation associated to a grid.
!> If a radial function
!> handle is given, the annotation for that 
!> radial function's grid is returned. Otherwise,
!> the return value is the annotation for the global grid.
!> If there is no appropriate annotation, an empty
!> structure is returned.
!> @param ps is a handle to the psml information
!> @param radfunc is a handle to a radial function structure
!>
function ps_GridAnnotation(ps,radfunc) result(annotation)

 type(ps_t), intent(in)                 :: ps
 type(ps_radfunc_t), intent(in), optional  :: radfunc
 
 type(ps_annotation_t)  :: annotation
 type(ps_annotation_t), pointer  :: annotation_p

 if (present(radfunc)) then
    ! We are told to get the grid annotation
    ! for a specific radial function
    
    if (.not. initialized(radfunc%grid)) then
       call die("get_annotation: Invalid radial function")
    endif
    annotation_p => annotationGrid(radfunc%grid)
    ! If npts_data /= npts_grid, add a record to reflect this
    annotation = annotation_p

 else

    ! This is the global grid annotation
    if (.not. initialized(ps%global_grid)) then
       annotation = EMPTY_ANNOTATION
    else
       annotation_p => annotationGrid(ps%global_grid)
       annotation = annotation_p
    endif

 endif
end function ps_GridAnnotation

!
!====================================================
! Semilocal potentials
!
subroutine ps_Potential_Get(ps,i,&
            l,j,n,rc,set,flavor,eref,annotation,func)
type(ps_t), intent(in), target            :: ps
integer,   intent(in)             :: i
integer, intent(out), optional    :: set
integer, intent(out), optional    :: l
real(dp), intent(out), optional    :: j
integer, intent(out), optional    :: n
real(dp), intent(out), optional    :: rc
real(dp), intent(out), optional    :: eref
character(len=*), intent(out), optional    :: flavor
type(ps_annotation_t), intent(out), optional  :: annotation
type(ps_radfunc_t), intent(out), optional    :: func

type(sl_table_t), pointer :: q(:)
q => ps%sl_table

call check_index(i,size(q),"SL pot")
if (present(set)) then
   set = q(i)%p%set
endif
if (present(l)) then
   l = l_of_sym(q(i)%p%l,"SL pot")
endif
if (present(n)) then
   n = q(i)%p%n
endif
if (present(j)) then
   if (q(i)%p%j < 0.0) then
      j = -1.0_dp
      ! Maybe optional status flag raised?
   else
      j = q(i)%p%j
   endif
endif
if (present(rc)) then
   rc = q(i)%p%rc
endif

if (present(eref)) then
   ! Will return a very large positive value if the attribute eref is not
   ! present in the file
   eref = q(i)%p%eref
endif

if (present(flavor)) then
   flavor = q(i)%p%flavor
endif
if (present(annotation)) then
   annotation = q(i)%p%parent_group%annotation
endif
if (present(func)) then
   func = q(i)%p%V
endif
end subroutine ps_Potential_Get
!
subroutine ps_SemilocalPotentials_Filter(ps,&
                    indexes_in, &
                    l,j,n,set, &
                    indexes,number)
type(ps_t), intent(in), target   :: ps
integer, intent(in), optional    :: indexes_in(:)
integer, intent(in), optional    :: set
integer, intent(in), optional    :: l
real(dp), intent(in), optional   :: j
integer, intent(in), optional    :: n
integer,   intent(out), allocatable, optional  :: indexes(:)
integer,   intent(out), optional  :: number

integer :: i, ii, num
integer, allocatable :: idx(:), range(:)

type(sl_table_t), pointer :: q(:)
q => ps%sl_table

!
!  If we specify an initial domain, we
!  only loop over it for the rest of
!  the operations
!

if (present(indexes_in)) then
   allocate(range(size(indexes_in)))
   range(:) = indexes_in(:)
else
   allocate(range(size(q)))
   do ii = 1, size(q)
      range(ii) = ii
   enddo
endif

num = 0
do ii = 1, size(range)
   i = range(ii)
   if (present(set)) then
      if (iand(q(i)%p%set,set) == 0) cycle
   endif
   if (present(l)) then
      if (l_of_sym(q(i)%p%l,"pot") /= l) cycle
   endif
   if (present(j)) then
      ! A negative p%j signals the absence of j...
      if (q(i)%p%j < 0.0) cycle
      ! Perform integer comparison
      if (nint(10*q(i)%p%j) /= nint(10*j)) cycle
   endif
   if (present(n)) then
      if (q(i)%p%n /= n) cycle
   endif
   num = num + 1
enddo

allocate(idx(num))

num = 0
do ii = 1, size(range)
   i = range(ii)
   if (present(set)) then
      if (iand(q(i)%p%set,set) == 0) cycle
   endif
   if (present(j)) then
      ! A negative p%j signals the absence of j...
      if (q(i)%p%j < 0.0) cycle
      ! Perform integer comparison
      if (nint(10*q(i)%p%j) /= nint(10*j)) cycle
   endif
   if (present(l)) then
      if (l_of_sym(q(i)%p%l,"pot") /= l) cycle
   endif
   if (present(n)) then
      if (q(i)%p%n /= n) cycle
   endif
   num = num + 1
   idx(num) = i
enddo

if (present(indexes)) then
   if (allocated(indexes))  deallocate(indexes)
   allocate(indexes(num))
   indexes(:) = idx(:)
endif
if (present(number)) then
   number = num
endif

deallocate(idx,range)

end subroutine ps_SemilocalPotentials_Filter
!
function ps_GetValue(f,r) result(val)
type(ps_radfunc_t), intent(in)     ::  f
real(dp),  intent(in)      :: r
real(dp)                   :: val

if (r> max_range(f)) then
   if (f%has_coulomb_tail) then
      val = f%tail_factor / r
   else
      val = 0.0_dp
   endif
else
   val = eval_radfunc(f,r, debug=global_debug)
endif
end function ps_GetValue

!> Evaluator by storage index
function ps_Potential_Value(ps,i,r) result(val)
type(ps_t), intent(in)     ::  ps
integer,   intent(in)      :: i
real(dp),  intent(in)      :: r
real(dp)                   :: val

call check_index(i,size(ps%sl_table),"SL pot")
val = ps_GetValue(ps%sl_table(i)%p%V,r)

end function ps_Potential_Value

subroutine ps_GetRawData(f,raw_r,raw_data)
type(ps_radfunc_t), intent(in) :: f
real(dp), allocatable, intent(out)  :: raw_r(:), raw_data(:)

integer npts_data
real(dp), pointer :: a(:) 

! Cover the case in which the data set uses only
! a first section of the grid

npts_data = size(f%data)
allocate(raw_r(npts_data), raw_data(npts_data))

a => valGrid(f%grid)
raw_r(1:npts_data) = a(1:npts_data)
raw_data(:) = f%data(:)

end subroutine ps_GetRawData

!
!====================================================
! PseudoWavefunctions
!
! Basic accessors
!
subroutine ps_PseudoWaveFunctions_Filter(ps,&
                    indexes_in,&
                    l,j,n,set, &
                    indexes,number)
type(ps_t), intent(in), target   :: ps
integer,  intent(in), optional   :: indexes_in(:)
integer, intent(in), optional    :: set
integer, intent(in), optional    :: l
real(dp), intent(in), optional   :: j
integer, intent(in), optional    :: n
integer,   intent(out), allocatable, optional  :: indexes(:)
integer,   intent(out), optional  :: number

integer :: i, ii, num
integer, allocatable :: idx(:), range(:)

type(wf_table_t), pointer :: q(:)
q => ps%wf_table

!
!  If we specify an initial domain, we
!  only loop over it for the rest of
!  the operations
!

if (present(indexes_in)) then
   allocate(range(size(indexes_in)))
   range(:) = indexes_in(:)
else
   allocate(range(size(q)))
   do ii = 1, size(q)
      range(ii) = ii
   enddo
endif

num = 0
do ii = 1, size(range)
   i = range(ii)
   if (present(set)) then
      if (iand(q(i)%p%set,set) == 0) cycle
   endif
   if (present(l)) then
      if (l_of_sym(q(i)%p%l,"wf") /= l) cycle
   endif
   if (present(j)) then
      ! A negative p%j signals the absence of j...
      if (q(i)%p%j < 0.0) cycle
      ! Perform integer comparison
      if (nint(10*q(i)%p%j) /= nint(10*j)) cycle
   endif
   if (present(n)) then
      if (q(i)%p%n /= n) cycle
   endif
   num = num + 1
enddo

allocate(idx(num))

num = 0
do ii = 1, size(range)
   i = range(ii)
   if (present(set)) then
      if (iand(q(i)%p%set,set) == 0) cycle
   endif
   if (present(j)) then
      ! A negative p%j signals the absence of j...
      if (q(i)%p%j < 0.0) cycle
      ! Perform integer comparison
      if (nint(10*q(i)%p%j) /= nint(10*j)) cycle
   endif
   if (present(l)) then
      if (l_of_sym(q(i)%p%l,"wf") /= l) cycle
   endif
   if (present(n)) then
      if (q(i)%p%n /= n) cycle
   endif
   num = num + 1
   idx(num) = i
enddo

if (present(indexes)) then
   if (allocated(indexes))  deallocate(indexes)
   allocate(indexes(num))
   indexes(:) = idx(:)
endif
if (present(number)) then
   number = num
endif

deallocate(idx,range)

end subroutine ps_PseudoWaveFunctions_Filter

subroutine ps_PseudoWf_Get(ps,i,&
            l,j,n,set,energy_level,annotation,func)
type(ps_t), intent(in), target    :: ps
integer,   intent(in)             :: i
integer, intent(out), optional    :: set
integer, intent(out), optional    :: l
real(dp), intent(out), optional   :: j
integer, intent(out), optional    :: n
real(dp), intent(out), optional   :: energy_level
type(ps_annotation_t), intent(out), optional :: annotation
type(ps_radfunc_t), intent(out), optional    :: func

type(wf_table_t), pointer :: q(:)
q => ps%wf_table

call check_index(i,size(q),"wf")
if (present(set)) then
   set = q(i)%p%set
endif
if (present(l)) then
   l = l_of_sym(q(i)%p%l,"wf")
endif
if (present(n)) then
   n = q(i)%p%n
endif
if (present(j)) then
   if (q(i)%p%j < 0.0) then
      j = -1.0_dp
      ! Maybe optional status flag raised?
   else
      j = q(i)%p%j
   endif
endif

if (present(energy_level)) then
   ! Will return a very large positive value if the attribute energy_level is not
   ! present in the file
   energy_level = q(i)%p%energy_level
endif


if (present(annotation)) then
   annotation = q(i)%p%parent_group%annotation
endif

if (present(func)) then
   func = q(i)%p%Phi
endif
end subroutine ps_PseudoWf_Get

!
function ps_PseudoWf_Value(ps,i,r) result(val)
type(ps_t), intent(in) :: ps
integer,   intent(in)  :: i
real(dp),  intent(in)  :: r
real(dp)               :: val

call check_index(i,size(ps%wf_table),"Wf")
val = ps_GetValue(ps%wf_table(i)%p%Phi,r)

end function ps_PseudoWf_Value
!
!====================================================
! Pseudopotential operator (Vlocal, LocalCharge, projectors)
!
! Basic accessors
!
function ps_HasProjectors(ps) result(p)
type(ps_t), intent(in) :: ps
logical                    :: p
!
p = (size(ps%nl_table) > 0)

end function ps_HasProjectors

function ps_HasLocalPotential(ps) result(p)
type(ps_t), intent(in) :: ps
logical                    :: p
!
p = (initialized(ps%local%Vlocal%grid))

end function ps_HasLocalPotential

subroutine ps_LocalPotential_Get(ps,type,annotation,func,&
                                 has_local_charge,func_local_charge)
type(ps_t), intent(in) :: ps

character(len=*), intent(out), optional      :: type
type(ps_annotation_t), intent(out), optional :: annotation
type(ps_radfunc_t), intent(out), optional    :: func
logical, intent(out), optional               :: has_local_charge
type(ps_radfunc_t), intent(out), optional    :: func_local_charge

if (present(type)) then
   type = ps%local%vlocal_type
endif
if (present(annotation)) then
   annotation = ps%local%annotation
endif
if (present(func)) then
   func = ps%local%vlocal
endif
if (present(has_local_charge)) then
   has_local_charge = (initialized(ps%local%chlocal%grid))
endif
if (present(func_local_charge)) then
   ! No checks
   func_local_charge = ps%local%chlocal
endif
end subroutine ps_LocalPotential_Get
!
function ps_LocalPotential_Value(ps,r) result(val)
type(ps_t), intent(in) :: ps
real(dp), intent(in)       :: r
real(dp)                   :: val

val = ps_GetValue(ps%local%vlocal,r)

end function ps_LocalPotential_Value
!
! ==========================================================
!
function ps_HasPSOperator(ps) result(psop)
type(ps_t), intent(in) :: ps
logical                    :: psop
!
psop = (ps_HasProjectors(ps) .and. ps_HasLocalPotential(ps))

end function ps_HasPSOperator
!
function ps_HasSemilocalPotentials(ps) result(p)
type(ps_t), intent(in) :: ps
logical                    :: p
!
p = (associated(ps%semilocal))

end function ps_HasSemilocalPotentials

!================================ Projectors
subroutine ps_NonlocalProjectors_Filter(ps,&
                    indexes_in,&
                    l,j,seq,set, &
                    indexes,number)
type(ps_t), intent(in), target   :: ps
integer, intent(in), optional    :: indexes_in(:)
integer, intent(in), optional    :: set
integer, intent(in), optional    :: l
real(dp), intent(in), optional   :: j
integer, intent(in), optional    :: seq
integer,   intent(out), allocatable, optional  :: indexes(:)
integer,   intent(out), optional  :: number

integer :: i, ii, num
integer, allocatable :: idx(:), range(:)

type(nl_table_t), pointer :: q(:)
q => ps%nl_table

!
!  If we specify an initial domain, we
!  only loop over it for the rest of
!  the operations
!

if (present(indexes_in)) then
   allocate(range(size(indexes_in)))
   range(:) = indexes_in(:)
else
   allocate(range(size(q)))
   do ii = 1, size(q)
      range(ii) = ii
   enddo
endif

num = 0
do ii = 1, size(range)
   i = range(ii)
   if (present(set)) then
      if (iand(q(i)%p%set,set) == 0) cycle
   endif
   if (present(l)) then
      if (l_of_sym(q(i)%p%l,"pot") /= l) cycle
   endif
   if (present(j)) then
      ! A negative p%j signals the absence of j...
      if (q(i)%p%j < 0.0) cycle
      ! Perform integer comparison
      if (nint(10*q(i)%p%j) /= nint(10*j)) cycle
   endif
   if (present(seq)) then
      if (q(i)%p%seq /= seq) cycle
   endif
   num = num + 1
enddo

allocate(idx(num))

num = 0
do ii = 1, size(range)
   i = range(ii)
   if (present(set)) then
      if (iand(q(i)%p%set,set) == 0) cycle
   endif
   if (present(j)) then
      ! A negative p%j signals the absence of j...
      if (q(i)%p%j < 0.0) cycle
      ! Perform integer comparison
      if (nint(10*q(i)%p%j) /= nint(10*j)) cycle
   endif
   if (present(l)) then
      if (l_of_sym(q(i)%p%l,"pot") /= l) cycle
   endif
   if (present(seq)) then
      if (q(i)%p%seq /= seq) cycle
   endif
   num = num + 1
   idx(num) = i
enddo

if (present(indexes)) then
   if (allocated(indexes))  deallocate(indexes)
   allocate(indexes(num))
   indexes(:) = idx(:)
endif
if (present(number)) then
   number = num
endif

deallocate(idx,range)

end subroutine ps_NonlocalProjectors_Filter

subroutine ps_Projector_Get(ps,i,&
            l,j,seq,set,ekb,eref,type,annotation,func)
type(ps_t), intent(in), target    :: ps
integer,   intent(in)             :: i
integer, intent(out), optional    :: set
integer, intent(out), optional    :: l
real(dp), intent(out), optional    :: j
integer, intent(out), optional    :: seq
real(dp), intent(out), optional    :: ekb
real(dp), intent(out), optional    :: eref
character(len=*), intent(out), optional    :: type
type(ps_annotation_t), intent(out), optional :: annotation
type(ps_radfunc_t), intent(out), optional    :: func

type(nl_table_t), pointer :: q(:)
q => ps%nl_table

call check_index(i,size(q),"NL pot")
if (present(set)) then
   set = q(i)%p%set
endif
if (present(l)) then
   l = l_of_sym(q(i)%p%l,"NL pot")
endif
if (present(seq)) then
   seq = q(i)%p%seq
endif
if (present(j)) then
   if (q(i)%p%j < 0.0) then
      j = -1.0_dp
      ! Maybe optional status flag raised?
   else
      j = q(i)%p%j
   endif
endif
if (present(ekb)) then
   ekb = q(i)%p%ekb
endif
if (present(eref)) then
   ! Will return a very large positive value if the attribute eref is not
   ! present in the file
   eref = q(i)%p%eref
endif
if (present(type)) then
   type = q(i)%p%type
endif
if (present(annotation)) then
   annotation = q(i)%p%parent_group%annotation
endif
if (present(func)) then
   func = q(i)%p%proj
endif
end subroutine ps_Projector_Get


function ps_Projector_Value(ps,i,r) result(val)
!+ display: private
type(ps_t), intent(in) :: ps
integer,   intent(in)  :: i
real(dp),  intent(in)  :: r
real(dp)               :: val

call check_index(i,size(ps%nl_table),"proj")
val = ps_GetValue(ps%nl_table(i)%p%proj,r)

end function ps_Projector_Value

!====================================================
! Low-level routines
!
!
subroutine check_index(i,n,str)
integer, intent(in) :: i, n
character(len=*), intent(in) :: str

call assert( (i <=  n), "Index overflow in "//trim(str))
call assert( (i >  0), "Non-positive index in "//trim(str))
end subroutine check_index
!
function l_of_sym(str,name) result(l)
character(len=*), intent(in) :: str, name
integer                :: l
!
! This routine will disappear once we store
! l as integer in the data structure
!
do l = 0,4
   if (str == sym(l)) RETURN
enddo
call die("Wrong l symbol in "//trim(name))
end function l_of_sym

!>  Returns the maximum radius in a radfunc's data
function max_range(f) result(range)
type(ps_radfunc_t), intent(in) :: f
real(dp)                  :: range

real(dp),  pointer :: a(:)
integer :: npts_data

a => valGrid(f%grid)

!
if (global_use_effective_range) then
   ! We use the effective end_of_range
   range = f%rcut_eff
else
   ! Use the nominal range
   ! This covers the case in which the data set uses only
   ! a first section of the grid
   npts_data = size(f%data)
   range = a(npts_data)
endif

end function max_range

!----------
function eval_radfunc(f,r,debug) result(val)
use m_psml_interp, only: interpolator, nq

type(ps_radfunc_t), intent(in) :: f
real(dp), intent(in)      :: r
logical, intent(in)       :: debug

real(dp)                  :: val

real(dp), pointer :: x(:) => null(), y(:) => null()
integer :: npts

x => valGrid(f%grid)
y => f%data(:)

!Note size(y) to cover the case in which the data set uses only
! a first section of the grid
npts = size(y)
call interpolator(nq,x,y,npts,r,val,debug)

end function eval_radfunc
!
!------
!
   subroutine assert(cond,message)
     logical, intent(in) :: cond
     character(len=*) message

     if (.not. cond) call die(message)
   end subroutine assert

end module m_psml_api

program show_psml

!
! Example of extraction of information from PSML file
! This is quite a "low-level" example, in which the
! program queries all the contents and prints the information.
!
! Examples closer to the use cases in electronic-structure
! codes are in preparation
!
! No examples of extraction of "j" or "s" values yet.
!
use m_psml
use m_getopts

implicit none

integer, parameter :: dp = selected_real_kind(10,100)
character(len=1), dimension(0:4) :: sym = (/ "s", "p", "d", "f", "g" /)

type(ps_t)   :: ps
type(ps_annotation_t)  :: annot

      character(len=200) :: filename
      logical            :: debug, plot, plot_raw
      character(len=200) :: opt_arg, mflnm, ref_line
      character(len=10)  :: opt_name 
      character(len=10)  :: interp_type
      integer            :: interp_quality
      integer :: nargs, iostat, n_opts, nlabels, iorb, ikb
      
      integer :: i, j, l, n, num, nfun, set, seq, ncont
      real(dp) :: ekb, rc, jval

      real(dp), allocatable, dimension(:) :: r
      real(dp) :: Rmax, delta, val
      integer  :: npts, ir
      character(len=50) :: outname,  target_set, set_str
      integer, allocatable   :: setidx(:), idxl(:)

      integer :: npots, nprojs, nwfs
      real(dp), allocatable   :: raw_r(:), raw_data(:)
      type(ps_radfunc_t) :: rfunc

      character(len=10) :: relativity
      logical           :: core_corrections
      logical           :: meta_gga

      character(len=100) :: creator, date
      integer            :: prov_depth, ninput
      character(len=100) :: uuid, version, namespace
      character(len=100) :: name, type
      real(dp)           :: weight
      integer            :: code
      logical            :: has_chlocal
      logical            :: use_effective_range = .true.

      ! There is a copy of dpnint1 inside the library
      ! This external declaration is to support calls
      ! to ps_SetInterpolator
      external :: interpolate_drh

      ! Uncomment the following when a new interpolator
      ! is added to the source tree. The one used previously
      ! was removed due to license issues.
!!      external :: interpolate_other  

!
!     Process options
!
      n_opts = 0
      debug = .false.
      plot = .false.
      plot_raw = .false.

      Rmax = 4.0_dp   ! default maximum radius for plots
      npts = 200      ! default number of points

      interp_type = "drh"
      interp_quality = 7  ! this is npoint=2 in OTHER interpolator
      do
         call getopts('dR:n:pi:q:tr',opt_name,opt_arg,n_opts,iostat)
         if (iostat /= 0) exit
         select case(opt_name)
           case ('d')
              debug = .true.
           case ('t')
              use_effective_range = .false.
           case ('p')
              plot = .true.
           case ('r')
              plot_raw = .true.
           case ('R')
              read(opt_arg,*) Rmax
           case ('n')
              read(opt_arg,*) npts
           case ('i')
              read(opt_arg,*) interp_type
           case ('q')
              read(opt_arg,*) interp_quality
           case ('?',':')
             write(0,*) "Invalid option: ", opt_arg(1:1)
             write(0,*) "Usage: show_psml [ -d -p -r -R Rmax -n npts ] FILE"
             write(0,*) " -d for debug output"
             write(0,*) " -p for output of evaluated data"
             write(0,*) " -r for output of raw data"
             write(0,*) " -R Rmax : maximum range of output grid (def: 4 bohr)"
             write(0,*) " -n npts : number of points of output grid (def: 200)"
             write(0,*) " -i type : interpolator type (drh) ('other' not implemented)"
             write(0,*) " -q nq   : interpolator quality (npoly for drh)"
             STOP
          end select
       enddo

       nargs = command_argument_count()
       nlabels = nargs - n_opts + 1
       if (nlabels /= 1)  then
             write(0,*) "Usage: show_psml [ -d -p -r -R Rmax -n npts ] FILE"
             write(0,*) " -d for debug output"
             write(0,*) " -p for output of evaluated data"
             write(0,*) " -r for output of raw data"
             write(0,*) " -R Rmax : maximum range of output grid (def: 4 bohr)"
             write(0,*) " -n npts : number of points of output grid (def: 200)"
             write(0,*) " -i type : interpolator type (drh) ('other' not implemented)"
             write(0,*) " -q nq   : interpolator quality (npoly for drh)"
          STOP
       endif

       call get_command_argument(n_opts,value=filename,status=iostat)
       if (iostat /= 0) then
          STOP "Cannot get filename"
       endif
!
print "(a)", "Processing: " // trim(filename)
call psml_reader(filename,ps,debug=debug,stat=iostat)
if (iostat == -1) then
   write(0,*) "Cannot open PSML file " // trim(filename)
   STOP
endif

call ps_SetEvaluatorOptions(use_effective_range=use_effective_range)
#ifdef __NO_PROC_POINTERS__
if (trim(interp_type)=="other") then
   print "(a)", "No support for other interpolators if no proc pointers"
   STOP 
endif
call ps_SetEvaluatorOptions(quality_index=interp_quality,debug=debug)
print "(a,i3)", "Using DRH (default) interpolator with npoly:", interp_quality

#else

if (trim(interp_type)=="other") then
!   call ps_SetInterpolator(interpolate_other,interp_quality)
!   print "(a,i3)", "Using OTHER interpolator with quality index:",interp_quality
   print "(a)", "Please implement 'other' interpolator first"
   STOP 
else if (trim(interp_type)=="drh") then
   call ps_SetEvaluatorOptions(custom_interpolator=interpolate_drh,&
                               quality_level=interp_quality,debug=debug)
   print "(a,i3)", "Using DRH interpolator with npoly:",interp_quality
else
   STOP "unknown interpolator"
endif

#endif

call ps_RootAttributes_Get(ps,uuid=uuid,version=version,&
                 namespace=namespace)
print "(a,1x,a,1x,a)", "PSML version, uuid:", version, uuid
print "(a,1x,a,1x,a)", "PSML namespace:", trim(namespace)

prov_depth = ps_Provenance_Depth(ps)
do i = prov_depth, 1, -1
   call ps_Provenance_Get(ps,i,creator=creator,date=date,annotation=annot,&
        number_of_input_files=ninput)
   print "(a,1x,i1,1x,a,1x,a,1x,i1)", "Prov: (depth)", i, trim(creator), trim(date), &
        ninput
   call print_annotation(annot)
end do
!
! Set up our grid
allocate(r(npts))
delta = Rmax / (npts - 1)
do ir = 1, npts
   r(ir) = (ir-1)*delta
enddo

call ps_PseudoAtomSpec_Get(ps,relativity=relativity,&
     core_corrections=core_corrections,meta_gga=meta_gga,annotation=annot)
call print_annotation(annot)

print *, "Relativity: ", trim(relativity)

call ps_ExchangeCorrelation_Get(ps,annotation=annot,n_libxc_functionals=nfun)
print *, "Exchange-correlation info:"

print *, "Number of functionals: ", nfun
do i = 1, nfun
   call ps_LibxcFunctional_Get(ps,i, &
           name=name,code=code,weight=weight,type=type)
  print "(a,1x,a,1x,a,1x,i4,f10.6)", "name, type, id, weight:", &
    trim(name), trim(type), code, weight
enddo
call print_annotation(annot)
!
! ================================================
!
call ps_Potential_Filter(ps,set=SET_ALL,indexes=setidx,number=npots)
print *, "There are ", npots, " semi-local pots"

do i = 1, npots
   call ps_Potential_Get(ps,setidx(i), &
                         l=l,n=n,j=jval,rc=rc,set=set,annotation=annot,func=rfunc)
   set_str = str_of_set(set)
   if (set == SET_LJ) then
      print "(a,1x,i1,a1,1x,f3.1,f10.3)", trim(set_str), n, sym(l), jval, rc
   else
      print "(a,1x,i1,a1,f10.3)", trim(set_str), n, sym(l), rc
   endif

   if (plot) then
   write(outname,"(a,i0,a1)") "Vsl." //trim(set_str) // ".", n, sym(l)
   open(4,file=outname,form="formatted",status="unknown",&
        action="write",position="rewind")
   do ir = 1, npts
      val = ps_Potential_Value(ps,setidx(i),r(ir))
      write(4,*) r(ir), val
   enddo
   close(4)
   endif
    if (plot_raw) then
      call ps_GetRawData(rfunc,raw_r,raw_data)
      write(outname,"(a)") trim(outname) // ".raw"
      open(4,file=outname,form="formatted",status="unknown",&
           action="write",position="rewind")
      do ir = 1, size(raw_data)
         write(4,*) raw_r(ir), raw_data(ir)
      enddo
      close(4)
    endif

enddo

if (.not. ps_HasLocalPotential(ps)) then
   print *, "This file does not have a local potential"
else
   call ps_LocalPotential_Get(ps,annotation=annot,type=type,&
                              has_local_charge=has_chlocal,func=rfunc)
   call print_annotation(annot)
   print *, "Vlocal type: " // trim(type)
   print *, "Has Local Charge: ", has_chlocal
   
   if (plot) then
   write(outname,"(a)") "Vlocal"
   open(4,file=outname,form="formatted",status="unknown",&
        action="write",position="rewind")
   do ir = 1, npts
      val = ps_LocalPotential_Value(ps,r(ir))
      write(4,*) r(ir), val
   enddo
   close(4)
   endif
    if (plot_raw) then
      call ps_GetRawData(rfunc,raw_r,raw_data)
      write(outname,"(a)") trim(outname) // ".raw"
      open(4,file=outname,form="formatted",status="unknown",&
           action="write",position="rewind")
      do ir = 1, size(raw_data)
         write(4,*) raw_r(ir), raw_data(ir)
      enddo
      close(4)
    endif
endif

if (.not. ps_HasProjectors(ps)) then
   print *, "This file does not have non-local projectors"
else

   call ps_Projector_Filter(ps,set=SET_ALL,indexes=setidx,number=nprojs)
   print *, "There are ", nprojs, " projectors"

   print "(a20,a8,a4,a12)", "set", "l (j)", "seq", "Ekb"
   do l = 0, 4
      call ps_Projector_Filter(ps,indexes_in=setidx,&
                   l=l,indexes=idxl,number=num)

   do j = 1, num
      call ps_Projector_Get(ps,idxl(j),ekb=ekb,set=set,seq=seq,j=jval,func=rfunc)
      set_str = str_of_set(set)
      if (set == SET_LJ) then
         print "(a20,i4,1x,f3.1,i4,f12.6)", set_str, l, jval, seq, ekb
         write(outname,"(a,i0,a1,f3.1,a1,i0)") &
                   "Proj." //trim(set_str) // ".", &
                    l, ".", jval,".", seq
      else
         print "(a20,i4,i4,f12.6)", set_str, l, seq, ekb
         write(outname,"(a,i0,a1,i0)") &
              "Proj." //trim(set_str) // ".", l, ".", seq
      endif

      if (plot) then

      open(4,file=outname,form="formatted",status="unknown",&
           action="write",position="rewind")
      do ir = 1, npts
         val = ps_Projector_Value(ps,idxl(j),r(ir))
         write(4,*) r(ir), val
      enddo
      close(4)
    if (plot_raw) then
      call ps_GetRawData(rfunc,raw_r,raw_data)
      write(outname,"(a)") trim(outname) // ".raw"
      open(4,file=outname,form="formatted",status="unknown",&
           action="write",position="rewind")
      do ir = 1, size(raw_data)
         write(4,*) raw_r(ir), raw_data(ir)
      enddo
      close(4)
    endif
   endif

   enddo
enddo
endif

! Valence charge density
call ps_ValenceCharge_Get(ps,annotation=annot)
call print_annotation(annot)

   if (plot) then
      write(outname,"(a)") "Valence.charge"
      open(4,file=outname,form="formatted",status="unknown",&
           action="write",position="rewind")
      do ir = 1, npts
         val = ps_ValenceCharge_Value(ps,r(ir))
         write(4,*) r(ir), val
      enddo
      close(4)
   endif

! Pseudo-Core charge

   if (core_corrections) then
      call ps_CoreCharge_Get(ps,annotation=annot,&
                             nderivs=ncont)
      call print_annotation(annot)
      print *, "No of continuous derivs: ", ncont
      if (plot) then
         write(outname,"(a)") "Core.charge"
         open(4,file=outname,form="formatted",status="unknown",&
              action="write",position="rewind")
         do ir = 1, npts
            val = ps_CoreCharge_Value(ps,r(ir))
            write(4,"(1p,2e21.13)") r(ir), val
         enddo
         close(4)
      endif
   endif
   
   if (meta_gga) then
      call ps_ValenceKineticDensity_Get(ps,annotation=annot)
      call print_annotation(annot)
      if (plot) then
         write(outname,"(a)") "Valence.KE.density"
         open(4,file=outname,form="formatted",status="unknown",&
              action="write",position="rewind")
         do ir = 1, npts
            val = ps_ValenceKineticDensity_Value(ps,r(ir))
            write(4,"(1p,2e21.13)") r(ir), val
         enddo
         close(4)
      endif
      if (core_corrections) then
         call ps_CoreKineticDensity_Get(ps,annotation=annot,&
                             nderivs=ncont)
         call print_annotation(annot)
         print *, "No of continuous derivs: ", ncont
         if (plot) then
            write(outname,"(a)") "Core.KE.density"
            open(4,file=outname,form="formatted",status="unknown",&
                 action="write",position="rewind")
            do ir = 1, npts
               val = ps_CoreKineticDensity_Value(ps,r(ir))
               write(4,"(1p,2e21.13)") r(ir), val
            enddo
            close(4)
         endif
      endif
   endif
   
call ps_PseudoWaveFunctions_Filter(ps,set=SET_ALL,indexes=setidx,number=nwfs)
print *, "There are ", nwfs, " pseudo wave-functions"
!call display_annotation(ps,"pseudo-wavefunctions")
!
do i = 1, nwfs
   call ps_PseudoWf_Get(ps,setidx(i),l=l,n=n,set=set,j=jval)
   set_str = str_of_set(set)
   if (set == SET_LJ) then
      print "(a,1x,i1,a1,1x,f3.1)", trim(set_str), n, sym(l), jval
   else
      print "(a,1x,i1,a1)", trim(set_str), n, sym(l)
   endif

   if (plot) then
   write(outname,"(a,i0,a1)") "Pswf." //trim(set_str) // ".", n, sym(l)
   open(4,file=outname,form="formatted",status="unknown",&
        action="write",position="rewind")
   do ir = 1, npts
      val = ps_PseudoWf_Value(ps,setidx(i),r(ir))
      write(4,*) r(ir), val
   enddo
   close(4)
   endif
enddo
   
call ps_destroy(ps)

end program show_psml

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

module m_psml_parsing_helpers
!
!  This module reads a pseudopotential file written in the PSML format
!  A full example of the building up of a data structure using
!  the SAX paradigm.
!
 use m_psml_core              ! For data types and basic utilities
 use m_psml_external_interfaces, only: die => psml_die
 use m_psml_class_Grid
 use m_psml_assoc_list, only: ps_annotation_t => assoc_list_t

 use m_psml_strings_helpers, only: safe_str_assign
 
implicit none

private

!
! It defines the routines that are called from xml_parser in response
! to particular events.
!
public  :: begin_element, end_element, pcdata_chunk
public  :: cdata_section_chunk

!
! The data will be stored in this public variable
! There are some design issues to decide:
! -- Should this be a pointer, associated by the client
!    program to its own variable? In that case, the
!    client should make sure that the variable is "clean"
!    before calling this routine, as some fields will be
!    allocated here.
! -- Perhaps it should be a pointer allocated here (and
!    then destroyed when done by the client). It should be
!    allocated at the beginning of processing, maybe detected
!    with a (default) "begin_Document" handler, or by 
!    "begin_Element" after checking for association.
!    This is the cleanest option, as the caller might want
!    to keep several instances alive at the same time...
!    (... but this should be handled by the user)
! -- If "pseudo" here is a normal variable, it should also
!    be "cleaned" before the next use. The current usage
!    in Abinit falls in this category: psxml is a pointer
!    associated to "pseudo", and cleaned after use.
!
!    We implement the first option now

type(ps_t), pointer, public, save :: pseudo => null() 
logical, public, save             :: debug_parsing = .false.

logical, private, save  :: in_psml = .false.
logical, private, save  :: in_slps = .false. , in_radfunc = .false.
logical, private, save  :: in_semilocal = .false. , in_header = .false.
logical, private, save  :: in_coreCharge = .false. , in_data = .false.
logical, private, save  :: in_grid_data = .false. , in_grid = .false.
logical, private, save  :: in_valenceCharge = .false.
logical, private, save  :: in_provenance = .false., in_input_file = .false.
logical, private, save  :: in_valence_config = .false.
logical, private, save  :: in_xc = .false., in_libxc_info = .false.
logical, private, save  :: in_pseudowavefun = .false. , in_pswf = .false.
logical, private, save  :: in_chlocal = .false., in_nonlocal = .false.
logical, private, save  :: in_proj = .false. , in_local_potential = .false.
logical, private, save  :: in_valenceKE = .false.
logical, private, save  :: in_coreKE = .false.
logical, private, save  :: got_explicit_grid_data

integer, private, save  :: ndata, ndata_grid
integer, private, save  :: n_funct

character(len=20), private, save :: current_wf_set
character(len=20), private, save :: current_sl_set
character(len=20), private, save :: current_proj_set
character(len=40), private, save :: top_flavor

integer, parameter, private    :: dp = selected_real_kind(14)
real(dp), private, save        :: zval_generation

type(Grid), private, save                  :: tmp_grid
real(dp), private, save, pointer           :: gdata(:) => null()
type(ps_annotation_t), private, save, pointer :: gannot => null()
!
! Pointers to make it easier to manage the data
!
type(provenance_t), private, pointer      :: pp => null()
type(provenance_t), private, pointer      :: qp => null()
type(input_file_t), private, pointer      :: ifp => null()
type(header_t), private, pointer          :: hp => null()
type(config_val_t), private, pointer      :: cp => null()
type(xc_t), private, pointer              :: xp => null()
type(wfns_t), private, pointer            :: wfp => null()
type(wfns_t), private, pointer            :: qwfp => null()
type(wf_t), private, pointer              :: wfpp => null()
type(wf_t), private, pointer              :: qwfpp => null()
type(semilocal_t), private, pointer       :: slp => null()
type(semilocal_t), private, pointer       :: qslp => null()
type(slps_t), private, pointer            :: slvp => null()
type(slps_t), private, pointer            :: qslvp => null()
type(local_t), private, pointer           :: lop => null()
type(nonlocal_t), private, pointer        :: nlp => null()
type(nonlocal_t), private, pointer        :: qnlp => null()
type(nlpj_t), private, pointer            :: nlpp => null()
type(nlpj_t), private, pointer            :: qnlpp => null()
type(valence_charge_t), private, pointer  :: valp => null()
type(core_charge_t), private, pointer     :: corep => null()
type(valence_kinetic_energy_density_t), private, pointer  :: valKEp => null()
type(core_kinetic_energy_density_t), private, pointer     :: coreKEp => null()
type(radfunc_t), private, pointer         :: rp => null()

character(len=100), private, save :: parent_element=""

integer :: npts_data

CONTAINS  !===========================================================

!----------------------------------------------------------------------

subroutine begin_element(name,attributes)

use xmlf90_sax, only: dictionary_t, get_value

character(len=*), intent(in)    :: name
type(dictionary_t), intent(in)  :: attributes

character(len=100)  :: value, msg
real                :: version_number
integer             :: status

integer             :: i, npts

if (debug_parsing) print *, "Element: ", trim(name)

select case(name)

      case ("psml")

         in_psml = .true.
         ! Make sure that pseudo is pointing to something

         if (.not. associated(pseudo)) then
            call die("ps_t object not initialized by client")
         endif

         call get_value(attributes,"version",value,status)
         if (status /= 0 ) call die("No psml version")
         read(value,fmt=*) version_number
         if ( (version_number < PSML_TARGET_VERSION_LO) .or. &
              (version_number > PSML_TARGET_VERSION_HI)) then
            write(msg,"('[',f4.2,',',f4.2,']')")  &
                       PSML_TARGET_VERSION_LO, &
                       PSML_TARGET_VERSION_HI
            call die("This version of the library can "// &
                     "process PSML files with version in "//trim(msg))
         endif
         pseudo%version = value
         call get_value(attributes,"energy_unit",pseudo%energy_unit,status)
         if (status /= 0 ) call die("No energy unit")
         call get_value(attributes,"length_unit",pseudo%length_unit,status)
         if (status /= 0 ) call die("No length unit")

         call get_value(attributes,"uuid",pseudo%uuid,status)
         if (status /= 0 ) pseudo%uuid = "no-uuid-specified"

         call get_value(attributes,"xmlns",pseudo%namespace,status)
         if (status /= 0 ) pseudo%namespace = "no-namespace-specified"

      case ("provenance")
         in_provenance = .true.
         ! This will gather all element provenances at the top level
            allocate(pp)
            if (associated(pseudo%provenance)) then
               qp => pseudo%provenance
               do while (associated(qp%next))
                  qp => qp%next
               enddo
               qp%next => pp
            else
               pseudo%provenance => pp
            endif

            pp%n_input_files = 0
            
            call get_value(attributes,"creator",pp%creator,status)
            if (status /= 0 ) pp%creator="unknown"
 
            call get_value(attributes,"date",pp%date,status)
            if (status /= 0 ) pp%date="unknown"

            ! Support the optional attribute 'record-number'.
            ! SAX will keep the order. In this parser we require
            ! that the records be in the right order in the file.
            ! (Check performed at the end of parsing)
            ! Other parsers (e.g. DOM) might need to worry about
            ! internal ordering
            pp%record_number = 0
            call get_value(attributes,"record-number",value,status)
            if (status == 0 ) then
               read(unit=value,fmt=*) pp%record_number
            endif
            
      case ("input-file")
         if (.not. in_provenance) call die("<input-file> outside <provenance>")
         in_input_file = .true.
         pp%n_input_files = pp%n_input_files + 1
         ifp => pp%input_file
         call get_value(attributes,"name",ifp%name,status)
         if (status /= 0 ) ifp%name="unknown"
         
      case ("header", "pseudo-atom-spec")
         in_header = .true.
         hp => pseudo%header
         
         call get_value(attributes,"atomic-label",hp%atomic_label,status)
         if (status /= 0 ) call die("Cannot determine atomic-label")

         call get_value(attributes,"z-pseudo",value,status)
         if (status /= 0 ) call die("Cannot determine z-pseudo")
         read(unit=value,fmt=*) hp%zpseudo

         call get_value(attributes,"atomic-number",value,status)
         if (status /= 0 ) call die("Cannot determine atomic number")
         read(unit=value,fmt=*) hp%z

         call get_value(attributes,"flavor",hp%flavor,status)
         if (status /= 0 ) hp%flavor=""  ! empty string signals absence

         call get_value(attributes,"relativity",hp%relativity,status)
         if (status /= 0 ) call die("Cannot determine relativity scheme")

         call get_value(attributes,"spin-dft",value,status)
         if (status /= 0 ) then  ! Check v1.0 form
            call get_value(attributes,"polarized",value,status)
            if (status /= 0 ) value = "no"
         endif
         hp%polarized = (value == "yes")
         if (hp%polarized .and. trim(hp%relativity)=="dirac") then
            call die("Cannot be polarized and fully relativistic at the same time")
         endif

         call get_value(attributes,"core-corrections", &
                                    hp%core_corrections,status)
         if (status /= 0 ) hp%core_corrections = "no"
         ! Check yes/no value??

         call get_value(attributes,"meta-gga", &
                                    hp%meta_gga,status)
         if (status /= 0 ) hp%meta_gga = "no"
         ! Check yes/no value??
         
      case ("exchange-correlation")
         in_xc = .true.
         xp => pseudo%xc_info

      case ("libxc-info")
         if (.not. in_xc) call die("Orphan <libxc-info>")
         in_libxc_info = .true.
         call get_value(attributes,"number-of-functionals", &
                                    value,status)
         if (status /= 0 ) call die("Error reading number of libxc functs")
         read(unit=value,fmt=*)  xp%n_functs_libxc 
         n_funct = xp%n_functs_libxc
         allocate(xp%libxc_name(n_funct), xp%libxc_id(n_funct))
         allocate(xp%libxc_weight(n_funct),xp%libxc_type(n_funct))
         xp%libxc_weight(1:n_funct) = 1.0_dp
         xp%libxc_type(1:n_funct) = "UNKNOWN"

         n_funct = 0   ! for checking the counting on the fly

      case ("functional")
         if (.not. in_libxc_info) call die("Orphan <functional>")
         n_funct = n_funct + 1
         if (n_funct > xp%n_functs_libxc) &
           call die("Too many <functional> elements in <libxc-info>")

         call get_value(attributes,"name", &
                                    xp%libxc_name(n_funct),status)
         if (status /= 0 ) call die("Error reading libxc name")

         call get_value(attributes,"id", value, status)
         if (status /= 0 ) call die("Error reading libxc id")
         read(unit=value,fmt=*)  xp%libxc_id(n_funct) 

         ! optional attribute(s)
         call get_value(attributes,"weight", value, status)
         if (status == 0 ) then
            read(unit=value,fmt=*)  xp%libxc_weight(n_funct) 
         endif
         call get_value(attributes,"type", value, status)
         if (status == 0 ) then
            xp%libxc_type(n_funct)  = trim(value)
         endif

      case ("valence-configuration")
         in_valence_config = .true.

         pseudo%config_val%nshells = 0
         pseudo%config_val%occ_up(:) = 0.0_dp
         pseudo%config_val%occ_down(:) = 0.0_dp
         pseudo%config_val%occ(:) = 0.0_dp
         call get_value(attributes,"total-valence-charge",value,status)
         if (status /= 0 ) call die("Cannot determine total-valence-charge")
         read(unit=value,fmt=*) pseudo%config_val%total_charge

      case ("shell")

         if (in_valence_config) then
            cp => pseudo%config_val
!         else if (in_core_config) then
!            cp => pseudo%config_core
         else
            call die("Orphan <shell> element")
         endif

         cp%nshells = cp%nshells + 1
         call get_value(attributes,"l",cp%l(cp%nshells),status)
         if (status /= 0 ) call die("Cannot determine l for shell")

         call get_value(attributes,"n",value,status)
         if (status /= 0 ) call die("Cannot determine n for shell")
         read(unit=value,fmt=*) cp%n(cp%nshells)

         call get_value(attributes,"occupation",value,status)
         if (status /= 0 ) call die("Cannot determine occupation for shell")
         read(unit=value,fmt=*) cp%occ(cp%nshells)

         call get_value(attributes,"occupation-up",value,status)
         if (status == 0 ) then
            read(unit=value,fmt=*) cp%occ_up(cp%nshells)
         endif
         call get_value(attributes,"occupation-down",value,status)
         if (status == 0 ) then
            read(unit=value,fmt=*) cp%occ_down(cp%nshells)
         endif

      case ("slps")
         in_slps = .true.
         if (.not. in_semilocal) call die("Orphan <slps> element")
         allocate(slvp)

         ! Append to end of list  !! call append(slp%pot,slvp)
         if (associated(slp%pot)) then
            qslvp => slp%pot
            do while (associated(qslvp%next))
               qslvp => qslvp%next
            enddo
            qslvp%next => slvp
         else
            !First link
            slp%pot => slvp
         endif

         rp => slvp%V

         slvp%parent_group => slp   ! current semilocal-potentials element
         
         call get_value(attributes,"set",value,status)
         if (status /= 0 ) then
            value = current_sl_set
         endif
         slvp%set = setcode_of_string(value)

         call get_value(attributes,"l",slvp%l,status)
         if (status /= 0 ) call die("Cannot determine l for SL potential")

         call get_value(attributes,"n",value,status)
         if (status /= 0 ) call die("Cannot determine n for SL potential")
         read(unit=value,fmt=*) slvp%n

         call get_value(attributes,"rc",value,status)
         if (status /= 0 ) call die("Cannot determine rc for SL potential")
         read(unit=value,fmt=*) slvp%rc

         call get_value(attributes,"j",value,status)
         if (status /= 0 ) then
            if (slvp%set == SET_LJ) &
                 call die("Cannot determine j for SLPS in set " // str_of_set(SET_LJ))
         else
            read(unit=value,fmt=*) slvp%j
         endif

         slvp%eref = huge(1.0_dp)  ! Signal absence of eref attribute
         call get_value(attributes,"eref",value,status)
         if (status == 0 ) then
            read(unit=value,fmt=*) slvp%eref
         endif

         call get_value(attributes,"flavor",slvp%flavor,status)
         if (status /= 0 ) then
            slvp%flavor = top_flavor
         endif

         ! Encode the behavior beyond the range
         ! The only current possibility is to have
         ! a Coulomb tail, or zero.

         select case (slvp%set)
         case (SET_SO, SET_SPINDIFF)
            rp%has_coulomb_tail = .false.
         case default
            rp%has_coulomb_tail = .true.
            rp%tail_factor = -pseudo%header%zpseudo
         end select


      case ("proj")
         in_proj = .true.
         if (.not. in_nonlocal) call die("Orphan <proj> element")
         allocate(nlpp)
         
         ! Append to end of list  !! call append(nlp%proj,nlpp)
         if (associated(nlp%proj)) then
            qnlpp => nlp%proj
            do while (associated(qnlpp%next))
               qnlpp => qnlpp%next
            enddo
            qnlpp%next => nlpp
         else
            !First link
            nlp%proj => nlpp
         endif

         rp => nlpp%proj
         rp%has_coulomb_tail = .false.
         nlpp%parent_group => nlp   ! current nonlocal-projectors element

         call get_value(attributes,"set",value,status)
         if (status /= 0 ) then
            value = current_proj_set
         endif
         nlpp%set = setcode_of_string(value)

         call get_value(attributes,"l",nlpp%l,status)
         if (status /= 0 ) call die("Cannot determine l for proj")

         call get_value(attributes,"seq",value,status)
         if (status /= 0 ) call die("Cannot determine seq number for proj")
         read(unit=value,fmt=*) nlpp%seq

         call get_value(attributes,"ekb",value,status)
         if (status /= 0 ) call die("Cannot determine Ekb for proj")
         read(unit=value,fmt=*) nlpp%ekb

         nlpp%eref = huge(1.0_dp)  ! Signal absence of eref attribute
         call get_value(attributes,"eref",value,status)
         if (status == 0 ) then
            read(unit=value,fmt=*) nlpp%eref
         endif

         call get_value(attributes,"j",value,status)
         if (status /= 0 ) then
            if (nlpp%set == SET_LJ) &
                 call die("Cannot determine j for Proj in set " // str_of_set(SET_LJ))
         else
            read(unit=value,fmt=*) nlpp%j
         endif

         call get_value(attributes,"type",nlpp%type,status)
         if (status /= 0 ) call die("Cannot determine type of proj")

      case ("pswf")

         if (.not. in_pseudowavefun) call die("Orphan <pswf> element")
         in_pswf = .true.

         allocate(wfpp)
         
         ! Append to end of list  !! call append(wfp%proj,wfpp)
         if (associated(wfp%wf)) then
            qwfpp => wfp%wf
            do while (associated(qwfpp%next))
               qwfpp => qwfpp%next
            enddo
            qwfpp%next => wfpp
         else
            !First link
            wfp%wf => wfpp
         endif

         rp => wfpp%Phi
         rp%has_coulomb_tail = .false.
         wfpp%parent_group => wfp   ! current nowfocal-projectors element

         call get_value(attributes,"set",value,status)
         if (status /= 0 ) then
            value = current_wf_set
         endif
         wfpp%set = setcode_of_string(value)

         call get_value(attributes,"l",wfpp%l,status)
         if (status /= 0 ) call die("Cannot determine l for wf")

         call get_value(attributes,"n",value,status)
         if (status /= 0 ) call die("Cannot determine n for wf")
         read(unit=value,fmt=*) wfpp%n

         call get_value(attributes,"j",value,status)
         if (status /= 0 ) then
            if (wfpp%set == SET_LJ) &
                 call die("Cannot determine j for wf in set " // str_of_set(SET_LJ))
         else
            read(unit=value,fmt=*) wfpp%j
         endif

         wfpp%energy_level = huge(1.0_dp)
         call get_value(attributes,"energy_level",value,status)
         if (status == 0 ) then
            read(unit=value,fmt=*) wfpp%energy_level
         endif


      case ("grid")
         in_grid = .true.

         got_explicit_grid_data = .false.

         ! This attribute is mandatory
         call get_value(attributes,"npts",value,status)
         if (status /= 0 ) call die("Cannot determine grid npts")
         read(unit=value,fmt=*) npts
         if (npts == 0) call die("Grid size not specified correctly")

         ! Create working object and associate inner sections
         ! while the parsing is active
         call newGrid(tmp_grid,npts)
         gdata => valGrid(tmp_grid)
         gannot => annotationGrid(tmp_grid)
         !
         ! In this way we allow for a private grid for each radfunc,
         ! or for a global grid specification
         !
         if (in_radfunc) then
            if (debug_parsing) print *, "Found grid in radfunc"
            if (initialized(rp%grid)) then
               call die("psml: Two grids specified for a radfunc")
            endif
            rp%grid = tmp_grid

         ! We check whether we are at the top level,
         ! or at an intermediate grouping level that allows a grid

         else if (in_nonlocal) then

            if (initialized(nlp%grid)) then
                call die("psml: Two grids in same nonlocal block")
            endif
            if (debug_parsing) print *, "Found nonlocal grid"
            nlp%grid = tmp_grid

         else if (in_local_potential) then

            if (initialized(lop%grid)) then
                call die("psml: Two grids in same local block")
            endif
            if (debug_parsing) print *, "Found local grid"
            lop%grid = tmp_grid

         else if (in_semilocal) then

            if (initialized(slp%grid)) then
                call die("psml: Two grids in same semilocal block")
            endif
            if (debug_parsing) print *, "Found semilocal grid"
            slp%grid = tmp_grid

         else if (in_pseudowavefun) then

            if (initialized(wfp%grid)) then
               !call die("psml: Two pseudo-wavefunction grids specified")
            endif
            if (debug_parsing) print *, "Found pseudo-wavefunction grid"
            wfp%grid = tmp_grid

         else  ! We are at the top level

            if (debug_parsing) print *, "Found grid at the top level"
            if (initialized(pseudo%global_grid)) then
               ! Maybe allow this in the future
               call die("psml: Two global grids specified")
            endif
            pseudo%global_grid = tmp_grid
         endif

      case ("data")
         if (.not. in_radfunc) then
            call die("<data> element outside <rad_func> element")
         endif
         in_data = .true.


	 ! The following blocks are a bit more verbose than needed since
         ! the Intel compiler seems to be trying to evaluate all the
         ! clauses joined by an .and. operator, instead of stopping if
         ! the first clause is .false.
       
         if (.not. initialized(rp%grid)) then

            ! Try regional grids first

            if (in_nonlocal) then
               if (initialized(nlp%grid)) then
                  rp%grid = nlp%grid
                  if (debug_parsing) print *,"Associated proj grid with nl parent grid"
               endif
            else if (in_local_potential) then
               if (initialized(lop%grid)) then
                  rp%grid = lop%grid
                  if (debug_parsing) print *,"Associated grid with vlocal parent grid"
               endif
            else if (in_semilocal) then
               if (initialized(slp%grid)) then
                  rp%grid = slp%grid
                  if (debug_parsing) print *,"Associated slps grid with sl parent grid"
               endif
            else if (in_pseudowavefun) then
               if (initialized(wfp%grid)) then
                  rp%grid = wfp%grid
               endif
            endif

         endif

         ! If the parent block does not include a grid, try the global grid

         if (.not. initialized(rp%grid)) then
               if (initialized(pseudo%global_grid)) then
                  rp%grid = pseudo%global_grid
                  if (debug_parsing) print *, "Associated grid with global grid"
               endif
         endif

         ! Now give up
         if (.not. initialized(rp%grid)) call die("Cannot find grid data for radfunc")

         ! This attribute is optional
         ! If present, it determines the actual number of points of the grid used
         ! (for example, for a function of shorter range)
         ! This is an experimental feature that can save space
         ! (if implemented correctly!!!)
         
         call get_value(attributes,"npts",value,status)
         if (status == 0 ) then
            read(unit=value,fmt=*) npts_data
            if (npts_data > sizeGrid(rp%grid)) call die("data npts too big")
         else
            npts_data = sizeGrid(rp%grid)
         endif

         allocate(rp%data(npts_data))
         ndata = 0             ! To start the build up

      case ("grid-data")
         if (.not. in_grid) call die("Grid_data element outside grid element")
         in_grid_data = .true.
         got_explicit_grid_data = .true.
         if (size(gdata) == 0) call die("Grid npts attribute faulty")
         ndata_grid = 0             ! To start the build up

      case ("radfunc")

         ! We need to make sure that a radfunc is allowed at this level
         ! 
         ! For example, if an old-style file with <vps> is used, the finding
         ! of a <vps> element will not increase npots, and there will be a
         ! segmentation fault when trying to store the data in the rp pointer,
         ! which would be non-associated if the vps section is the first
         ! case of radfuncs in the file
         !
         ! Actually, it gets worse: if there is a <core-charge> element
         ! before the old-style <vps> section, the rp pointer used for 
         ! core-charge will be reused and assigned the data for the first
         ! and subsequent vps elements.
         !
         if (     in_slps .or. in_coreCharge .or. in_valenceCharge &
              .or. in_valenceKE .or. in_coreKE  &
              .or. in_pswf .or. in_proj .or. in_local_potential  &
              .or. in_chlocal) then           
            in_radfunc = .true.
         else
            call die("<radfunc> element found under unallowed <"// &
                     trim(parent_element) // ">")
         endif

      case ("pseudocore-charge")
         in_coreCharge = .true.
         corep => pseudo%core_charge
         rp => corep%rho_core
         rp%has_coulomb_tail = .false.

         call get_value(attributes,"matching-radius",value,status)
         if (status == 0 )  then
            read(unit=value,fmt=*) corep%rcore
         else
            ! Signal absence of attribute with a negative number
            corep%rcore = -1.0_dp
         endif
                                                                              
         call get_value(attributes,"number-of-continuous-derivatives", &
                                   value,status)
         if (status == 0 )  then
            read(unit=value,fmt=*) corep%n_cont_derivs
         else
            ! Signal absence of attribute with a negative number
            corep%n_cont_derivs = -1
         endif

      case ("valence-charge")
         in_valenceCharge = .true.
         valp => pseudo%valence_charge
         rp => valp%rho_val
         rp%has_coulomb_tail = .false.
         
         call get_value(attributes,"total-charge",value,status)
         if (status /= 0 ) call die("Cannot determine total valence charge")
         read(unit=value,fmt=*) valp%total_charge

         call get_value(attributes,"is-unscreening-charge",&
            valp%is_unscreening_charge,status)
         if (status /= 0 ) valp%is_unscreening_charge = ""
         
         call get_value(attributes,"rescaled-to-z-pseudo",&
            valp%rescaled_to_z_pseudo,status)
         if (status /= 0 ) valp%rescaled_to_z_pseudo = ""
         
      case ("valence-kinetic-energy-density")
         in_valenceKE = .true.
         valKEp => pseudo%valence_kinetic_energy_density
         rp => valKEp%kin_edens_val
         rp%has_coulomb_tail = .false.
         
         call get_value(attributes,"is-unscreening-tau",&
            valKEp%is_unscreening_tau,status)
         if (status /= 0 ) valKEp%is_unscreening_tau = ""
         

      case ("pseudocore-kinetic-energy-density")
         in_coreKE = .true.
         coreKEp => pseudo%core_kinetic_energy_density
         rp => coreKEp%kin_edens_core
         rp%has_coulomb_tail = .false.
         
         call get_value(attributes,"matching-radius",value,status)
         if (status == 0 )  then
            read(unit=value,fmt=*) coreKEp%rcore
         else
            ! Signal absence of attribute with a negative number
            coreKEp%rcore = -1.0_dp
         endif
                                                                              
         call get_value(attributes,"number-of-continuous-derivatives", &
                                   value,status)
         if (status == 0 )  then
            read(unit=value,fmt=*) coreKEp%n_cont_derivs
         else
            ! Signal absence of attribute with a negative number
            coreKEp%n_cont_derivs = -1
         endif

      case ("semilocal-potentials")
         in_semilocal = .true.
         allocate(slp)
         
         if (associated(pseudo%semilocal)) then
            qslp => pseudo%semilocal
            do while (associated(qslp%next))
               qslp => qslp%next
            enddo
            qslp%next => slp
         else
            pseudo%semilocal => slp
         endif
            
         current_sl_set = "invalid"
         slp%set = SET_NULL
         call get_value(attributes,"set",value,status)
         if (status == 0 ) then
            current_sl_set = value
            slp%set = setcode_of_string(value)
         endif
         if (debug_parsing) print *, "Found semilocal-potentials set: ", trim(current_sl_set)

         top_flavor = pseudo%header%flavor
         call get_value(attributes,"flavor",value,status)
         if (status == 0 ) then
            top_flavor = value
         endif


      case ("nonlocal-projectors")
         in_nonlocal = .true.

	 ! Allocate new node and add to the end of the linked list
         allocate(nlp)

         if (associated(pseudo%nonlocal)) then
            qnlp => pseudo%nonlocal
            do while (associated(qnlp%next))
               qnlp => qnlp%next
            enddo
            qnlp%next => nlp
         else
            pseudo%nonlocal => nlp
         endif

         current_proj_set = "invalid"
         nlp%set = SET_NULL
         call get_value(attributes,"set",value,status)
         if (status == 0 ) then
            current_proj_set = value
            nlp%set = setcode_of_string(value)
         endif
         if (debug_parsing) print *, "Found nonlocal-projectors set: ", trim(current_proj_set)
         nlp%set = setcode_of_string(value)

      case ("local-potential")
         in_local_potential = .true.
         lop => pseudo%local
         rp => lop%vlocal
         rp%has_coulomb_tail = .true.
         rp%tail_factor = -pseudo%header%zpseudo
         
         call get_value(attributes,"type",lop%vlocal_type,status)
         if (status /= 0 ) call die("Cannot determine type of local potential")
                                                                              
      case ("local-charge")
         if (.not. in_local_potential) call die("<local-charge> outside <local-potential>")
         in_chlocal = .true.
         lop => pseudo%local
         rp => lop%chlocal
         rp%has_coulomb_tail = .false.
         
         ! Future expansion: chlocal attributes
                                                                              
      case ("pseudo-wave-functions")
         in_pseudowavefun = .true. 

	 ! Allocate new node and add to the end of the linked list
         allocate(wfp)

         if (associated(pseudo%wavefunctions)) then
            qwfp => pseudo%wavefunctions
            do while (associated(qwfp%next))
               qwfp => qwfp%next
            enddo
            qwfp%next => wfp
         else
            pseudo%wavefunctions => wfp
         endif

         current_wf_set = "invalid"
         wfp%set = SET_NULL
         call get_value(attributes,"set",value,status)
         if (status == 0 ) then
            current_wf_set = value
            wfp%set = setcode_of_string(value)
         endif
         if (debug_parsing) print *, "Found wavefunctions set: ", trim(current_wf_set)
         wfp%set = setcode_of_string(value)

         !! Optional
         call get_value(attributes,"type",value,status)
         if (status == 0 ) wfp%type=trim(value)



      case ("annotation")
         ! Deeper elements first...
         if (in_xc) then
            call save_annotation(attributes,xp%annotation)
         else if (in_valence_config) then
            call save_annotation(attributes,cp%annotation)
         else if (in_header) then
            call save_annotation(attributes,hp%annotation)
         else if (in_provenance) then
            call save_annotation(attributes,pp%annotation)
         else if (in_grid) then
            call save_annotation(attributes,gannot)
         else if (in_semilocal) then
            call save_annotation(attributes,slp%annotation)
         else if (in_nonlocal) then
            call save_annotation(attributes,nlp%annotation)
         else if (in_local_potential) then
            call save_annotation(attributes,lop%annotation)
         else if (in_pseudowavefun) then
            call save_annotation(attributes,wfp%annotation)
         else if (in_valenceCharge) then
            call save_annotation(attributes,valp%annotation)
         else if (in_coreCharge) then
            call save_annotation(attributes,corep%annotation)
         else if (in_valenceKE) then
            call save_annotation(attributes,valKEp%annotation)
         else if (in_coreKE) then
            call save_annotation(attributes,coreKEp%annotation)
         else if (in_psml) then  ! It must be at the top level
            ! Version 1.0 only. Keep it in the structure
            call save_annotation(attributes,pseudo%annotation)
         else
            ! Do nothing instead of dying
            ! call die("Misplaced <annotation> element")
         endif
                  
end select

parent_element = name

end subroutine begin_element
!----------------------------------------------------------------------

subroutine end_element(name)

character(len=*), intent(in)     :: name

integer :: i, nnz
real(dp) :: Z
real(dp), parameter :: tol = 1.0e-20_dp  !! Scale or other data dependence?
real(dp), pointer :: rg(:)

type(provenance_t), pointer      :: q => null()
integer                          :: depth

if (debug_parsing) print *, "-- end Element: ", trim(name)

select case(name)

      case ("radfunc")
         in_radfunc = .false.
         if (.not. associated(rp%data)) then
            call die("No data for radfunc!")
         endif

         ! Determine the effective range
         ! by skipping over (nearly) zeros
         ! For functions with tail, use r*f
         
         rg => valGrid(rp%grid)
         if (rp%has_coulomb_tail) then
            Z = - rp%tail_factor
            nnz = size(rp%data)
            do while ( approx( (rg(nnz)*rp%data(nnz) + Z),0.0_dp, tol) )
               nnz = nnz - 1
            enddo
         else
            nnz = size(rp%data)
            do while ( approx( rp%data(nnz) ,0.0_dp, tol) )
               nnz = nnz - 1
            enddo
         endif
         
         rp%nnz = nnz
         if (nnz == size(rp%data)) then
            rp%rcut_eff = rg(nnz)
         else
            rp%rcut_eff = rg(nnz+1)
            if (debug_parsing) print "(a,i4,f10.4)",&
                 "Effective npts and range:", nnz+1, rp%rcut_eff
         endif

      case ("grid")
         in_grid = .false.
         !
         if (.not. got_explicit_grid_data) then
            call die("Need explicit grid data!")
         endif
         call delete(tmp_grid)

      case ("data")
      !
      ! We are done filling up the radfunc data
      ! Check that we got the advertised number of items
      !
         in_data = .false.
         if (ndata /= size(rp%data)) then
            call die("npts mismatch in radfunc data")
         endif

      case ("grid-data")
      !
      ! We are done filling up the grid data
      ! Check that we got the advertised number of items
      !
         in_grid_data = .false.
         if (ndata_grid /= size(gdata)) then
            call die("npts mismatch in grid")
         endif
         if (debug_parsing) print *, "Got grid data: ", got_explicit_grid_data

      case ("pseudocore-charge")
         in_coreCharge = .false.

      case ("valence-charge")
         in_valenceCharge = .false.

      case ("pseudocore-kinetic-energy-density")
         in_coreKE = .false.

      case ("valence-kinetic-energy-density")
         in_valenceKE = .false.

      case ("semilocal-potentials")
         in_semilocal = .false.
         slp => null()

      case ("nonlocal-projectors")
         in_nonlocal = .false.
         nlp => null()

      case ("slps")
         in_slps = .false.

      case ("proj")
         in_proj = .false.

      case ("local-potential")
         in_local_potential = .false.
         lop => null()

      case ("local-charge")
         in_chlocal = .false.

      case ("pseudo-wave-functions")
         in_pseudowavefun = .false. 

      case ("pswf")
         in_pswf = .false.

      case ("valence-configuration")
         in_valence_config = .false.

      case ("exchange-correlation")
         in_xc = .false.

      case ("libxc-info")
         in_libxc_info = .false.
         if (n_funct /= xp%n_functs_libxc) &
            call die("Too few <functional> elements in <libxc-info>")

      case ("provenance")
         in_provenance = .false.

      case ("input-file")
         in_input_file = .false.
         
      case ("header", "pseudo-atom-spec")  ! v1.0, v1.1
         in_header = .false.

      case ("psml")
         in_psml = .false.
         !
         ! Check provenance elements
         !
         ! First, determine how many there are
         depth = 0
         q => pseudo%provenance
         do while (associated(q))
            depth = depth + 1
            q => q%next
         enddo
         !
         ! Assign record numbers. For now, we
         ! require that the records are ordered in the file
         !
         q => pseudo%provenance
         do while (associated(q))
            ! A value of zero means that there is no (optional) record number
            if ( (q%record_number /= 0) .and. &
                 (q%record_number /= depth)) then
               call die("Provenance records out of order")
            endif
            q%record_number = depth
            q => q%next
            depth = depth - 1
         enddo

end select

end subroutine end_element
!----------------------------------------------------------------------

subroutine pcdata_chunk(chunk)

  use xmlf90_sax, only: build_data_array
  
character(len=*), intent(in) :: chunk

if (len_trim(chunk) == 0) RETURN     ! skip empty chunk

if (in_data) then
!
! Note that we know where we need to put it through the pointer rp...
!
      call build_data_array(chunk,rp%data,ndata)

else if (in_grid_data) then
!
!     Fill the explicit grid data pointer
      call build_data_array(chunk,gdata,ndata_grid)

else if (in_input_file) then

      call safe_str_assign(ifp%buffer,ifp%buffer // chunk)
   
else if (in_header) then
      !
      ! There should not be any pcdata in header in this version...

!      print *, "Header data:"
!      print *, trim(chunk)

endif

end subroutine pcdata_chunk
!
subroutine cdata_section_chunk(chunk)
  
character(len=*), intent(in) :: chunk

if (len_trim(chunk) == 0) RETURN     ! skip empty chunk

if (in_input_file) then
   call safe_str_assign(ifp%buffer,ifp%buffer // chunk)
endif

end subroutine cdata_section_chunk
!----------------------------------------------------------------------

     ! Annotations are encoded as an association list
     ! in a couple of arrays
     ! ( (key "value") (key "value") ...)
     ! 
subroutine save_annotation(atts,annotation)
  use m_psml_assoc_list, ps_annotation_t => assoc_list_t
  use xmlf90_sax, only: dictionary_t, get_value, get_key, len

       type(dictionary_t), intent(in) :: atts
       type(ps_annotation_t), intent(out) :: annotation
       
       integer :: n, i, status
       character(len=300) :: key, value

       n = len(atts)
       call assoc_list_init(annotation,n,status)
       if (status /= 0) call die("Failed to init annotation object")
       do i = 1, n
          call get_key(atts,i,key,status)
          if (status /= 0) call die("cannot get key in atts dict")
          call get_value(atts,i,value,status)
          if (status /= 0) call die("cannot get value in atts dict")
          call assoc_list_insert(annotation,key,value,status)
          if (status /= 0) call die("Failed to insert annotation pair")
       enddo
     end subroutine save_annotation

     function approx(x,y,tol) result (is_close)
       real(dp), intent(in) :: x, y
       real(dp), intent(in) :: tol
       logical              :: is_close
       
       is_close = abs(x-y) < tol
     end function approx
     
end module m_psml_parsing_helpers

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

module m_psml_external_interfaces
  !
  interface
     ! Called to terminate the program, printing a message
     subroutine psml_die_interf(str)
       character(len=*), intent(in)   :: str
     end subroutine psml_die_interf
  end interface

  ! This initialization to non-null() is a F2008 feature
  procedure(psml_die_interf),pointer ::   &
      psml_die => simple_die_routine

  public :: psml_die
  public :: psml_die_interf
  public :: set_die_routine

CONTAINS

  subroutine set_die_routine(func)

    procedure(psml_die_interf) :: func

    psml_die => func

  end subroutine set_die_routine

  subroutine simple_die_routine(str)
    character(len=*), intent(in)   :: str
    write(0,'(a,a)') "[libpsml default error handler]: " // trim(str)
    write(6,'(a,a)') "[libpsml default error handler]: " // trim(str)
    write(6,'(a)') "Use ps_set_error_handler(custom_handler) to configure"
    stop
  end subroutine simple_die_routine

end module m_psml_external_interfaces

module m_psml_strings_helpers
  !
  ! A safe (re)allocator for character variables that will work even
  ! if compiler flags such as -fno-realloc-lhs are used
  !
  ! Rationale:
  !
  ! Allocatable character variables are a great addition to the
  ! language, but the automatic allocation feature (e.g. ' string =
  ! "Mary had a lamb"') might be inhibited if the compiler is told to
  ! avoid these kinds of allocations (for example, for performance
  ! reasons)
  !
  ! call safe_str_assign(string,"Mary had a lamb")
  !
  ! will work, and so will
  !
  ! call safe_str_assign(string, string // " in the farm")
  !
  ! The second argument is handled correctly by the compiler without any attempt
  ! at allocation, and treated as a character variable with the proper length.
  !
  ! NOTE: The 'len' intrinsic (and not 'len_trim') is used below for generality.
  
  public :: safe_str_assign

CONTAINS
  
  subroutine safe_str_assign(a,val)
    character(len=:), allocatable :: a
    character(len=*) :: val

    integer :: size
    
    size = len(val)
    if (allocated(a)) deallocate(a)
    allocate(character(size) :: a)
    a = val
    
  end subroutine safe_str_assign

end module m_psml_strings_helpers

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

module m_psml

!
  use m_psml_reader, only: psml_reader 

  use m_psml_core, only: ps_t, ps_destroy

  use m_psml_core, only: str_of_set
  use m_psml_core, only:     SET_SREL     , &
                             SET_NONREL   , &
                             SET_SO       , &
                             SET_LJ       , &
                             SET_UP       , &
                             SET_DOWN     , &
                             SET_SPINAVE  , &
                             SET_SPINDIFF , &
                             SET_USER1    , &
                             SET_USER2    , &
                             SET_ALL

  ! Temporarily needed for psop
  use m_psml_core, only: nonlocal_t, nlpj_t

  use m_psml_api
  
  use m_psml_dump
  use m_psml_ps_edit

  ! Exported utility types
  use m_psml_core, only: ps_radfunc_t => radfunc_t
  use m_psml_assoc_list, only: ps_annotation_t => assoc_list_t

  use m_psml_assoc_list, only: nitems_annotation => assoc_list_nitems
  use m_psml_assoc_list, only: get_annotation_key => assoc_list_get_key
  use m_psml_assoc_list, only: get_annotation_value => assoc_list_get_value
  use m_psml_assoc_list, only: insert_annotation_pair => assoc_list_insert
  use m_psml_assoc_list, only: init_annotation => assoc_list_init
  use m_psml_assoc_list, only: reset_annotation => assoc_list_reset
  use m_psml_assoc_list, only: print_annotation => assoc_list_print
  use m_psml_assoc_list, only: EMPTY_ANNOTATION => EMPTY_ASSOC_LIST 

  use m_psml_external_interfaces, only: ps_set_error_handler => &
                                 set_die_routine
 
  ! Remove common names from namespace
  use m_psml_class_Grid, dummy_id => id, dummy_name => name

  ! Export precision of real numbers used
  
  integer, public, parameter :: ps_real_kind = selected_real_kind(10,100)

end module m_psml

! The PSML library calls a "psml_die" procedure pointer when it encounters
! an error. The procedure pointer can be made to point to a given error handler
! by calling the 'ps_set_error_handler' routine.

! The handler should take care of carrying out any needed cleaning and
! terminating the program.  As the details would vary with the client
! program, each program should provide its own and call the
! 'ps_set_error_handler' routine.
! 
! This is an example implementation that could be used for serial programs.

subroutine custom_psml_die(str)
  character(len=*), intent(in) :: str

  write(0,"(a,a)") "Custom psml_die:: ", str
  write(6,"(a,a)") "Custom psml_die:: ", str
  STOP

end subroutine custom_psml_die

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

module m_psml_interp

! Default quality parameter for interpolator
integer, public, save                  :: nq = 7

! This is the interface that the interpolators
! must have
interface
   subroutine interpolate(nquality,x,y,npts,r,val,debug)

     integer, parameter :: dp = selected_real_kind(10,100)

     integer, intent(in)  :: nquality  ! Quality parameter
     real(dp), intent(in) :: x(*), y(*)
     integer, intent(in)  :: npts    ! Size of x, y arrays
     real(dp), intent(in) :: r
     real(dp), intent(out):: val
     logical, intent(in) :: debug
   end subroutine interpolate
end interface

! 
procedure(interpolate),pointer, public ::  &
                       interpolator => null()
!
! Note that initialization of procedure pointers at declaration
! is a f2008 feature not yet supported by some compilers...
!                       interpolator => dpnint1

public :: set_interpolator, set_default_interpolator
private :: dpnint1

CONTAINS

subroutine set_interpolator(func,nquality)

! Parameter for interpolator's quality
! It might mean different things for different
! interpolators
integer, intent(in) :: nquality

! We should not need to repeat this...
interface
   subroutine func(nquality,x,y,npts,r,val,debug)

     integer, parameter :: dp = selected_real_kind(10,100)

     integer, intent(in)  :: nquality  ! Quality parameter
     real(dp), intent(in) :: x(*), y(*)
     integer, intent(in)  :: npts    ! Size of x, y arrays
     real(dp), intent(in) :: r
     real(dp), intent(out):: val
     logical, intent(in) :: debug
   end subroutine func
end interface

  interpolator => func
  nq = nquality

end subroutine set_interpolator

!
! This routine is needed to work around f2008 issue above
!
subroutine set_default_interpolator()

! Default interpolator and quality parameter
! DRH's dpnint modified by AG, at 7th order
! (Included in this module with permission)
!
  call set_interpolator(dpnint1,7)

end subroutine set_default_interpolator

!
! Copyright (c) 1989-2014 by D. R. Hamann, Mat-Sim Research LLC and Rutgers
! University
! 
! Modified by Alberto Garcia, March 2015
! This routine is included in this module with permission from D.R. Hamann.
!
 subroutine dpnint1(npoly, xx, yy, nn, r, val, debug)

! Modified by Alberto Garcia, March 2015 from routine
! dpnint by D.R. Hamann. 
! Changes:
!   -- A single value is returned
!   -- It can extrapolate, instead of stopping,
!      when called with an abscissa outside the
!      data range.
!   -- If the number of data points is less than
!      npoly+1, npoly is implicitly reduced, without
!      error, and without warning.
!   -- Debug interface 
!
! local polynomial interpolation of data yy on nn points xx
! giving value val on point r
! npoly sets order of polynomial
! xx must be ordered in ascending order
! output interpolated value val on point r

 implicit none

 integer, parameter :: dp=kind(1.0d0)

!Input variables
 real(dp), intent(in) :: xx(*),yy(*)
 real(dp), intent(in) :: r
 real(dp), intent(out) :: val
 integer, intent(in)   ::  nn,npoly
 logical, intent(in)   ::  debug

!Local variables
 real(dp) :: sum,term,zz
 integer ii,imin,imax,iprod,iy,istart,kk,iend

! interval halving search for xx(ii) points bracketing r

   imin = 1
   imax = nn
   do kk = 1, nn
     ii = (imin + imax) / 2
     if(r>xx(ii)) then
       imin = ii
     else
       imax = ii
     end if
     if(imax - imin .eq. 1) then
       exit
     end if
   end do


   zz=r

!   if (debug) print *, "imin, imax: ", imin, imax

   if(mod(npoly,2)==1) then
    istart=imin-npoly/2
   else if(zz-xx(imin) < xx(imax)-zz) then
     istart=imin-npoly/2
   else
     istart=imax-npoly/2
   end if

   istart = min(istart, nn - npoly)
   istart = max(istart, 1)
   iend = min(istart+npoly,nn)

 !  if (debug) print *, "istart, iend: ", istart, iend
   sum=0.0d0
   do iy=istart,iend
    if(yy(iy)==0.0d0) cycle
    term=yy(iy)
    do iprod=istart, iend
     if(iprod==iy) cycle
     term=term*(zz-xx(iprod))/(xx(iy)-xx(iprod))
    end do
    sum=sum+term
   end do
   val=sum

 end subroutine dpnint1

end module m_psml_interp

!
! Copyright (c) 1989-2014 by D. R. Hamann, Mat-Sim Research LLC and Rutgers
! University
! 
!
! 
! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <http://www.gnu.org/licenses/>.
!
! subroutine dpnint(npoly, xx, yy, nn, r, val, debug)
 subroutine interpolate_drh(npoly, xx, yy, nn, r, val, debug)

! Modified by Alberto Garcia, March 2015 for test purposes
! Incorporated into this code with permission from D.R. Hamann
   
! local polynomial interpolation of data yy on nn points xx
! giving value val on point r
! npoly sets order of polynomial
! xx must be ordered in ascending order
! output interpolated value val on point r

 implicit none

 integer, parameter :: dp=kind(1.0d0)

!Input variables
 real(dp), intent(in) :: xx(*),yy(*)
 real(dp), intent(in) :: r
 real(dp), intent(out) :: val
 integer, intent(in)   ::  nn,npoly
 logical, intent(in)   ::  debug

!Local variables
 real(dp) :: sum,term,zz
 integer ii,imin,imax,iprod,iy,istart,kk

 if(nn<npoly+1) then
   write(6,'(/a,i6,a,i4)') 'dp3int: interpolation error, n=', &
&       nn,'< npoly=',npoly
   stop
 end if

!!$   if(r<xx(1)) then
!!$     write(6,'(/a)') 'dp3int: interpolation error - out of range'
!!$!     stop
!!$   end if
!!$   if(r>xx(nn)) then
!!$     write(6,'(/a)') 'dp3int: interpolation error - out of range'
!!$!     stop
!!$   end if

! interval halving search for xx(ii) points bracketing r

   imin = 1
   imax = nn
   do kk = 1, nn
     ii = (imin + imax) / 2
     if(r>xx(ii)) then
       imin = ii
     else
       imax = ii
     end if
     if(imax - imin .eq. 1) then
       exit
     end if
   end do


   zz=r

!!   if (debug) print *, "imin, imax: ", imin, imax

   if(mod(npoly,2)==1) then
    istart=imin-npoly/2
   else if(zz-xx(imin) < xx(imax)-zz) then
     istart=imin-npoly/2
   else
     istart=imax-npoly/2
   end if

   istart = min(istart, nn - npoly)
   istart = max(istart, 1)

!!   if (debug) print *, "istart, iend: ", istart, istart+npoly
   sum=0.0d0
   do iy=istart,istart+npoly
    if(yy(iy)==0.0d0) cycle
    term=yy(iy)
    do iprod=istart, istart+npoly
     if(iprod==iy) cycle
     term=term*(zz-xx(iprod))/(xx(iy)-xx(iprod))
    end do
    sum=sum+term
   end do
   val=sum

 end subroutine interpolate_drh

!> Functions to handle PSML pseudopotential format structures
!!
!! (Table generators)
!> @author Alberto Garcia
!
#if defined HAVE_CONFIG_H
#include "config.h"
#endif

module m_psml_tables

use m_psml_core   ! For basic structures

implicit none

public :: ps_GenerateTables

private

CONTAINS !===============================================


!-------------------------------------
subroutine generate_table_sl(ps)

  type(ps_t), intent(inout), target :: ps

  type(semilocal_t), pointer :: slp
  type(slps_t), pointer :: slvp

  integer :: npots

  if (allocated(ps%sl_table)) then
     deallocate(ps%sl_table)
  endif

  npots = 0
  slp => ps%semilocal
  do while (associated(slp))
     slvp => slp%pot
     do while (associated(slvp))
        npots = npots + 1
        slvp => slvp%next
     enddo
     slp => slp%next
  enddo

  allocate(ps%sl_table(npots))
  
  npots = 0
  slp => ps%semilocal
  do while (associated(slp))
     slvp => slp%pot
     do while (associated(slvp))
        npots = npots + 1
        ps%sl_table(npots)%p => slvp
        slvp => slvp%next
     enddo
     slp => slp%next
  enddo

end subroutine generate_table_sl

!-------------------------------------
subroutine generate_table_nl(ps)

  type(ps_t), intent(inout), target :: ps

  type(nonlocal_t), pointer :: nlp
  type(nlpj_t), pointer :: nlpp

  integer :: nprojs

  if (allocated(ps%nl_table)) then
     deallocate(ps%nl_table)
  endif

  nprojs = 0
  nlp => ps%nonlocal
  do while (associated(nlp))
     nlpp => nlp%proj
     do while (associated(nlpp))
        nprojs = nprojs + 1
        nlpp => nlpp%next
     enddo
     nlp => nlp%next
  enddo

  allocate(ps%nl_table(nprojs))
  
  nprojs = 0
  nlp => ps%nonlocal
  do while (associated(nlp))
     nlpp => nlp%proj
     do while (associated(nlpp))
        nprojs = nprojs + 1
        ps%nl_table(nprojs)%p => nlpp
        nlpp => nlpp%next
     enddo
     nlp => nlp%next
  enddo

end subroutine generate_table_nl

!------------------------------------

subroutine generate_table_wf(ps)

  type(ps_t), intent(inout), target :: ps

  type(wfns_t), pointer :: wfp
  type(wf_t), pointer   :: wfpp

  integer :: nwfns

  if (allocated(ps%wf_table)) then
     deallocate(ps%wf_table)
  endif

  nwfns = 0
  wfp => ps%wavefunctions
  do while (associated(wfp))
     wfpp => wfp%wf
     do while (associated(wfpp))
        nwfns = nwfns + 1
        wfpp => wfpp%next
     enddo
     wfp => wfp%next
  enddo

  allocate(ps%wf_table(nwfns))
  
  nwfns = 0
  wfp => ps%wavefunctions
  do while (associated(wfp))
     wfpp => wfp%wf
     do while (associated(wfpp))
        nwfns = nwfns + 1
        ps%wf_table(nwfns)%p => wfpp
        wfpp => wfpp%next
     enddo
     wfp => wfp%next
  enddo

end subroutine generate_table_wf

subroutine ps_GenerateTables(ps)

  type(ps_t), intent(inout), target :: ps

  call generate_table_sl(ps)
  call generate_table_nl(ps)
  call generate_table_wf(ps)

end subroutine ps_GenerateTables

end module m_psml_tables

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

module m_psml_class_Grid

  use m_psml_assoc_list, only: ps_annotation_t => assoc_list_t
  use m_psml_assoc_list, only: ps_clean_annotation => assoc_list_reset

  use m_psml_external_interfaces, only: psml_die
  
  implicit none

  character(len=*), parameter :: mod_name= "Grid"

  integer, parameter :: dp = selected_real_kind(10,100)

  !
  type Grid_
    integer :: refCount = 0
    character(len=36)   :: id = "null_id"
    !----------------------
    character(len=256)   :: name = "null Grid"
    integer                        :: npts = 0
    real(dp), pointer              :: grid_data(:) => null()
    type(ps_annotation_t)          :: annotation 
  end type Grid_

  type Grid
    type(Grid_), pointer :: data => null()
  end type Grid

  public  :: newGrid, print_type, valGrid, annotationGrid, sizeGrid

  interface print_type
    module procedure printGrid
  end interface

!========================
#define TYPE_NAME Grid
#define OBJ_ERR_HANDLER psml_die
#include "basic_type.inc"
!========================

     subroutine delete_Data(gd)
      type(Grid_) :: gd
      if (associated(gd%grid_data)) then
         deallocate(gd%grid_data)
         gd%grid_data => null()
      endif
      call ps_clean_annotation(gd%annotation)
     end subroutine delete_Data


  subroutine newGrid(this,n,name)

   type(Grid), intent(inout)  :: this
   integer, intent(in)        :: n
   character(len=*), intent(in), optional  :: name

   integer :: stat

   ! We release the previous incarnation
   ! This means that we relinquish access to the previous
   ! memory location. It will be deallocated when nobody
   ! else is using it.

   call init(this)

   if (present(name)) then
      this%data%name = trim(name)
   else
      this%data%name = "(Grid from n)"
   endif

   allocate(this%data%grid_data(n))

   call tag_new_object(this)

  end subroutine newGrid

  function valGrid(this) result(p)
   type(Grid), intent(in)  :: this
   real(dp), pointer       :: p(:)

   nullify(p)
   p => this%data%grid_data
 end function valGrid

  function annotationGrid(this) result(p)
   type(Grid), intent(in)         :: this
   type(ps_annotation_t) , pointer   :: p

   nullify(p)
   p => this%data%annotation
 end function annotationGrid

 function sizeGrid(this) result(n)
   type(Grid), intent(in)  :: this
   integer                 :: n

   if (.not. initialized(this)) then
      n = 0
   else
      n = size(this%data%grid_data)
   endif
 end function sizeGrid

 subroutine printGrid(this)
   type(Grid), intent(in)  :: this

    integer :: n, m

   if (.not. associated(this%data)) then
      print "(a)", "Grid Not Associated"
      RETURN
   endif

    n = size(this%data%grid_data)

   print "(a,i0,a,i0,a,i0,a)", "  <grid:" // trim(this%data%name) // &
                               " n=",  n,   &
                               ", refcount: ", refcount(this),">"
 end subroutine printGrid

end module m_psml_class_Grid

! The PSML library calls a "die" routine when it encounters
! an error. This routine should take care of carrying out any
! needed cleaning and terminating the program.
! As the details would vary with the client program, each program
! has to provide its own.
! 
! This is an example implementation that could be used for serial programs.

subroutine psml_die(str)
  character(len=*), intent(in) :: str

  write(0,"(a)") trim(str)
  stop

end subroutine psml_die

  !+ graph: false
  !+ author: Alberto Garcia

  !+ Data structures to handle the PSML pseudopotential format.

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

module m_psml_core

use m_psml_assoc_list, only: ps_annotation_t => assoc_list_t
use m_psml_assoc_list, only: ps_clean_annotation => assoc_list_reset
use m_psml_class_Grid

use m_psml_external_interfaces, only: die => psml_die

implicit none

private

!
! Update this. Up to 99...
integer, parameter    :: PATCH_LEVEL = 0
!
! Only update 1000 when changing major/minor version
integer, parameter, public  :: PSML_LIBRARY_VERSION = 2000 + PATCH_LEVEL
!
!  Simple sanity checks while the format evolves
!  This version is able to read v1.0 and v1.2 PSML files
!
!  Note that the version is really given by the generators.
!
! The "hi" value is intended to auto-revoke the library, but
! it is neither completely foolproof nor flexible enough.
!
real, parameter, public  :: PSML_TARGET_VERSION_LO = 1.00
real, parameter, public  :: PSML_TARGET_VERSION_HI = 1.20

!----------------------------------------------------------------
! Hardwired parameters (to be made dynamical in a later version)

! Maximum number of valence shells (including semicore) or core shells:
integer, parameter, private    :: MAXN_SHELLS = 20
!----------------------------------------------------------------

integer, parameter, private    :: dp = selected_real_kind(14)
!
!-----------------------------------------------------------

type, public :: input_file_t
        character(len=100)            :: name = "-----"
        character(len=:), allocatable :: buffer
end type input_file_t

!------
type, public :: provenance_t
   type(provenance_t), pointer  :: prev  => null()
        integer                 :: record_number
        character(len=100)      :: creator = "-----"
        character(len=60)       :: date    = "-----"
        integer                 :: n_input_files = 0  ! Max 1 for now !!
        type(input_file_t)      :: input_file
        type(ps_annotation_t)   :: annotation
   type(provenance_t), pointer  :: next => null()
end type provenance_t
!------
type, public :: header_t
   ! This is the 'pseudo-atom-spec' section
   
        character(len=100)      :: atomic_label    !! generalized symbol
        real(kind=dp)           :: z  !! atomic number (might be non-integer)
        real(kind=dp)           :: zpseudo !! Z - ncore-electrons
        character(len=100)      :: flavor  !! pseudization method
        character(len=6)        :: relativity !! "no|scalar|dirac"
        logical                 :: polarized !! is spin-DFT?
        !
        character(len=3)        :: core_corrections !! are there NLCC's?
        character(len=3)        :: meta_gga         !! includes kinetic-energy-densities?
      !
      type(ps_annotation_t)   :: annotation
end type header_t
!------
type, public :: config_val_t
      integer                          :: nshells
      real(kind=dp)                    :: total_charge
      integer, dimension(MAXN_SHELLS)  :: n
      character(len=1), dimension(MAXN_SHELLS) :: l
      real(dp), dimension(MAXN_SHELLS) :: occ
      real(dp), dimension(MAXN_SHELLS) :: occ_up
      real(dp), dimension(MAXN_SHELLS) :: occ_down
      !
      type(ps_annotation_t)   :: annotation
end type config_val_t
!------
type, public :: xc_t
        integer                         :: n_functs_libxc = 0
        character(len=200), allocatable :: libxc_name(:)
        character(len=100), allocatable :: libxc_type(:)
        integer, allocatable            :: libxc_id(:)
        real(dp), allocatable           :: libxc_weight(:)
        type(ps_annotation_t)           :: annotation
end type xc_t
!------
type, public :: radfunc_t
      type(Grid)                              :: grid
      real(kind=dp), dimension(:), pointer    :: data => null()
      logical                                 :: has_coulomb_tail
      real(dp)                                :: tail_factor = 0.0_dp
      integer                                 :: nnz ! # of 'non-zero' values
      real(dp)                                :: rcut_eff ! effective end of range
 
end type radfunc_t      
!
!===============================================
type, public :: slps_t
      integer           :: n
      character(len=1)  :: l
      real(dp)          :: j = -1.0_dp
      integer           :: set
      character(len=100):: flavor
      real(dp)          :: rc
      real(dp)          :: eref  ! Reference energy
      type(radfunc_t)   :: V
      type(semilocal_t), pointer :: parent_group => null()
   type(slps_t), pointer :: next => null()

end type slps_t

type, public :: sl_table_t
   type(slps_t), pointer :: p => null()
end type sl_table_t

type, public :: semilocal_t
   type(slps_t), pointer :: pot => null()
   integer           :: set
   !
   ! Optional private grid
   !
   type(Grid)             :: grid
   type(ps_annotation_t)  :: annotation
   !
   type(semilocal_t), pointer     :: next => null()

end type semilocal_t
!===============================================

type, public :: local_t
   !
      type(ps_annotation_t)                     :: annotation

   ! Optional private grid
   !
      type(Grid)                               :: grid

      type(radfunc_t)                          :: Vlocal
      character(len=100)                       :: vlocal_type

      type(radfunc_t)                          :: Chlocal
end type local_t

!===============================================
type, public :: nlpj_t
      integer           :: seq
      character(len=1)  :: l
      real(dp)          :: j = -1.0_dp
      integer           :: set
      character(len=100):: type
      real(dp)          :: ekb
      real(dp)          :: eref  ! Reference energy
      type(radfunc_t)   :: proj

      type(nonlocal_t), pointer :: parent_group => null()
   type(nlpj_t), pointer :: next => null()

end type nlpj_t

type, public :: nl_table_t
   type(nlpj_t), pointer :: p => null()
end type nl_table_t

type, public :: nonlocal_t
   type(nlpj_t), pointer :: proj => null()
   integer           :: set
   !
   ! Optional private grid
   !
   type(Grid)                               :: grid
   type(ps_annotation_t)  :: annotation
   !
   type(nonlocal_t), pointer     :: next => null()

end type nonlocal_t
!===============================================
! Wavefunctions
!
type, public :: wf_t
      integer           :: n
      character(len=1)  :: l
      integer           :: set
      real(dp)          :: j = -1.0_dp
      real(dp)          :: energy_level
      type(radfunc_t)   :: Phi
      type(wfns_t), pointer :: parent_group => null()
   type(wf_t), pointer :: next => null()

end type wf_t

type, public :: wf_table_t
   type(wf_t), pointer :: p => null()
end type wf_table_t

type, public :: wfns_t
   type(wf_t), pointer :: wf => null()
   integer             :: set
   character(len=100)  :: type = ""
   !
   ! Optional private grid
   !
   type(Grid)             :: grid
   type(ps_annotation_t)  :: annotation
   !
   type(wfns_t), pointer     :: next => null()

end type wfns_t

type, public :: valence_charge_t
      real(dp)        :: total_charge
      character(len=3):: is_unscreening_charge = ""
      character(len=3):: rescaled_to_z_pseudo  = ""

      type(radfunc_t) :: rho_val
      type(ps_annotation_t)   :: annotation
end type valence_charge_t

type, public :: core_charge_t
      integer         :: n_cont_derivs
      real(dp)        :: rcore
      type(radfunc_t) :: rho_core

      type(ps_annotation_t)           :: annotation
end type core_charge_t

! MGGA  ---
type, public :: valence_kinetic_energy_density_t  ! valence-kinetic-energy-density
      character(len=3):: is_unscreening_tau = ""
      type(radfunc_t) :: kin_edens_val
      type(ps_annotation_t)   :: annotation
end type valence_kinetic_energy_density_t

type, public :: core_kinetic_energy_density_t
      integer         :: n_cont_derivs
      real(dp)        :: rcore

      type(radfunc_t) :: kin_edens_core

      type(ps_annotation_t)           :: annotation
end type core_kinetic_energy_density_t
! ----

type, public :: ps_t
!! Main derived type to hold the PSML information
      character(len=10)                  :: version     = ""
      character(len=40)                  :: energy_unit = ""
      character(len=40)                  :: length_unit = ""
      character(len=36)                  :: uuid = ""
      character(len=200)                 :: namespace = ""
      type(ps_annotation_t)              :: annotation   ! V1.0 only
      type(provenance_t), pointer        :: provenance => null()
      type(header_t)                     :: header     ! pseudo-atom-spec
      type(config_val_t)                 :: config_val
      type(config_val_t)                 :: config_core  ! extension
      type(xc_t)                         :: xc_info
      type(Grid)                         :: global_grid
      type(local_t)                      :: local
      type(semilocal_t), pointer         :: semilocal => null()
      type(nonlocal_t), pointer          :: nonlocal => null()
      type(wfns_t), pointer              :: wavefunctions => null()
      !
      type(valence_charge_t)             :: valence_charge
      type(core_charge_t)                :: core_charge
      !
      type(valence_kinetic_energy_density_t)  :: valence_kinetic_energy_density
      type(core_kinetic_energy_density_t)     :: core_kinetic_energy_density
      !
      ! index tables
      !
      type(sl_table_t), allocatable      :: sl_table(:)
      type(nl_table_t), allocatable      :: nl_table(:)
      type(wf_table_t), allocatable      :: wf_table(:)

   end type ps_t

   integer,  parameter, public   &
                          :: SET_NULL     =   0, &
                             SET_SREL     =   1, &
                             SET_NONREL   =   2, &
                             SET_SO       =   4, &
                             SET_LJ       =   8, &
                             SET_UP       =  16, &
                             SET_DOWN     =  32, &
                             SET_SPINAVE  =  64, &
                             SET_SPINDIFF = 128, &         ! 2^7
                             SET_USER1    = 256, &         ! 2^8
                             SET_USER2    = 512            ! 2^9

   integer, parameter, public    :: SET_ALL =  2**10 -1

 public  :: ps_destroy
 public  :: str_of_set

 public  :: setcode_of_string    ! utility function, not for client normal use

 public  :: destroy_local
 public  :: destroy_nonlocal
 public  :: destroy_wavefunctions
 
 CONTAINS

subroutine ps_destroy(ps)
!! Cleans the ps object
type(ps_t), intent(inout)     :: ps

integer :: i

call ps_clean_annotation(ps%annotation)

call destroy_provenance(ps%provenance)

call ps_clean_annotation(ps%header%annotation)
call ps_clean_annotation(ps%config_val%annotation)
call ps_clean_annotation(ps%config_core%annotation)
call destroy_xc(ps%xc_info)
!
! Note that freshly declared objects must have
! npots = 0 and npswfs = 0 !
!
call destroy_semilocal(ps%semilocal)
call destroy_nonlocal(ps%nonlocal)
!
call destroy_local(ps%local)
!
call destroy_wavefunctions(ps%wavefunctions)
!
call destroy_radfunc(ps%valence_charge%rho_val)
call ps_clean_annotation(ps%valence_charge%annotation)
!
call destroy_radfunc(ps%core_charge%rho_core)
call ps_clean_annotation(ps%core_charge%annotation)

call destroy_radfunc(ps%valence_kinetic_energy_density%kin_edens_val)
call ps_clean_annotation(ps%valence_kinetic_energy_density%annotation)
!
call destroy_radfunc(ps%core_kinetic_energy_density%kin_edens_core)
call ps_clean_annotation(ps%core_kinetic_energy_density%annotation)
!
call delete(ps%global_grid)

end subroutine ps_destroy

subroutine destroy_provenance(p)
type(provenance_t), pointer :: p

type(provenance_t), pointer :: q

do while (associated(p))
   call ps_clean_annotation(p%annotation)
   ! clean buffers for input files?
   q => p%next
   deallocate(p)
   p => q
enddo

end subroutine destroy_provenance

!==================================================
subroutine destroy_semilocal(p)
type(semilocal_t), pointer :: p

type(semilocal_t), pointer :: q

do while (associated(p))
   call ps_clean_annotation(p%annotation)
   call destroy_slps(p%pot)
   call delete(p%grid)
   q => p%next
   deallocate(p)
   p => q
enddo

end subroutine destroy_semilocal
!
subroutine destroy_slps(p)
type(slps_t), pointer :: p

type(slps_t), pointer :: q

do while (associated(p))
   call destroy_radfunc(p%V)
   q => p%next
   deallocate(p)
   p => q
enddo

end subroutine destroy_slps
!==================================================
subroutine destroy_local(p)
  type(local_t)  :: p
  
call ps_clean_annotation(p%annotation)
call delete(p%grid)
call destroy_radfunc(p%vlocal)
call destroy_radfunc(p%chlocal)
end subroutine destroy_local
!==================================================
subroutine destroy_nonlocal(p)
type(nonlocal_t), pointer :: p

type(nonlocal_t), pointer :: q

do while (associated(p))
   call ps_clean_annotation(p%annotation)
   call destroy_nlpj(p%proj)
   call delete(p%grid)
   q => p%next
   deallocate(p)
   p => q
enddo

end subroutine destroy_nonlocal
!
subroutine destroy_nlpj(p)
type(nlpj_t), pointer :: p

type(nlpj_t), pointer :: q

do while (associated(p))
   call destroy_radfunc(p%proj)
   q => p%next
   deallocate(p)
   p => q
enddo

end subroutine destroy_nlpj
!
!==================================================
subroutine destroy_wavefunctions(p)
type(wfns_t), pointer :: p

type(wfns_t), pointer :: q

do while (associated(p))
   call ps_clean_annotation(p%annotation)
   call destroy_pswf(p%wf)
   call delete(p%grid)
   q => p%next
   deallocate(p)
   p => q
enddo

end subroutine destroy_wavefunctions
subroutine destroy_pswf(p)
type(wf_t), pointer :: p

type(wf_t), pointer :: q

do while (associated(p))
   call destroy_radfunc(p%Phi)
   q => p%next
   deallocate(p)
   p => q
enddo

end subroutine destroy_pswf

!==================================================
subroutine destroy_radfunc(rp)
type(radfunc_t) :: rp

call delete(rp%grid)
if (associated(rp%data)) then
   deallocate(rp%data)
   rp%data => null()
endif
end subroutine destroy_radfunc

!
subroutine destroy_xc(xp)
type(xc_t), intent(inout) :: xp

if (allocated(xp%libxc_name)) deallocate(xp%libxc_name)
if (allocated(xp%libxc_type)) deallocate(xp%libxc_type)
if (allocated(xp%libxc_id)) deallocate(xp%libxc_id)
if (allocated(xp%libxc_weight)) deallocate(xp%libxc_weight)
call ps_clean_annotation(xp%annotation)

end subroutine destroy_xc

function setcode_of_string(str) result(code)
       character(len=*), intent(in) :: str
       integer                      :: code

       select case (trim(str))
       case ("non_relativistic")
          code = SET_NONREL
       case ("scalar_relativistic")
          code = SET_SREL
       case ("spin_orbit")
          code = SET_SO
       case ("lj")
          code = SET_LJ
       case ("spin_up")
          code = SET_UP
       case ("spin_down")
          code = SET_DOWN
       case ("spin_average")
          code = SET_SPINAVE
       case ("spin_difference")
          code = SET_SPINDIFF
       case ("user_extension1")
          code = SET_USER1
       case ("user_extension2")
          code = SET_USER2
       case ("all","any")
          code = SET_ALL
       case ("invalid","INVALID")
          code = SET_NULL
       case default
          call die("Wrong set string: "//trim(str))
       end select

end function setcode_of_string

function str_of_set(code) result(str)
       integer, intent(in)          :: code
       character(len=40)            :: str

       character(len=100) :: msg

       select case (code)
       case (SET_NONREL)
          str ="non_relativistic"
       case (SET_SREL)
          str ="scalar_relativistic"
       case (SET_SO)
          str ="spin_orbit"
       case (SET_LJ)
          str ="lj"
       case (SET_UP)
          str ="spin_up"
       case (SET_DOWN)
          str ="spin_down"
       case (SET_SPINAVE)
          str ="spin_average"
       case (SET_SPINDIFF)
          str ="spin_difference"
       case (SET_USER1)
          str ="user_extension1"
       case (SET_USER2)
          str ="user_extension2"
       case (SET_ALL)
          str ="all"
       case (SET_NULL)
          str ="invalid"
       case default
          write(msg,"(a,i4)") "Wrong set code: ", code
          call die(msg)
       end select

end function str_of_set

end module m_psml_core

#!/bin/sh
#
# Copyright (C) 2010 Yann Pouillon
#
# This file is part of the LibPSML software package. For license information,
# please see the COPYING file in the top-level directory of the source
# distribution.
#

#
# IMPORTANT NOTE:
#
#   For maintainer use only!
#
#   PLEASE DO NOT EDIT THIS FILE, AS IT COULD CAUSE A SERIOUS LOSS OF DATA.
#   *** YOU HAVE BEEN WARNED! ***
#

# Check that we are in the right directory
if test ! -s "./configure.ac" -o ! -s "src/m_psml.F90"; then
  echo "wipeout: Cowardly refusing to remove something from here!"
  exit 1
fi

# Fix permissions
chmod -R u+w .

# Remove temporary directories and files
echo "Removing temporary directories and files..."
rm -rf tmp*
find . -depth -name 'tmp-*' -exec rm -rf {} \;
find src -name '*.~[0-9]~' -exec rm -f {} \;
echo "done."

# Remove autotools files
echo "Removing autotools files..."
find src -depth -name '.deps' -exec rm -rf {} \;
find src -depth -name '.libs' -exec rm -rf {} \;
find . -name '*.pc' -exec rm {} \;
rm -f core config.log config.status stamp-h1 config.h config.h.in*
rm -rf aclocal.m4 autom4te.cache configure confstat*
(test -e config/gnu && cd config/gnu && rm -f compile config.guess config.sub depcomp install-sh ltmain.sh missing)
(test -e config/m4 && cd config/m4 && rm -f libtool.m4 ltoptions.m4 ltsugar.m4 ltversion.m4 lt~obsolete.m4)
echo "done."

# Remove Makefiles and machine-generated files
echo "Removing generated makefiles and libtool scripts..."
rm -f libtool
find . -name Makefile -exec rm {} \;
find . -name Makefile.in -exec rm {} \;
echo "done."

# Remove object files, libraries and programs
echo "Removing object files, libraries and programs..."
find src -name '*.a' -o -name '*.o' -exec rm {} \;
find src -name '*.la' -o -name '*.lo' -exec rm {} \;
find src -name '*.mod' -exec rm {} \;
find src -name '*.x' -exec rm {} \;
echo "done."

# Remove distribution files
echo "Removing distribution files..."
rm -rf libpsml-[0-9].[0-9].[0-9].[0-9]*
echo "done."

#!/bin/sh

#
# This is not completely kosher. It will find the PSML file
# only if the "build" directory is a first-level subdirectory of the package directory.
# ToDo: use the proper auto-xxx variables.
#
./show_psml -p ../../examples/mgga.psml

#!/bin/sh
#
#  Run 'show_psml' on a file in 'plot' mode to generate
#  a log file and data files in a 'test_output' directory.
#  Its contents can be compared with those of 'reference_output'
#  to check the installation.
#
#  This script must be run in the (Building Directory)/examples directory,
#  after compilation of the example programs (see the installation
#  instructions):
#
#            sh run_test.sh
#
echo
echo "Running installation test..."
echo
#
if [ -d test_output ]
then
    echo "Directory 'test_output' must be removed"
    exit
fi

mkdir -p test_output
cd test_output
../show_psml -p ../Ba.sc-ionic-siesta-vnl.psml > Ba.sc-ionic-siesta-vnl.show
cd ..
#
echo "Test output in 'test_output'"
echo "Compare to contents of 'reference_output'"
echo "You might want to use 'diff -rq test_output reference_output'"

title: Developer Notes

# Abstract types

* The main type of the library is [[ps_t(type)]].

* The `ps_annotation_t` type is actually an alias for [[assoc_list_t]].

* The `ps_radfunc_t` type is actually an alias for [[m_psml_core(module):radfunc_t(type)]]

title: Overview

Several well-known programs generate pseudopotentials in a variety of
formats, tailored to the needs of electronic-structure codes. While
some generators are now able to output data in different bespoke
formats, and some simulation codes are now able to read different
pseudopotential formats, the common historical pattern in the design
of those formats has been that a generator produced data for a single
particular simulation code, most likely maintained by the same
group. This implied that a number of implicit assumptions, shared by
generator and user, have gone into the formats and fossilized there.

This leads to practical problems, not only of programming, but of
interoperability and reproducibility, which depend on spelling out
quite a number of details which are not well represented for all codes
in existing formats.

PSML (for PSeudopotential Markup Language) is a file format for
norm-conserving pseudopotential data which is designed to encapsulate
as much as possible the abstract concepts in the domain's ontology,
and to provide appropriate metadata and provenance information.

The software library libPSML can be used by electronic structure codes
to transparently extract the information in a PSML file and adapt it
to their own data structures, or to create converters for other
formats.

A full description of PSML and its design principles has been published
in:

* The psml format and library for norm-conserving pseudopotential
  data curation and interoperability,  
  by Alberto García, Matthieu J. Verstraete, Yann Pouillon, and Javier Junquera  
 [Comput. Phys. Comm., 227 (2018) 51–71](https://doi.org/10.1016/j.cpc.2018.02.011)
    

A preprint is also available in [arXiv](https://arxiv.org/abs/1707.08938).

* [PSML description](./01_the_psml_format/index.html)
* [libPSML user guide](./02_library_user_guide/index.html)

title: Annotations

XML provides for built-in extensibility and client programs can use as
much or as little information as needed. For the actual mapping of a
domain ontology to a XML-based format, however, clients and producers
have to agree on the terms used. What has been described in the above
sections is a minimal form of such a mapping, containing the basic
concepts and functions needed. The extension of the format with new
fixed-meaning elements and attributes would involve an updated schema
and re-coding of parsers and other programs. A more light-weight
solution to the extensibility issue is provided by the use of
`annotations`, which have the morphology of XML empty elements
(containing only attributes) but can appear in various places and
contain arbitrary key-value pairs. Annotations provide immediate
information to human readers of the PSML files, and can be
exploited informally by client programs to extract additional
information. For the latter use, it is clear that some degree of
permanence and agreed meaning should be given to annotations, but this
task falls not on some central authority, but on specific codes.

As an example, the following snippet of a PSML file shows an annotation in the 
`pseudo-atom-spec` element:

```xml
<pseudo-atom-spec atomic-label="La" atomic-number="57" z-pseudo="11"
 flavor="Hamann&apos;s oncvpsp" relativity="scalar" spin-dft="no"
 core-corrections="no">
<annotation pseudo-energy="-31.7585823482" cutoff_hint_low="38"
 cutoff_hint_normal="39" cutoff_hint_high="47" />
<exchange-correlation>
<annotation oncvpsp-xc-code="3"
 oncvpsp-xc-type="LDA -- Ceperley-Alder Perdew-Zunger" />
<libxc-info number-of-functionals="2">
<functional name="Slater exchange (LDA)" type="exchange" id="1" />
<functional name="Perdew &amp; Zunger (LDA)" type="correlation" id="9" />
</libxc-info>
</exchange-correlation>
<valence-configuration total-valence-charge="11">
<shell n="5" l="s" occupation="2" />
<shell n="5" l="p" occupation="6" />
<shell n="5" l="d" occupation="2" />
<shell n="6" l="s" occupation="1" />
</valence-configuration>
</pseudo-atom-spec>
```

Plane-wave codes might want to exploit the energy cutoff hints given
in the annotation, perhaps using a `plugin routine` that identifies
the generator program and its version and extracts the hints in the
appropriate manner. These plugin routines might be stored (and
properly maintained) in a repository to which both the owners of the
generator programs and the owners of the client programs can
contribute. Some chosen plugins might also be distributed with the
libPSML library itself, to serve as examples and templates.

Annotations are currently allowed within the following elements:

* `provenance`
* `pseudo-atom-spec`
* `exchange-correlation`
* `valence-configuration`
* `core-configuration`
* `semilocal-potentials`
* `local-potential`
* `nonlocal-projectors`
* `pseudo-wave-functions`
* `valence-charge`
* `core-charge`
* `grid`

Top-level annotations are not allowed. They properly
belong in the `provenance` elements.

title: PSML description

PSML is a file format for norm-conserving
pseudopotential data which is designed to encapsulate as much as
possible the concepts in the domain’s ontology. For example,
the format, together with its supporting processing library, offers a
very good approximation to an abstract mathematical function (an object
which produces a value from its input). PSML also provides a rich
set of metadata to document the provenance (i.e., the generation
history) and the generation conditions and flavor of the
pseudopotential. The format is based on XML, and it is by
nature extensible, offering a basic set of elements and a number of
extra features that can be exploited for sophisticated uses or future
improvements.

As first steps in the implementation of the PSML vision, we have modified two
different atomic pseudopotential generation codes to generate PSML
files, and interfaced libPSML to two electronic-structure programs.

Example PSML files can be found in the `examples` directory of the
libPSML distribution, and also in the [databases](./databases.html) of
pseudopotentials that support the format.

* [Pseudopotential generators supporting PSML](./01_generators/index.html)
* [First-principles codes able to read PSML files](./02_clients/index.html)
* [Schema for PSML v1.2](./schema.html)
* [Schema for PSML v1.1](./schema-1.1.html)
* [Databases of PSML files](./databases.html)

title: First-principles codes able to read PSML files

On the client side, we have incorporated the libPSML library in SIESTA
and ABINIT. PSML files can then be directly read and processed by these
codes, achieving pseudopotential interoperability.

### SIESTA

The PSML functionality has been available in [SIESTA](https://siesta-project.org) since Version 5.0.

### ABINIT

The [Abinit code](https://www.abinit.org) has been able to process PSML files since Version 8.2.

title: libPSML API

The API for libPSML follows very closely the structure of the schema.

[TOC]

# Exported types

The library exports the opaque types:

* `ps_t`: Main handle for all the libPSML routines. It contains data
  structures resulting from parsing

* `ps_annotation_t`: A handle to deal with the content of
  `<annotation>` elements in the PSML file. More information on
  annotations can be found [here](./annotations.html).

* `ps_radfunc_t`: A handle for the data structures implementing the
  functionality of radial functions, in particular their evaluation.

More information about the associated implementations can be found in
the [developer notes](../../03_library_developer_notes/index.html).

In addition, the library exports the integer parameter `ps_real_kind`
that represents the kind of the real numbers accepted and returned by
the library.

For error handling, the library exports the subroutine
`ps_set_error_handler` that can be used to configure an error
handler. The handler must have as argument a string and should carry
out any needed cleaning up before stopping the program in the
appropriate manner. There is currently no provision for signaling
specific error conditions.

# Parsing

* The routine [[psml_reader(proc)]] (`filename, ps, debug, stat`) parses the PSML file
`filename` and populates the data structures in the handle
`ps`. An optional `debug` argument determines whether the
library issues debugging messages while parsing. An optional `stat` argument will
be set to 0 upon successful return, to -1 if the filename cannot be opened,
and (if using a recent version of xmlf90), to -2 if there is a XML parsing error.

* [[ps_destroy(proc)]] (`ps`) is a low-level routine provided for
completeness in cases where a pristine `ps` is needed for further
use.

# Library identification

* The function [[ps_GetLibPSMLVersion(proc)]] returns the version as
    an integer (for example: 1106) instead of the typical dot form
    (1.1.6).

# Data accessors

The API follows closely the element structure of the PSML format. Each
section in the high-level document structure of the
[schema](../../01_the_psml_format/schema.html) is mapped to a group of
routines in the API. Within each, there are routines to query any
internal structure (attributes, existence, number, or selection of
child elements) and routines to obtain specific data items
(attributes, content of child elements).

## Root attributes and namespace

The namespace and the attributes of the root element
```python
default namespace = "http://esl.cecam.org/PSML/ns/1.1"

Root.Attributes =  attribute energy_unit { "hartree" }
                 , attribute length_unit { "bohr" }
                 , attribute uuid { xsd:NMTOKEN }
                 , attribute version { xsd:decimal }
```

are read by the routine [[ps_RootAttributes_Get(proc)]]
(`ps,uuid,version,namespace`).  As in all the routines that follow, the
handle `ps` is mandatory. All other arguments are optional, with
`intent(out)`, and of type `character(len=*)`. The
argument version returns the PSML version of the file being
processed. A given version of the library is able to process files
with lower version numbers, up to a limit.

## Provenance data
```python
Provenance =  element provenance {
                attribute record-number { xsd:positiveInteger }?
              , attribute creator { xsd:string }
              , attribute date { xsd:string }
      
              , Annotation?
	      , InputFile*    # zero or more input files
              }
	      
InputFile =  element input-file {
               attribute name { xsd:NMTOKEN }, # No spaces or commas allowed
               text
             }
```
As there can be several `<provenance>` elements, the API provides a
function to enquire about their number (depth of provenance
information), and a routine to get the information from a given level:

* [[ps_Provenance_Depth(proc)]] (`ps`)  result(`depth`)

* [[ps_Provenance_Get(proc)]] (`ps,level,creator,date,annotation,number_of_input_files`)

  The integer argument `level` selects the provenance depth level (1
  is the deepest, or older, so to get the latest record the routine
  should be called with level=depth as returned from the previous
  routine). All other arguments are optional with
  intent(out). `creator` and `date` are strings. Here and in what
  follows, [annotation](./annotations.html) arguments are of the
  opaque type `ps_annotation_t`.  If there is no annotation, an empty
  structure is returned.
  
## Pseudo-atom specification attributes and annotation

```python
PseudoAtomSpec.Attributes = 
       attribute atomic-label { xsd:NMTOKEN },
       attribute atomic-number { xsd:double },
       attribute z-pseudo { xsd:double },
       attribute core-corrections { "yes" | "no" },
       attribute meta-gga { "yes" | "no" }?,
       attribute relativity { "no" | "scalar" | "dirac" },
       attribute spin-dft { "yes" | "no" }?,
       attribute flavor { xsd:string }?
```

* [[ps_PseudoAtomSpec_Get(proc)]] (`ps, atomic_symbol,
  atomic_label, atomic_number, z_pseudo,
  pseudo_flavor, relativity, spin_dft, core_corrections, meta_gga, annotation`)

  The arguments `spin_dft`, `core_corrections`, and `meta_gga` are boolean,
  and the routine returns an empty string in `flavor` if the
  attribute is not present (recall that `flavor` is a cascading
  attribute that can be set at multiple levels).
  

### Valence configuration
```python
ValenceConfiguration =  element valence-configuration {
                          attribute total-valence-charge { xsd:double },
	                  Annotation?,
                          ValenceShell+
                        }

ValenceShell =   Shell

Shell =  element shell {
           attribute_l,
           attribute_n,
           attribute occupation { xsd:double },
           attribute occupation-up { xsd:double }?,
           attribute occupation-down { xsd:double }?
         }

attribute_l = attribute l { "s" | "p" | "d" | "f" | "g" }
attribute_n = attribute n { "1" | "2" | "3" | "4" | "5" | "6" | "7" | "8" | "9" }
```

* [[ps_ValenceConfiguration_Get(proc)]] (`ps,nshells,charge,annotation`)

  This routine returns (as always, in optional arguments), the
  values of the top-level attributes, any annotation, and the number of
  `Shell` elements, which serves as upper limit for the index
  `i` in the following routine, which extracts shell information:
  
* [[ps_ValenceShell_Get(proc)]] (`ps,i,n,l,occupation,occ_up,occ_down`)

  The `n` and `l` quantum number arguments are integers
  (despite the use of spectroscopic symbols for the angular momentum
  in the format), and the occupations real.
  
### Exchange and correlation

```python
ExchangeCorrelation =  element exchange-correlation {
                         Annotation?
                         , element libxc-info {
                              attribute number-of-functionals { xsd:positiveInteger },
                              LibxcFunctional+
                           }
                        }

LibxcFunctional =   element functional {
                      attribute id { xsd:positiveInteger },
                      attribute name { xsd:string },
                      attribute weight { xsd:double }?,

                      # allow canonical names and libxc-style symbols
	      
                      attribute type { "exchange" | "correlation" | "exchange-correlation" |
	                               "XC_EXCHANGE" | "XC_CORRELATION" |
		  	                  "XC_EXCHANGE_CORRELATION" }?
                    }
```

The routines follow the same structure as those in the previous section.

* [[ps_ExchangeCorrelation_Get(proc)]] (`ps,annotation,n_libxc_functionals`)

* [[ps_LibxcFunctional_Get(proc)]] (`ps,i,name,code,type,weight`)

## Valence and Core Charges

```python
ValenceCharge =  element valence-charge {
                   attribute total-charge { xsd:double },
                   attribute is-unscreening-charge { "yes" | "no" }?,
                   attribute rescaled-to-z-pseudo { "yes" | "no" }?,
                   Annotation?,
                   Radfunc
                 }  
    
# =========
CoreCharge =  element pseudocore-charge {
                attribute matching-radius { xsd:double },
                attribute number-of-continuous-derivatives { xsd:nonNegativeInteger },
                Annotation?,
                Radfunc
              }
```

These are radial functions with some metadata in the form of
attributes, an optional annotation, and a `Radfunc` child. The accessors
have the extra optional argument `func` that returns a handle to
a `ps_radfunc_t` object, which can later be used to get extra
information.

* [[ps_ValenceCharge_Get(proc)]] (`ps,total_charge,
                      is_unscreening_charge, rescaled_to_z_pseudo,
                      annotation,func`)

  The routine returns an emtpy string in `is_unscreening_charge` and
  `rescaled_to_z_pseudo` if the attributes are not present in the
  PSML file. 
  
* [[ps_CoreCharge_Get(proc)]] (`ps,rc,nderivs,annotation,func`)

  `rc` corresponds to the matching radius and `nderivs` to the
  continuity information. Negative values are returned if the
  corresponding attributes are not present in the file.

The `func` object can be used to evaluate the radial functions at
a particular point `r`:

* function [[ps_GetValue(proc)]] (`func,r`) result(`val`)

but the API offers some convenience functions

* function [[ps_ValenceCharge_Value(proc)]] (`ps,r`) result(`val`)
* function [[ps_CoreCharge_Value(proc)]] (`ps,r`) result(`val`)

## Valence and core kinetic-energy density for MGGA

These are work in progress. The relevant routines are

```python
ValenceKineticDensity =  element valence-kinetic-energy-density {
                   attribute is-unscreening-tau { "yes" | "no" }?,
                   Annotation?,
                   Radfunc
                 }  
# =========
CoreKineticDensity =  element pseudocore-kinetic-energy-density {
                attribute matching-radius { xsd:double }?,
                attribute number-of-continuous-derivatives { xsd:nonNegativeInteger }?,
                Annotation?,
                Radfunc
              }

```


* [[ps_ValenceKineticDensity_Get(proc)]] (`is_unscreening_tau,
                      annotation,func`)

  The routine returns an emtpy string in `is_unscreening_tau` 
  if the attribute is not present in the PSML file. 
  
* [[ps_CoreKineticDensity_Get(proc)]] (`ps,rc,nderivs,annotation,func`)

  `rc` corresponds to the matching radius and `nderivs` to the
  continuity information. Negative values are returned if the
  corresponding attributes are not present in the file.

As above, the API offers some convenience functions to get the actual
values as a function of the radial coordinate:

* function [[ps_ValenceKineticDensity_Value(proc)]] (`ps,r`) result(`val`)
* function [[ps_CoreKineticDensity_Value(proc)]] (`ps,r`) result(`val`)

## Local Potential and Local Charge Density

```python
LocalPotential =  element local-potential {
                    attribute type { xsd:string },
                    Annotation?,
                    Grid?,
                    Radfunc,
		    LocalCharge?  # Optional local-charge element
                  }
    
LocalCharge =  element local-charge {
	         Radfunc
	       }
```

* [[ps_LocalPotential_Get(proc)]] (`ps,type,annotation,func,has_local_charge,func_local_charge`)

In this version of the API, the optional `<local-charge>` element is
not given a first-class status. To evaluate it (if the boolean
argument `has_local_charge` is `.true.`), the
`func_local_charge` argument has to be used in the
`ps_GetValue` routine above. The local potential can be
evaluated via the `func` object or with the convenience function 

* function [[ps_LocalPotential_Value(proc)]] (`ps,r`) result(`val`)

## Semilocal potentials

```python
SemiLocalPotentials =  element semilocal-potentials {
                         attribute_set,
                         attribute flavor  { xsd:string }?,
                         Annotation?,
			 Grid?,
                         Potential+
                        }

Potential =   element slps {
                attribute flavor { xsd:string }?,
                attribute_l,
                attribute_j ?,
                attribute_n,
                attribute rc { xsd:double },
                attribute eref { xsd:double }?,
                Radfunc
              }   
```

As explained [here](./sets.html) there can be several
`<semilocal-potentials>` elements corresponding to different
sets. Internally, the data is built up in linked lists during the
parsing stage and later all the data for the `<slps>` child elements
are re-arranged into flat tables, which can be queried like a simple
database. The table indexes for the potentials with
specific quantum numbers, or set membership, can be obtained with
the routine

* [[ps_SemilocalPotentials_Filter(proc)]] (`ps,indexes_in,l,j,n,set,indexes,number`)

    - `indexes_in`: (Optional, in) Initial set of indexes on which to
     perform the filtering operation. If not present, the full table is used.
    - `l,j,n,set`: (Optional, in) Values for filtering criteria.
    - `indexes`: (Optional, out) Set of indexes which satisfy the criteria.
    - `number`: (Optional, out) Number of items which satisfy the criteria.


The `set` argument has to be given using special integer symbols exported
by the API, as explained [here](./sets.html).

The appropriate indexes can then be fed into the following routines to
get specific information:

*  [[ps_Potential_Get(proc)]] (`ps,i,l,j,n,rc,eref,set,flavor,annotation,func`)

  All arguments except `ps` and `i` are optional. The value
  returned in `set` is an integer which can be converted to a
  mnemonic string through the [[str_of_set]] convenience function.
  The `annotation` returned corresponds to the optional `<annotation>`
  element of the parent block of the `<slps>` element.
  
  The routine returns a very large positive value in `eref` if the
  corresponding attribute is not present in the file.

* function [[ps_Potential_Value(proc)]] (`ps,i,r`) result(`val`)

## Nonlocal Projectors

```python
NonLocalProjectors =  element nonlocal-projectors {
                        attribute_set,
                        Annotation?,
                        Grid?,
	                Projector+
                      }

Projector =   element proj {
                attribute ekb { xsd:double },
                attribute eref { xsd:double }?,
                attribute_l,
                attribute_j ?,
                attribute seq { xsd:positiveInteger },
                attribute type { xsd:string },
                Radfunc
              }+
```

The ideas are exactly the same as for the semilocal potentials. The
relevant routines are:

* [[ps_NonlocalProjectors_Filter(proc)]] (`ps,indexes_in,l,j,seq,set,indexes,number`)

* [[ps_Projector_Get(proc)]] (`ps,i,l,j,seq,set,ekb,eref,type,annotation,func`)

  The routine returns a very large positive value in `eref` if the
  corresponding attribute is not present in the file.
  
* function [[ps_Projector_Value(proc)]] (`ps,i,r`) result(`val`)

## Pseudo Wavefunctions

```python
PseudoWaveFunctions =  element pseudo-wave-functions {
                         attribute_set,
                         Annotation?,
                         Grid?,
                         PseudoWf+
                       }

PseudoWf =  element pswf {
       	      attribute_l,
              attribute_j ?,
              attribute_n,
              attribute energy_level { xsd:double} ?,
              Radfunc
            }
```
Again, the same strategy:

* [[ps_PseudoWavefunctions_Filter(proc)]] (`ps,indexes_in,l,j,set,indexes,number`)
* [[ps_PseudoWf_Get(proc)]] (`ps,i,l,j,n,set,energy_level,annotation,func`)

  The routine returns a very large positive value in `energy_level` if the
  corresponding attribute is not present in the file.

* function [[ps_PseudoWf_Value(proc)]] (`ps,i,r`) result(`val`)


## Radial function and grid information

```python
Radfunc =  element radfunc {
             Grid?,              # Optional grid element
             element data {      
               list { xsd:double+ }       # One or more floating point numbers
             }
           }

Grid =  element grid {
          attribute npts { xsd:positiveInteger },
          Annotation?,
          element grid-data {
                 list { xsd:double+ }   # One or more floating point numbers
          }
        }
```

In keeping with the PSML philosophy of being grid-agnostic, the basic
API does not provide any direct means of accessing the data used in
the tabulation of the radial functions. The values of the functions at
a particular point `r` can be generally obtained through the
`ps_XXXX_Value` interfaces, or through the [[ps_GetValue]]
interface using `func` objects of type `ps_radfunc_t`.

It is nevertheless possible to get annotation data for the grid of a
particular radial function, or for the top-level grid, through the
function

* function [[ps_GridAnnotation(proc)]] (`ps,func`}) result(`annotation`)

  If a radial function handle `func` is given, the annotation for
  that radial function's grid is returned. Otherwise, the return value
  is the annotation for the top-level grid.  

# The evaluation engine

In the current version of the library the evaluation of tabulated
functions is performed by default with polynomial interpolation, using
a slightly modified version of an algorithm borrowed (with permission)
from the [oncvpsp](http://www.mat-simresearch.com) program by
D.R. Hamann.  By default seventh-order interpolation, as in `oncvpsp`,
is used.  If the library is compiled with the appropriate
pre-processor symbols, the interpolator and/or its order can be chosen
at runtime, but we note that this should be considered a debugging
feature. Reproducibility of results would be hampered if client codes
change the interpolation parameters at will. Generator codes should
instead strive to produce data tabulations that will guarantee a given
level of precision when interpolated with the default scheme, using
appropriate output grids on which to sample their internal data
sets. For example, our own work on enabling PSML output in `oncvpsp`
(see below) includes diagnostic tools to check the interpolation
accuracy.

Most codes use internally a non-uniform grid (e.g. logarithmic). We
have found that a good choice of output grid is a subset of the
producer's working grid points that leaves out most of the very close
points near the origin but maintains the rest. This can be achieved by
imposing a minimum inter-point separation $\delta$. This parameter
$\delta$ can be smaller than the typical linear-grid step used
currently by most codes, and still lead to smaller grids (in terms of
number of points) that preserve the accuracy of the output.

High-order interpolation can lead to *ringing* effects
(oscillations of the interpolating polynomial between points), notably
near edge regions when the shape of the function changes
abruptly. This is the case, for example, if the function drops to zero
within the interpolation range as a result of cutting off a tail. The
actual interpolated values will typically be very small, but might cause
undesirable effects in the client code. To avoid this problem, the
libPSML evaluator works internally with an effective end-of-range
that is determined by analyzing the data values after parsing.

If needed for debugging purposes, the evaluator engine can be
configured by the routine:

* [[ps_SetEvaluatorOptions(proc)]] (`quality_level,debug,
  use_effective_range,
  custom_interpolator`)

  All arguments are optional, and apply globally to the operation of
  the library. The `custom_interpolator` argument is not allowed
  if the underlying Fortran compiler does not support procedure
  pointers. `quality_level` (an integer) is by default and will
  typically be the interpolation order, but its meaning can change
  with the interpolator in use. The evaluator uses an effective range
  by default, as discussed above, but this feature can be turned off
  by setting `use_effective_range` to `.false.`. The
  `debug` argument will turn on any extra printing configured in
  the evaluator. By default, no extra printing is produced.
  
Finally, in case it is necessary to look at the raw tabular data for debugging 
purposes, the library also provides a low-level routine:

* [[ps_GetRawData(proc)]] (`func,rg,data`)

  If a radial function handle `func` is given, the grid points
  and the actual tabulated data are returned in `rg` and
  `data`, which must be passed as allocatable arrays.
  
# Predicate routines for contents

The following convenience functions return a logical value. For semi-local
potentials, non-local projectors, and pseudo-wave-functions, the test
is done on the union of all possible sets.

* [[ps_HasSemilocalPotentials]]
* [[ps_HasPsOperator]]
* [[ps_HasLocalPotential]]
* [[ps_HasProjectors]]

# Editing of ps structures

The PSML library has currently limited support for editing the content
of [[ps_t(type)]] objects from user programs. For example, such an
editing might be done by a KB-projector generator to insert a new
provenance record (and KB and local-potential data) in the
`ps` object, prior to dumping to a new PSML file.

* [[ps_RootAttributes_Set(proc)]] (`ps,version,uuid,namespace`)
* [[ps_Provenance_Add(proc)]] (`ps,creator,date,annotation`)

  Annotations can be created using routines exported by the PSML API
  (see below)
  
* [[ps_NonlocalProjectors_Delete(proc)]] (`ps`)
* [[ps_LocalPotential_Delete(proc)]] (`ps`)

# Dump of ps structures

The contents of a (possibly edited) [[ps_t(type)]] object can be dumped
to a PSML file using the routine

* [[ps_DumpToPSMLFile(proc)]] (`ps,fname,indent`)

  Here `fname` is the output file name, and `indent` is a
  logical variable that determines whether automatic indenting of
  elements is turned on (by default it is not).
  
# Annotation API

To support the annotation functionality, the library contains a module
implementing a basic instance of an association list (a data structure
holding key-value pairs), and exports the `ps_annotation_t`
type, the empty annotation object `EMPTY_ANNOTATION` and the following routines:

(The names of these routines are aliases of the originals in the [[assoc_list(module)]] module.)

* reset_annotation (`annotation`)

  Cleans the contents of the `ps_annotation_t` object
  `annotation` so that it can be reused.
  
* insert_annotation_pair (annotation,key,value,stat)

  Inserts the `key, value` pair of string variables in the
  `ps_annotation_t` object `annotation`. Internally, `annotation` can
  grow as much as needed.
  
* function nitems_annotation (`annotation`) result(`nitems`)

  Returns the number of key-value pairs in the annotation object

* get_annotation_value (`annotation,key,value,stat`)
* get_annotation_value (`annotation,i,value,stat`)

  This routine has two interfaces. The first gets the `value`
  associated to the `key`, and the second gets the `value`
  associated to the `i`'th entry in the annotation object.

* get_annotation_key (`annotation,i,key,stat`)
  
  Gets the `key` of the `i`'th entry in the annotation object.
  
  Together with the second form of `get_annotation_value`,
  this routine can be used to scan the complete annotation object. The
  first form of `get_annotation_value` is appropriate if the
  key(s) are known.

In all the above routines a non-zero `stat` signals an error condition.

title: Sets of potentials, projectors, and pseudo-wave-functions

A given pseudopotential-generator code might offer several possible
levels of theory, and output different sets of magnitudes accordingly.

The `set` attribute in several API routines allows the handling of
various sets of semilocal pseudopotentials, projectors, and
pseudo-wave-functions. Its value is normalized as follows, depending
on the type of calculation generating the pseudopotential and the way
in which the code chooses to present the results. (First, the symbolic
name used in the API is given, followed by the value of the attribute in
the PSML file)

* (`SET_NONREL`, `non_relativistic`) for the non-relativistic, non-spin-DFT
case.

* (`SET_SREL`,`scalar_relativistic`) if the calculation is
scalar-relativistic, or if it is fully relativistic and an set of `lj`
potentials averaged over `j` is provided.

* (`SET_SO`, `spin_orbit`) if a
fully relativistic code provides this combination of `lj` potentials.

* (`SET_LJ`,`lj`) for a fully relativistic calculation with straight output
of the $lj$ channels.

* (`SET_UP`,`up`)  and (`SET_DOWN`,`down`), for a spin-DFT
calculation with straight output of the spin channels.

* (`SET_SPINAVE`,`spin_average`) for the spin-DFT case when the generation code
outputs a population-averaged pseudopotential.

* (`SET_SPINDIFF`,`spin_difference`) for the spin-DFT case when the generation code
outputs this (rare) combination.

Note that a given code might choose to output its semilocal-potential
information in two different forms (say, as scalar-relativistic and
spin-orbit combinations plus the `lj` form). The format allows this,
although in this particular case the information can easily be
converted from the `lj` form to the other by client programs.

For extensibility, the format allows two more values for the `set`
attribute, (`SET_USER1`,`user_extension1`) and (`SET_USER2`,
`user_extension2`), which can in principle be used to store custom
information while maintaining structural and operative compatibility
with the format.

The wildcard specification `SET_ALL` can be used to represent the
union of all possible sets.

title: Schema for PSML (V1.2)

```python
#
# Schema for PSML format
# RELAX-NG compact form. See: http://www.relaxng.org/compact-tutorial-20030326.htm
#
# This form can be processed by the jing/trang set of tools, available from
#   https://github.com/relaxng/jing-trang
#
# The 'jing' validator can work directly with this .rnc file (RELAX-NG compact form),
# and this is the preferred option.
#
# The 'trang' converter can be used to generate other schema forms, such as:
#
#     .rng (RELAX-NG xml form), .xsd (XML Schema)
#
# But note that some features of RELAX-NG cannot be completely represented by XML Schema
# schema files. In particular, in this file, the 'arbitrary attribute' idiom in the
# 'annotation' element is emulated.
#

default namespace = "http://esl.cecam.org/PSML/ns/1.2"

start = PSML

PSML =  element psml { 
            Root.Attributes         
          , Provenance+             # One or more provenance elements
          , PseudoAtomSpec          
          , Grid?                   # Optional top-level grid
          , ValenceCharge           
          , CoreCharge?             # Optional pseudo-core charge
          , ValenceKineticDensity?     # Optional valence-kinetic energy density for MGGA
          , CoreKineticDensity?        # Optional core-kinetic energy density for MGGA
		, (
		     (SemiLocalPotentials+ , PSOperator?)
		     |
		     (SemiLocalPotentials* , PSOperator )
		  )
          , PseudoWaveFunctions*          # Zero or more Pseudo Wavefunction groups
       }  

#
# Definitions of the above grammar symbols follow

#
Root.Attributes =  attribute energy_unit { "hartree" }
                 , attribute length_unit { "bohr" }
                 , attribute uuid { xsd:NMTOKEN }
                 , attribute version { xsd:decimal }

# =========
Provenance =  element provenance {
                attribute record-number { xsd:positiveInteger}?
              , attribute creator { xsd:string }
              , attribute date { xsd:string }
      
              , Annotation?
	      , InputFile*    # zero or more input files
              }
	      
InputFile =  element input-file {
               attribute name { xsd:NMTOKEN }, # No spaces or commas allowed
               text
             }

# =========
PseudoAtomSpec =  element pseudo-atom-spec {    PseudoAtomSpec.Attributes
                                              , Annotation?
                                              , ExchangeCorrelation
		                              , ValenceConfiguration
                                              , CoreConfiguration?
                                           }
# =========
PseudoAtomSpec.Attributes = 
       attribute atomic-label { xsd:NMTOKEN },
       attribute atomic-number { xsd:double },
       attribute z-pseudo { xsd:double },
       attribute core-corrections { "yes" | "no" },
       attribute meta-gga { "yes" | "no" }?,
       attribute relativity { "no" | "scalar" | "dirac" },
       attribute spin-dft { "yes" | "no" }?,
       attribute flavor { xsd:string }?

# =========
ExchangeCorrelation =  element exchange-correlation {
                         Annotation?
                         , element libxc-info {
                              attribute number-of-functionals { xsd:positiveInteger },
                              LibxcFunctional+
                           }
                        }

LibxcFunctional =   element functional {
                      attribute id { xsd:positiveInteger },
                      attribute name { xsd:string },
                      attribute weight { xsd:double }?,

                      # allow canonical names and libxc-style symbols
	      
                      attribute type { "exchange" | "correlation" | "exchange-correlation" |
	                               "XC_EXCHANGE" | "XC_CORRELATION" |
		  	                  "XC_EXCHANGE_CORRELATION" }?
                    }

# =========
ValenceConfiguration =  element valence-configuration {
                          attribute total-valence-charge { xsd:double },
	                  Annotation?,
                          ValenceShell+
                        }

ValenceShell =   Shell

Shell =  element shell {
           attribute_l,
           attribute_n,
           attribute occupation { xsd:double },
           attribute occupation-up { xsd:double }?,
           attribute occupation-down { xsd:double }?
         }

# =========
CoreConfiguration =  element core-configuration {
                       attribute total-core-charge { xsd:double },
	               Annotation?,
		       CoreShell+
                     }

CoreShell =   Shell

# =========
ValenceCharge =  element valence-charge {
                   attribute total-charge { xsd:double },
                   attribute is-unscreening-charge { "yes" | "no" }?,
                   attribute rescaled-to-z-pseudo { "yes" | "no" }?,
                   Annotation?,
                   Radfunc
                 }  
    
# =========
CoreCharge =  element pseudocore-charge {
                attribute matching-radius { xsd:double }?,
                attribute number-of-continuous-derivatives { xsd:nonNegativeInteger }?,
                Annotation?,
                Radfunc
              }

# =========
ValenceKineticDensity =  element valence-kinetic-energy-density {
                   attribute is-unscreening-tau { "yes" | "no" }?,
                   Annotation?,
                   Radfunc
                 }  
    
# =========
CoreKineticDensity =  element pseudocore-kinetic-energy-density {
                attribute matching-radius { xsd:double }?,
                attribute number-of-continuous-derivatives { xsd:nonNegativeInteger }?,
                Annotation?,
                Radfunc
              }

# =========
SemiLocalPotentials =  element semilocal-potentials {
                         attribute_set,
                         attribute flavor  { xsd:string }?,
                         Annotation?,
			 Grid?,
                         Potential+
                        }

Potential =   element slps {
                attribute flavor { xsd:string }?,
                attribute_l,
                attribute_j ?,
                attribute_n,
                attribute rc { xsd:double },
		attribute eref { xsd:double }?,
                Radfunc
              }   

# =========
PSOperator =   (   LocalPotential            # Local potential
                 , NonLocalProjectors* )     # Zero or more fully nonlocal groups


LocalPotential =  element local-potential {
                    attribute type { xsd:string },
                    Annotation?,
                    Grid?,
                    Radfunc,
		    LocalCharge?  # Optional local-charge element
                  }
    
LocalCharge =  element local-charge {
	         Radfunc
	       }

# =========
NonLocalProjectors =  element nonlocal-projectors {
                        attribute_set,
                        Annotation?,
                        Grid?,
	                Projector+
                      }

Projector =   element proj {
                attribute ekb { xsd:double },
                attribute eref { xsd:double }?, 
                attribute_l,
                attribute_j ?,
                attribute seq { xsd:positiveInteger },
                attribute type { xsd:string },
                Radfunc
              }+

# =========
PseudoWaveFunctions =  element pseudo-wave-functions {
                         attribute_set,
                         Annotation?,
                         Grid?,
                         PseudoWf+
                       }

PseudoWf =  element pswf {
       	      attribute_l,
              attribute_j ?,
              attribute_n,
              attribute energy_level { xsd:double} ?,
              Radfunc
            }

# =========
Grid =  element grid {
          attribute npts { xsd:positiveInteger },
          Annotation?,
          element grid-data {
                 list { xsd:double+ }   # One or more floating point numbers
          }
        }
  
# =========
Radfunc =  element radfunc {
             Grid?,              # Optional grid element
             element data {      
               attribute npts { xsd:positiveInteger }?,
               list { xsd:double+ }       # One or more floating point numbers
             }
           }

#
# This is the way to leave the annotations
# as collections of one or more arbitrary attributes
#
# This RELAX NG idiom cannot be directly translated to W3C schema (xsd form),
# but a similar result could be obtained with the <any> and <anyAttribute> xsd elements
#
any_attribute = attribute * { text }
Annotation =  element annotation { any_attribute+  }

#
# Convenience enumeration definitions
#
attribute_l = attribute l { "s" | "p" | "d" | "f" | "g" }
attribute_n = attribute n { "1" | "2" | "3" | "4" | "5" | "6" | "7" | "8" | "9" }
attribute_j = attribute j { "0.5" | "1.5" | "2.5" | "3.5" | "4.5" }

attribute_set = attribute set { "non_relativistic" |
                                "scalar_relativistic" | "spin_orbit" | "lj" |
				"up" | "down" | "spin_average" | "spin_difference" |
				"user_extension1" | "user_extension2" }
```

title: Databases of PSML files

The [Pseudo-Dojo](http://www.pseudo-dojo.org) project maintains a
database of pseudopotentials generated
with the oncvpsp code, and provides extensive information on their
performance on several tests. One of the formats supported is PSML.

More information about the project is available in a
[publication](https://doi.org/10.1016/j.cpc.2018.01.012) (also available
in [preprint form](https://arxiv.org/abs/1710.10138)).

title: Pseudopotential generators supporting PSML

###ONCVPSP

The first generator is the open-source
[ONCVPSP](http://www.mat-simresearch.com/) code implemented by
[D. Hamann](http://dx.doi.org/10.1103%2FPhysRevB.88.085117) to
generate optimized multiple-projector norm-conserving
pseudopotentials. The projectors are directly stored in the PSML
format together with a choice for the local potential. In addition, a
set of semi-local potentials, a by-product of the ONCVPSP algorithm,
is also included in the PSML file. Versions of ONCVPSP able to produce
PSML files are available in
[Gitlab](https://gitlab.com/garalb/oncvpsp-psml/-/releases). To ease the production
of XML, a special library (wxml, part of the [xmlf90
project](https://gitlab.com/siesta-project/libraries/xmlf90) maintained by one of the
authors (A.G.)) is used.

MGGA support is offered by a special version of ONCVPSP, called [METAPSP](http://www.mat-simresearch.com/),
being developed by D. Hamann.

###ATOM

The second generator enabled for PSML output is the ATOM code,
originally developed by S. Froyen, later modified by N. Troullier and
J. L. Martins, and currently maintained by one of us (A. G.)  within
the [SIESTA](http://www.icmab.es/siesta) project.  ATOM, freely
distributed to the academic community, generates norm-conserving
pseudopotentials in the semilocal form.

In addition, we have developed a post-processing tool (PSOP, currently
available in the main branch of SIESTA development) which takes as
input the semilocal components and computes the local part of the
pseudopotential and the KB projector functions in the same way as it
is done within the SIESTA code. These new elements, together with a
new provenance record, are incorporated in a new PSML file, which
describes a well-defined, client-code independent and unique operator.

We have thus already two different generators of PSML files, their
specific idiosyncrasies being describable by a common standard. Our
plans are to enable PSML output in other pseudopotential-generation
codes.

title: libPSML User Guide

We provide a companion library to the PSML format, libPSML, that
provides transparent parsing and data extraction from PSML files, as
well as basic editing and data conversion capabilities.

The library is built around a data structure of type [[ps_t(type)]]
that maps the information in a PSML file. Instances of this
structure are populated by PSML parsers, processed by
intermediate utility programs, and used as handles for information
retrieval by client codes through accessor routines. The library
provides, in essence:

*  A routine to parse a PSML file and produce a `ps`
  object of type [[ps_t(type)]].
*  A routine to dump the information in a `ps` object to a
  PSML file.
*  Accessor routines to extract information from `ps`
  objects.
*  Some setter routines to insert specific blocks of information
  into `ps` objects. These might be used by intermediate
  processors or by high-level parsers.

The library is written in modern Fortran and provides a
high-level Fortran interface. A C/C++ interface is in preparation.

The basic modus operandi is to parse a PSML file, storing the information
in an abstract handle [[ps_t(type)]], and then to query the handle to
extract the relevant data.

```fortran
use m_psml

type(psml_t) :: ps
call psml_reader("input.psml",ps,debug=.false.)
...
! Set up a grid of our own choosing
npts = 400; delta = 0.01  
allocate(r(npts))
do ir = 1, npts
   r(ir) = (ir-1)*delta
enddo

! Query existing potentials and get values
call ps_Potential_Filter(ps,set=SET_SREL,indexes=idx,number=npots)
do i = 1, npots
   call ps_Potential_Get(ps,idx(i),l=l,n=n,rc=rc)
   ...
   do ir = 1, npts
      val = ps_Potential_Value(ps,idx(i),r(ir))
      ...
   enddo
enddo
...
call ps_destroy(ps)
```

---
project: libPSML
summary: Library to handle Pseudopotential Markup Language files
author: Alberto Garcia
project_dir: ./src
             ./examples
page_dir: ./doc/pages
output_dir: /tmp/psml-docs
preprocessor: gfortran -E -P
preprocess: true
exclude: strings_helpers.f90
project_website: http://gitlab.com/siesta-project/libraries/libpsml
email: albertog@icmab.es
extensions: f90
            F90
docmark: +	    
predocmark: >
docmark_alt: *
predocmark_alt: <
source: true
graph: false
search: true
license: bsd
display: public
         private
	 protected
extra_filetypes: sh #
                 inc !
md_extensions: markdown.extensions.toc
---

The library provides an API for parsing PSML files and extracting
information from them.

For more information, and to begin exploring the PSML ecosystem,
check out the [Overview](./page/index.html).
  
